"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtCore, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore

bytes = str


class QEvent(object):
    """
    https://doc.qt.io/qt-5/qevent.html

    **Detailed Description**

    Qt's main event loop (**QCoreApplication::exec** ()) fetches native window
    system events from the event queue, translates them into QEvents, and sends
    the translated events to **QObject** s.

    In general, events come from the underlying window system (**spontaneous**
    () returns `true`), but it is also possible to manually send events using
    **QCoreApplication::sendEvent** () and **QCoreApplication::postEvent** ()
    (**spontaneous** () returns `false`).

    **QObjects**  receive events by having their **QObject::event** () function
    called. The function can be reimplemented in subclasses to customize event
    handling and add additional event types; **QWidget::event** () is a notable
    example. By default, events are dispatched to event handlers like
    **QObject::timerEvent** () and **QWidget::mouseMoveEvent** ().
    **QObject::installEventFilter** () allows an object to intercept events
    destined for another object.

    The basic QEvent contains only an event type parameter and an "accept" flag.
    The accept flag set with **accept** (), and cleared with **ignore** (). It
    is set by default, but don't rely on this as subclasses may choose to clear
    it in their constructor.

    Subclasses of QEvent contain additional parameters that describe the
    particular event.

    **See also** **QObject::event** (), **QObject::installEventFilter** (),
    **QCoreApplication::sendEvent** (), **QCoreApplication::postEvent** (), and
    **QCoreApplication::processEvents** ().
    """

    None_: QEvent = ...
    Timer: QEvent = ...
    MouseButtonPress: QEvent = ...
    MouseButtonRelease: QEvent = ...
    MouseButtonDblClick: QEvent = ...
    MouseMove: QEvent = ...
    KeyPress: QEvent = ...
    KeyRelease: QEvent = ...
    FocusIn: QEvent = ...
    FocusOut: QEvent = ...
    Enter: QEvent = ...
    Leave: QEvent = ...
    Paint: QEvent = ...
    Move: QEvent = ...
    Resize: QEvent = ...
    Create: QEvent = ...
    Destroy: QEvent = ...
    Show: QEvent = ...
    Hide: QEvent = ...
    Close: QEvent = ...
    Quit: QEvent = ...
    ParentChange: QEvent = ...
    ThreadChange: QEvent = ...
    FocusAboutToChange: QEvent = ...
    WindowActivate: QEvent = ...
    WindowDeactivate: QEvent = ...
    ShowToParent: QEvent = ...
    HideToParent: QEvent = ...
    Wheel: QEvent = ...
    WindowTitleChange: QEvent = ...
    WindowIconChange: QEvent = ...
    ApplicationWindowIconChange: QEvent = ...
    ApplicationFontChange: QEvent = ...
    ApplicationLayoutDirectionChange: QEvent = ...
    ApplicationPaletteChange: QEvent = ...
    PaletteChange: QEvent = ...
    Clipboard: QEvent = ...
    Speech: QEvent = ...
    MetaCall: QEvent = ...
    SockAct: QEvent = ...
    ShortcutOverride: QEvent = ...
    DeferredDelete: QEvent = ...
    DragEnter: QEvent = ...
    DragMove: QEvent = ...
    DragLeave: QEvent = ...
    Drop: QEvent = ...
    DragResponse: QEvent = ...
    ChildAdded: QEvent = ...
    ChildPolished: QEvent = ...
    ChildRemoved: QEvent = ...
    ShowWindowRequest: QEvent = ...
    PolishRequest: QEvent = ...
    Polish: QEvent = ...
    LayoutRequest: QEvent = ...
    UpdateRequest: QEvent = ...
    UpdateLater: QEvent = ...
    EmbeddingControl: QEvent = ...
    ActivateControl: QEvent = ...
    DeactivateControl: QEvent = ...
    ContextMenu: QEvent = ...
    InputMethod: QEvent = ...
    TabletMove: QEvent = ...
    LocaleChange: QEvent = ...
    LanguageChange: QEvent = ...
    LayoutDirectionChange: QEvent = ...
    Style: QEvent = ...
    TabletPress: QEvent = ...
    TabletRelease: QEvent = ...
    OkRequest: QEvent = ...
    HelpRequest: QEvent = ...
    IconDrag: QEvent = ...
    FontChange: QEvent = ...
    EnabledChange: QEvent = ...
    ActivationChange: QEvent = ...
    StyleChange: QEvent = ...
    IconTextChange: QEvent = ...
    ModifiedChange: QEvent = ...
    WindowBlocked: QEvent = ...
    WindowUnblocked: QEvent = ...
    WindowStateChange: QEvent = ...
    ReadOnlyChange: QEvent = ...
    MouseTrackingChange: QEvent = ...
    ToolTip: QEvent = ...
    WhatsThis: QEvent = ...
    StatusTip: QEvent = ...
    ActionChanged: QEvent = ...
    ActionAdded: QEvent = ...
    ActionRemoved: QEvent = ...
    FileOpen: QEvent = ...
    Shortcut: QEvent = ...
    WhatsThisClicked: QEvent = ...
    ToolBarChange: QEvent = ...
    ApplicationActivate: QEvent = ...
    ApplicationActivated: QEvent = ...
    ApplicationDeactivate: QEvent = ...
    ApplicationDeactivated: QEvent = ...
    QueryWhatsThis: QEvent = ...
    EnterWhatsThisMode: QEvent = ...
    LeaveWhatsThisMode: QEvent = ...
    ZOrderChange: QEvent = ...
    HoverEnter: QEvent = ...
    HoverLeave: QEvent = ...
    HoverMove: QEvent = ...
    ParentAboutToChange: QEvent = ...
    WinEventAct: QEvent = ...
    AcceptDropsChange: QEvent = ...
    ZeroTimerEvent: QEvent = ...
    GraphicsSceneMouseMove: QEvent = ...
    GraphicsSceneMousePress: QEvent = ...
    GraphicsSceneMouseRelease: QEvent = ...
    GraphicsSceneMouseDoubleClick: QEvent = ...
    GraphicsSceneContextMenu: QEvent = ...
    GraphicsSceneHoverEnter: QEvent = ...
    GraphicsSceneHoverMove: QEvent = ...
    GraphicsSceneHoverLeave: QEvent = ...
    GraphicsSceneHelp: QEvent = ...
    GraphicsSceneDragEnter: QEvent = ...
    GraphicsSceneDragMove: QEvent = ...
    GraphicsSceneDragLeave: QEvent = ...
    GraphicsSceneDrop: QEvent = ...
    GraphicsSceneWheel: QEvent = ...
    KeyboardLayoutChange: QEvent = ...
    DynamicPropertyChange: QEvent = ...
    TabletEnterProximity: QEvent = ...
    TabletLeaveProximity: QEvent = ...
    NonClientAreaMouseMove: QEvent = ...
    NonClientAreaMouseButtonPress: QEvent = ...
    NonClientAreaMouseButtonRelease: QEvent = ...
    NonClientAreaMouseButtonDblClick: QEvent = ...
    MacSizeChange: QEvent = ...
    ContentsRectChange: QEvent = ...
    MacGLWindowChange: QEvent = ...
    FutureCallOut: QEvent = ...
    GraphicsSceneResize: QEvent = ...
    GraphicsSceneMove: QEvent = ...
    CursorChange: QEvent = ...
    ToolTipChange: QEvent = ...
    NetworkReplyUpdated: QEvent = ...
    GrabMouse: QEvent = ...
    UngrabMouse: QEvent = ...
    GrabKeyboard: QEvent = ...
    UngrabKeyboard: QEvent = ...
    MacGLClearDrawable: QEvent = ...
    StateMachineSignal: QEvent = ...
    StateMachineWrapped: QEvent = ...
    TouchBegin: QEvent = ...
    TouchUpdate: QEvent = ...
    TouchEnd: QEvent = ...
    NativeGesture: QEvent = ...
    Gesture: QEvent = ...
    RequestSoftwareInputPanel: QEvent = ...
    CloseSoftwareInputPanel: QEvent = ...
    GestureOverride: QEvent = ...
    WinIdChange: QEvent = ...
    ScrollPrepare: QEvent = ...
    Scroll: QEvent = ...
    Expose: QEvent = ...
    InputMethodQuery: QEvent = ...
    OrientationChange: QEvent = ...
    TouchCancel: QEvent = ...
    ThemeChange: QEvent = ...
    SockClose: QEvent = ...
    PlatformPanel: QEvent = ...
    StyleAnimationUpdate: QEvent = ...
    ApplicationStateChange: QEvent = ...
    WindowChangeInternal: QEvent = ...
    ScreenChangeInternal: QEvent = ...
    PlatformSurface: QEvent = ...
    Pointer: QEvent = ...
    TabletTrackingChange: QEvent = ...
    User: QEvent = ...
    MaxUser: QEvent = ...

    class Type(object):
        None_: QEvent.Type = ...
        Timer: QEvent.Type = ...
        MouseButtonPress: QEvent.Type = ...
        MouseButtonRelease: QEvent.Type = ...
        MouseButtonDblClick: QEvent.Type = ...
        MouseMove: QEvent.Type = ...
        KeyPress: QEvent.Type = ...
        KeyRelease: QEvent.Type = ...
        FocusIn: QEvent.Type = ...
        FocusOut: QEvent.Type = ...
        Enter: QEvent.Type = ...
        Leave: QEvent.Type = ...
        Paint: QEvent.Type = ...
        Move: QEvent.Type = ...
        Resize: QEvent.Type = ...
        Create: QEvent.Type = ...
        Destroy: QEvent.Type = ...
        Show: QEvent.Type = ...
        Hide: QEvent.Type = ...
        Close: QEvent.Type = ...
        Quit: QEvent.Type = ...
        ParentChange: QEvent.Type = ...
        ThreadChange: QEvent.Type = ...
        FocusAboutToChange: QEvent.Type = ...
        WindowActivate: QEvent.Type = ...
        WindowDeactivate: QEvent.Type = ...
        ShowToParent: QEvent.Type = ...
        HideToParent: QEvent.Type = ...
        Wheel: QEvent.Type = ...
        WindowTitleChange: QEvent.Type = ...
        WindowIconChange: QEvent.Type = ...
        ApplicationWindowIconChange: QEvent.Type = ...
        ApplicationFontChange: QEvent.Type = ...
        ApplicationLayoutDirectionChange: QEvent.Type = ...
        ApplicationPaletteChange: QEvent.Type = ...
        PaletteChange: QEvent.Type = ...
        Clipboard: QEvent.Type = ...
        Speech: QEvent.Type = ...
        MetaCall: QEvent.Type = ...
        SockAct: QEvent.Type = ...
        ShortcutOverride: QEvent.Type = ...
        DeferredDelete: QEvent.Type = ...
        DragEnter: QEvent.Type = ...
        DragMove: QEvent.Type = ...
        DragLeave: QEvent.Type = ...
        Drop: QEvent.Type = ...
        DragResponse: QEvent.Type = ...
        ChildAdded: QEvent.Type = ...
        ChildPolished: QEvent.Type = ...
        ChildRemoved: QEvent.Type = ...
        ShowWindowRequest: QEvent.Type = ...
        PolishRequest: QEvent.Type = ...
        Polish: QEvent.Type = ...
        LayoutRequest: QEvent.Type = ...
        UpdateRequest: QEvent.Type = ...
        UpdateLater: QEvent.Type = ...
        EmbeddingControl: QEvent.Type = ...
        ActivateControl: QEvent.Type = ...
        DeactivateControl: QEvent.Type = ...
        ContextMenu: QEvent.Type = ...
        InputMethod: QEvent.Type = ...
        TabletMove: QEvent.Type = ...
        LocaleChange: QEvent.Type = ...
        LanguageChange: QEvent.Type = ...
        LayoutDirectionChange: QEvent.Type = ...
        Style: QEvent.Type = ...
        TabletPress: QEvent.Type = ...
        TabletRelease: QEvent.Type = ...
        OkRequest: QEvent.Type = ...
        HelpRequest: QEvent.Type = ...
        IconDrag: QEvent.Type = ...
        FontChange: QEvent.Type = ...
        EnabledChange: QEvent.Type = ...
        ActivationChange: QEvent.Type = ...
        StyleChange: QEvent.Type = ...
        IconTextChange: QEvent.Type = ...
        ModifiedChange: QEvent.Type = ...
        WindowBlocked: QEvent.Type = ...
        WindowUnblocked: QEvent.Type = ...
        WindowStateChange: QEvent.Type = ...
        ReadOnlyChange: QEvent.Type = ...
        MouseTrackingChange: QEvent.Type = ...
        ToolTip: QEvent.Type = ...
        WhatsThis: QEvent.Type = ...
        StatusTip: QEvent.Type = ...
        ActionChanged: QEvent.Type = ...
        ActionAdded: QEvent.Type = ...
        ActionRemoved: QEvent.Type = ...
        FileOpen: QEvent.Type = ...
        Shortcut: QEvent.Type = ...
        WhatsThisClicked: QEvent.Type = ...
        ToolBarChange: QEvent.Type = ...
        ApplicationActivate: QEvent.Type = ...
        ApplicationActivated: QEvent.Type = ...
        ApplicationDeactivate: QEvent.Type = ...
        ApplicationDeactivated: QEvent.Type = ...
        QueryWhatsThis: QEvent.Type = ...
        EnterWhatsThisMode: QEvent.Type = ...
        LeaveWhatsThisMode: QEvent.Type = ...
        ZOrderChange: QEvent.Type = ...
        HoverEnter: QEvent.Type = ...
        HoverLeave: QEvent.Type = ...
        HoverMove: QEvent.Type = ...
        ParentAboutToChange: QEvent.Type = ...
        WinEventAct: QEvent.Type = ...
        AcceptDropsChange: QEvent.Type = ...
        ZeroTimerEvent: QEvent.Type = ...
        GraphicsSceneMouseMove: QEvent.Type = ...
        GraphicsSceneMousePress: QEvent.Type = ...
        GraphicsSceneMouseRelease: QEvent.Type = ...
        GraphicsSceneMouseDoubleClick: QEvent.Type = ...
        GraphicsSceneContextMenu: QEvent.Type = ...
        GraphicsSceneHoverEnter: QEvent.Type = ...
        GraphicsSceneHoverMove: QEvent.Type = ...
        GraphicsSceneHoverLeave: QEvent.Type = ...
        GraphicsSceneHelp: QEvent.Type = ...
        GraphicsSceneDragEnter: QEvent.Type = ...
        GraphicsSceneDragMove: QEvent.Type = ...
        GraphicsSceneDragLeave: QEvent.Type = ...
        GraphicsSceneDrop: QEvent.Type = ...
        GraphicsSceneWheel: QEvent.Type = ...
        KeyboardLayoutChange: QEvent.Type = ...
        DynamicPropertyChange: QEvent.Type = ...
        TabletEnterProximity: QEvent.Type = ...
        TabletLeaveProximity: QEvent.Type = ...
        NonClientAreaMouseMove: QEvent.Type = ...
        NonClientAreaMouseButtonPress: QEvent.Type = ...
        NonClientAreaMouseButtonRelease: QEvent.Type = ...
        NonClientAreaMouseButtonDblClick: QEvent.Type = ...
        MacSizeChange: QEvent.Type = ...
        ContentsRectChange: QEvent.Type = ...
        MacGLWindowChange: QEvent.Type = ...
        FutureCallOut: QEvent.Type = ...
        GraphicsSceneResize: QEvent.Type = ...
        GraphicsSceneMove: QEvent.Type = ...
        CursorChange: QEvent.Type = ...
        ToolTipChange: QEvent.Type = ...
        NetworkReplyUpdated: QEvent.Type = ...
        GrabMouse: QEvent.Type = ...
        UngrabMouse: QEvent.Type = ...
        GrabKeyboard: QEvent.Type = ...
        UngrabKeyboard: QEvent.Type = ...
        MacGLClearDrawable: QEvent.Type = ...
        StateMachineSignal: QEvent.Type = ...
        StateMachineWrapped: QEvent.Type = ...
        TouchBegin: QEvent.Type = ...
        TouchUpdate: QEvent.Type = ...
        TouchEnd: QEvent.Type = ...
        NativeGesture: QEvent.Type = ...
        Gesture: QEvent.Type = ...
        RequestSoftwareInputPanel: QEvent.Type = ...
        CloseSoftwareInputPanel: QEvent.Type = ...
        GestureOverride: QEvent.Type = ...
        WinIdChange: QEvent.Type = ...
        ScrollPrepare: QEvent.Type = ...
        Scroll: QEvent.Type = ...
        Expose: QEvent.Type = ...
        InputMethodQuery: QEvent.Type = ...
        OrientationChange: QEvent.Type = ...
        TouchCancel: QEvent.Type = ...
        ThemeChange: QEvent.Type = ...
        SockClose: QEvent.Type = ...
        PlatformPanel: QEvent.Type = ...
        StyleAnimationUpdate: QEvent.Type = ...
        ApplicationStateChange: QEvent.Type = ...
        WindowChangeInternal: QEvent.Type = ...
        ScreenChangeInternal: QEvent.Type = ...
        PlatformSurface: QEvent.Type = ...
        Pointer: QEvent.Type = ...
        TabletTrackingChange: QEvent.Type = ...
        User: QEvent.Type = ...
        MaxUser: QEvent.Type = ...

    @typing.overload
    def __init__(self, other: PySide2.QtCore.QEvent) -> None:
        """
        https://doc.qt.io/qt-5/qevent.html#QEvent

        **QEvent::QEvent(QEvent::Type type )**

        Contructs an event object of type **type**.
        """
        ...

    @typing.overload
    def __init__(self, type: PySide2.QtCore.QEvent.Type) -> None:
        """
        https://doc.qt.io/qt-5/qevent.html#QEvent

        **QEvent::QEvent(QEvent::Type type )**

        Contructs an event object of type **type**.
        """
        ...

    def accept(self) -> None:
        """
        https://doc.qt.io/qt-5/qevent.html#accept

        **void QEvent::accept()**

        Sets the accept flag of the event object, the equivalent of calling
        **setAccepted** (true).

        Setting the accept parameter indicates that the event receiver wants the
        event. Unwanted events might be propagated to the parent widget.

        **See also** **ignore** ().
        """
        ...

    def ignore(self) -> None:
        """
        https://doc.qt.io/qt-5/qevent.html#ignore

        **void QEvent::ignore()**

        Clears the accept flag parameter of the event object, the equivalent of
        calling **setAccepted** (false).

        Clearing the accept parameter indicates that the event receiver does not
        want the event. Unwanted events might be propagated to the parent
        widget.

        **See also** **accept** ().
        """
        ...

    def isAccepted(self) -> bool:
        ...

    @staticmethod
    def registerEventType(hint: int = ...) -> int:
        """
        https://doc.qt.io/qt-5/qevent.html#registerEventType

        **[static] int QEvent::registerEventType(int hint = -1)**

        Registers and returns a custom event type. The **hint** provided will be
        used if it is available, otherwise it will return a value between
        **QEvent::User**  and **QEvent::MaxUser**  that has not yet been
        registered. The **hint** is ignored if its value is not between
        **QEvent::User**  and **QEvent::MaxUser** .

        Returns -1 if all available values are already taken or the program is
        shutting down.

        **Note:** This function is **thread-safe** .

        This function was introduced in Qt 4.4.
        """
        ...

    def setAccepted(self, accepted: bool) -> None:
        """
        https://doc.qt.io/qt-5/qevent.html#accepted-prop

        **accepted : bool**

        the accept flag of the event object

        Setting the accept parameter indicates that the event receiver wants the
        event. Unwanted events might be propagated to the parent widget. By
        default, isAccepted() is set to true, but don't rely on this as
        subclasses may choose to clear it in their constructor.

        For convenience, the accept flag can also be set with **accept** (), and
        cleared with **ignore** ().

        **Access functions:**

        bool **isAccepted** () const
        void **setAccepted** (bool **accepted** )

        **Member Function Documentation**
        """
        ...

    def spontaneous(self) -> bool:
        """
        https://doc.qt.io/qt-5/qevent.html#spontaneous

        **bool QEvent::spontaneous() const**

        Returns `true` if the event originated outside the application (a system
        event); otherwise returns `false`.

        The return value of this function is not defined for paint events.
        """
        ...

    def type(self) -> PySide2.QtCore.QEvent.Type:
        """
        https://doc.qt.io/qt-5/qevent.html#type

        **QEvent::Type QEvent::type() const**

        Returns the event type.
        """
        ...
