"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtCore, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore

bytes = str


class QLibraryInfo(object):
    """
    https://doc.qt.io/qt-5/qlibraryinfo.html

    **Detailed Description**

    Many pieces of information are established when Qt is configured and built.
    This class provides an abstraction for accessing that information. By using
    the static functions of this class, an application can obtain information
    about the instance of the Qt library which the application is using at run-
    time.

    You can also use a `qt.conf` file to override the hard-coded paths that are
    compiled into the Qt library. For more information, see the **Using
    qt.conf**  documentation.

    **See also** **QSysInfo**  and **Using qt.conf** .
    """

    PrefixPath: QLibraryInfo = ...
    DocumentationPath: QLibraryInfo = ...
    HeadersPath: QLibraryInfo = ...
    LibrariesPath: QLibraryInfo = ...
    LibraryExecutablesPath: QLibraryInfo = ...
    BinariesPath: QLibraryInfo = ...
    PluginsPath: QLibraryInfo = ...
    ImportsPath: QLibraryInfo = ...
    Qml2ImportsPath: QLibraryInfo = ...
    ArchDataPath: QLibraryInfo = ...
    DataPath: QLibraryInfo = ...
    TranslationsPath: QLibraryInfo = ...
    ExamplesPath: QLibraryInfo = ...
    TestsPath: QLibraryInfo = ...
    SettingsPath: QLibraryInfo = ...

    class LibraryLocation(object):
        PrefixPath: QLibraryInfo.LibraryLocation = ...
        DocumentationPath: QLibraryInfo.LibraryLocation = ...
        HeadersPath: QLibraryInfo.LibraryLocation = ...
        LibrariesPath: QLibraryInfo.LibraryLocation = ...
        LibraryExecutablesPath: QLibraryInfo.LibraryLocation = ...
        BinariesPath: QLibraryInfo.LibraryLocation = ...
        PluginsPath: QLibraryInfo.LibraryLocation = ...
        ImportsPath: QLibraryInfo.LibraryLocation = ...
        Qml2ImportsPath: QLibraryInfo.LibraryLocation = ...
        ArchDataPath: QLibraryInfo.LibraryLocation = ...
        DataPath: QLibraryInfo.LibraryLocation = ...
        TranslationsPath: QLibraryInfo.LibraryLocation = ...
        ExamplesPath: QLibraryInfo.LibraryLocation = ...
        TestsPath: QLibraryInfo.LibraryLocation = ...
        SettingsPath: QLibraryInfo.LibraryLocation = ...

    @staticmethod
    def build() -> bytes:
        ...

    @staticmethod
    def buildDate() -> PySide2.QtCore.QDate:
        ...

    @staticmethod
    def isDebugBuild() -> bool:
        """
        https://doc.qt.io/qt-5/qlibraryinfo.html#isDebugBuild

        **[static] bool QLibraryInfo::isDebugBuild()**

        Returns `true` if this build of Qt was built with debugging enabled, or
        false if it was built in release mode.

        This function was introduced in Qt 5.0.
        """
        ...

    @staticmethod
    def licensedProducts() -> str:
        ...

    @staticmethod
    def licensee() -> str:
        ...

    @staticmethod
    def location(arg__1: PySide2.QtCore.QLibraryInfo.LibraryLocation) -> str:
        """
        https://doc.qt.io/qt-5/qlibraryinfo.html#location

        **[static] QString QLibraryInfo::location(QLibraryInfo::LibraryLocation
        loc )**

        Returns the location specified by **loc**.
        """
        ...

    @staticmethod
    def platformPluginArguments(platformName: str) -> typing.List:
        ...

    @staticmethod
    def version() -> PySide2.QtCore.QVersionNumber:
        """
        https://doc.qt.io/qt-5/qlibraryinfo.html#version

        **[static] QVersionNumber QLibraryInfo::version()**

        Returns the version of the Qt library.

        This function was introduced in Qt 5.8.

        **See also** **qVersion** ().
        """
        ...
