"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtGui, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui

bytes = str


class QAccessibleTextCursorEvent(PySide2.QtGui.QAccessibleEvent):
    """
    https://doc.qt.io/qt-5/qaccessibletextcursorevent.html

    **Detailed Description**

    This class is used with **QAccessible::updateAccessibility** ().
    """

    @typing.overload
    def __init__(
        self, iface: PySide2.QtGui.QAccessibleInterface, cursorPos: int
    ) -> None:
        """
        https://doc.qt.io/qt-5/qaccessibletextcursorevent.html#QAccessibleTextCu
        rsorEvent

        **QAccessibleTextCursorEvent::QAccessibleTextCursorEvent(QObject *
        object , int cursorPos )**

        Create a new QAccessibleTextCursorEvent for **object**. The
        **cursorPos** is the new cursor position.
        """
        ...

    @typing.overload
    def __init__(self, obj: PySide2.QtCore.QObject, cursorPos: int) -> None:
        """
        https://doc.qt.io/qt-5/qaccessibletextcursorevent.html#QAccessibleTextCu
        rsorEvent-1

        **QAccessibleTextCursorEvent::QAccessibleTextCursorEvent(QAccessibleInte
        rface * iface , int cursorPos )**

        Create a new QAccessibleTextCursorEvent for **iface** , The
        **cursorPos** is the new cursor position.
        """
        ...

    def cursorPosition(self) -> int:
        """
        https://doc.qt.io/qt-5/qaccessibletextcursorevent.html#cursorPosition

        **int QAccessibleTextCursorEvent::cursorPosition() const**

        Returns the cursor position.

        **See also** **setCursorPosition** ().
        """
        ...

    def setCursorPosition(self, position: int) -> None:
        """
        https://doc.qt.io/qt-5/qaccessibletextcursorevent.html#setCursorPosition

        **void QAccessibleTextCursorEvent::setCursorPosition(int position )**

        Sets the cursor **position** for this event.

        **See also** **cursorPosition** ().
        """
        ...
