"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtGui, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui

bytes = str


class QAccessibleTextRemoveEvent(PySide2.QtGui.QAccessibleTextCursorEvent):
    """
    https://doc.qt.io/qt-5/qaccessibletextremoveevent.html

    **Detailed Description**

    This class is used with **QAccessible::updateAccessibility** ().
    """

    @typing.overload
    def __init__(
        self, iface: PySide2.QtGui.QAccessibleInterface, position: int, text: str
    ) -> None:
        """
        https://doc.qt.io/qt-5/qaccessibletextremoveevent.html#QAccessibleTextRe
        moveEvent

        **QAccessibleTextRemoveEvent::QAccessibleTextRemoveEvent(QObject *
        object , int position , const QString & text )**

        Constructs a new QAccessibleTextRemoveEvent event for **object**. The
        **text** has been removed at **position**. By default it is assumed that
        the cursor has moved to **position**. If that is not the case, one needs
        to manually set it with
        **QAccessibleTextCursorEvent::setCursorPosition** () for this event.
        """
        ...

    @typing.overload
    def __init__(self, obj: PySide2.QtCore.QObject, position: int, text: str) -> None:
        """
        https://doc.qt.io/qt-5/qaccessibletextremoveevent.html#QAccessibleTextRe
        moveEvent-1

        **QAccessibleTextRemoveEvent::QAccessibleTextRemoveEvent(QAccessibleInte
        rface * iface , int position , const QString & text )**

        Constructs a new QAccessibleTextRemoveEvent event for **iface**. The
        **text** has been removed at **position**. By default it is assumed that
        the cursor has moved to **position**. If that is not the case, one needs
        to manually set it with
        **QAccessibleTextCursorEvent::setCursorPosition** () for this event.
        """
        ...

    def changePosition(self) -> int:
        """
        https://doc.qt.io/qt-5/qaccessibletextremoveevent.html#changePosition

        **int QAccessibleTextRemoveEvent::changePosition() const**

        Returns the position where the text was removed.
        """
        ...

    def textRemoved(self) -> str:
        """
        https://doc.qt.io/qt-5/qaccessibletextremoveevent.html#textRemoved

        **QString QAccessibleTextRemoveEvent::textRemoved() const**

        Returns the text that has been removed.
        """
        ...
