"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtGui, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui

bytes = str


class QAccessibleValueChangeEvent(PySide2.QtGui.QAccessibleEvent):
    """
    https://doc.qt.io/qt-5/qaccessiblevaluechangeevent.html

    **Detailed Description**

    It contains the new value.

    This class is used with **QAccessible::updateAccessibility** ().
    """

    @typing.overload
    def __init__(
        self, iface: PySide2.QtGui.QAccessibleInterface, val: typing.Any
    ) -> None:
        """
        https://doc.qt.io/qt-5/qaccessiblevaluechangeevent.html#QAccessibleValue
        ChangeEvent

        **QAccessibleValueChangeEvent::QAccessibleValueChangeEvent(QObject *
        object , const QVariant & value )**

        Constructs a new QAccessibleValueChangeEvent for **object**. The event
        contains the new **value**.
        """
        ...

    @typing.overload
    def __init__(self, obj: PySide2.QtCore.QObject, val: typing.Any) -> None:
        """
        https://doc.qt.io/qt-5/qaccessiblevaluechangeevent.html#QAccessibleValue
        ChangeEvent-1

        **QAccessibleValueChangeEvent::QAccessibleValueChangeEvent(QAccessibleIn
        terface * iface , const QVariant & val )**

        Constructs a new QAccessibleValueChangeEvent for **iface**. The event
        contains the new value **val**.
        """
        ...

    def setValue(self, val: typing.Any) -> None:
        """
        https://doc.qt.io/qt-5/qaccessiblevaluechangeevent.html#setValue

        **void QAccessibleValueChangeEvent::setValue(const QVariant & value )**

        Sets the new **value** for this event.

        **See also** **value** ().
        """
        ...

    def value(self) -> typing.Any:
        """
        https://doc.qt.io/qt-5/qaccessiblevaluechangeevent.html#value

        **QVariant QAccessibleValueChangeEvent::value() const**

        Returns the new value of the accessible object of this event.

        **See also** **setValue** ().
        """
        ...
