"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtGui, except for defaults which are replaced by "...".
"""
import PySide2
import PySide2.QtCore
import PySide2.QtGui

bytes = str


class QDragEnterEvent(PySide2.QtGui.QDragMoveEvent):
    """
    https://doc.qt.io/qt-5/qdragenterevent.html

    **Detailed Description**

    A widget must accept this event in order to receive the **drag move events**
    that are sent while the drag and drop action is in progress. The drag enter
    event is always immediately followed by a drag move event.

    QDragEnterEvent inherits most of its functionality from **QDragMoveEvent** ,
    which in turn inherits most of its functionality from **QDropEvent** .

    **See also** **QDragLeaveEvent** , **QDragMoveEvent** , and **QDropEvent** .
    """

    def __init__(
        self,
        pos: PySide2.QtCore.QPoint,
        actions: PySide2.QtCore.Qt.DropActions,
        data: PySide2.QtCore.QMimeData,
        buttons: PySide2.QtCore.Qt.MouseButtons,
        modifiers: PySide2.QtCore.Qt.KeyboardModifiers,
    ) -> None:
        """
        https://doc.qt.io/qt-5/qdragenterevent.html#QDragEnterEvent

        **QDragEnterEvent::QDragEnterEvent(const QPoint & point ,
        Qt::DropActions actions , const QMimeData * data , Qt::MouseButtons
        buttons , Qt::KeyboardModifiers modifiers )**

        Constructs a QDragEnterEvent that represents a drag entering a widget at
        the given **point** with mouse and keyboard states specified by
        **buttons** and **modifiers**.

        The drag data is passed as MIME-encoded information in **data** , and
        the specified **actions** describe the possible types of drag and drop
        operation that can be performed.

        **Warning:** Do not create a QDragEnterEvent yourself since these
        objects rely on Qt's internal state.
        """
        ...
