"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtGui, except for defaults which are replaced by "...".
"""
import PySide2
import PySide2.QtCore
import PySide2.QtGui

bytes = str


class QExposeEvent(PySide2.QtCore.QEvent):
    """
    https://doc.qt.io/qt-5/qexposeevent.html

    **Detailed Description**

    Expose events are sent to windows when an area of the window is invalidated,
    for example when window exposure in the windowing system changes.

    A Window with a client area that is completely covered by another window, or
    is otherwise not visible may be considered obscured by Qt and may in such
    cases not receive expose events.

    The event handler **QWindow::exposeEvent** () receives expose events.
    """

    def __init__(self, rgn: PySide2.QtGui.QRegion) -> None:
        """
        https://doc.qt.io/qt-5/qexposeevent.html#QExposeEvent

        **QExposeEvent::QExposeEvent(const QRegion & exposeRegion )**

        Constructs an expose event for the given **exposeRegion** which must be
        in local coordinates.
        """
        ...

    def region(self) -> PySide2.QtGui.QRegion:
        """
        https://doc.qt.io/qt-5/qexposeevent.html#region

        **const QRegion &QExposeEvent::region() const**

        Returns the window area that has been exposed. The region is given in
        local coordinates.
        """
        ...
