"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtGui, except for defaults which are replaced by "...".
"""
import PySide2
import PySide2.QtCore
import PySide2.QtGui

bytes = str


class QFocusEvent(PySide2.QtCore.QEvent):
    """
    https://doc.qt.io/qt-5/qfocusevent.html

    **Detailed Description**

    Focus events are sent to widgets when the keyboard input focus changes.
    Focus events occur due to mouse actions, key presses (such as **Tab** or
    **Backtab** ), the window system, popup menus, keyboard shortcuts, or other
    application-specific reasons. The reason for a particular focus event is
    returned by **reason** () in the appropriate event handler.

    The event handlers **QWidget::focusInEvent** (), **QWidget::focusOutEvent**
    (), **QGraphicsItem::focusInEvent**  and **QGraphicsItem::focusOutEvent** ()
    receive focus events.

    **See also** **QWidget::setFocus** (), **QWidget::setFocusPolicy** (), and
    **Keyboard Focus in Widgets** .
    """

    def __init__(
        self,
        type: PySide2.QtCore.QEvent.Type,
        reason: PySide2.QtCore.Qt.FocusReason = ...,
    ) -> None:
        """
        https://doc.qt.io/qt-5/qfocusevent.html#QFocusEvent

        **QFocusEvent::QFocusEvent(QEvent::Type type , Qt::FocusReason reason =
        Qt::OtherFocusReason)**

        Constructs a focus event object.

        The **type** parameter must be either **QEvent::FocusIn**  or
        **QEvent::FocusOut** . The **reason** describes the cause of the change
        in focus.
        """
        ...

    def gotFocus(self) -> bool:
        """
        https://doc.qt.io/qt-5/qfocusevent.html#gotFocus

        **bool QFocusEvent::gotFocus() const**

        Returns `true` if **type** () is **QEvent::FocusIn** ; otherwise returns
        false.
        """
        ...

    def lostFocus(self) -> bool:
        """
        https://doc.qt.io/qt-5/qfocusevent.html#lostFocus

        **bool QFocusEvent::lostFocus() const**

        Returns `true` if **type** () is **QEvent::FocusOut** ; otherwise
        returns false.
        """
        ...

    def reason(self) -> PySide2.QtCore.Qt.FocusReason:
        """
        https://doc.qt.io/qt-5/qfocusevent.html#reason

        **Qt::FocusReason QFocusEvent::reason() const**

        Returns the reason for this focus event.
        """
        ...
