"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtGui, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui

bytes = str


class QInputMethodQueryEvent(PySide2.QtCore.QEvent):
    """
    https://doc.qt.io/qt-5/qinputmethodqueryevent.html

    **Detailed Description**

    It is used by the input method to query a set of properties of the object to
    be able to support complex input method operations as support for
    surrounding text and reconversions.

    **queries** () specifies which properties are queried.

    The object should call **setValue** () on the event to fill in the requested
    data before calling **accept** ().
    """

    def __init__(self, queries: PySide2.QtCore.Qt.InputMethodQueries) -> None:
        """
        https://doc.qt.io/qt-5/qinputmethodqueryevent.html#QInputMethodQueryEven
        t

        **QInputMethodQueryEvent::QInputMethodQueryEvent(Qt::InputMethodQueries
        queries )**

        Constructs a query event for properties given by **queries**.
        """
        ...

    def queries(self) -> PySide2.QtCore.Qt.InputMethodQueries:
        """
        https://doc.qt.io/qt-5/qinputmethodqueryevent.html#queries

        **Qt::InputMethodQueries QInputMethodQueryEvent::queries() const**

        Returns the properties queried by the event.
        """
        ...

    def setValue(
        self, query: PySide2.QtCore.Qt.InputMethodQuery, value: typing.Any
    ) -> None:
        """
        https://doc.qt.io/qt-5/qinputmethodqueryevent.html#setValue

        **void QInputMethodQueryEvent::setValue(Qt::InputMethodQuery query ,
        const QVariant & value )**

        Sets property **query** to **value**.

        **See also** **value** ().
        """
        ...

    def value(self, query: PySide2.QtCore.Qt.InputMethodQuery) -> typing.Any:
        """
        https://doc.qt.io/qt-5/qinputmethodqueryevent.html#value

        **QVariant QInputMethodQueryEvent::value(Qt::InputMethodQuery query )
        const**

        Returns value of the property **query**.

        **See also** **setValue** ().
        """
        ...
