"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtGui, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui

bytes = str


class QOpenGLDebugMessage(object):
    """
    https://doc.qt.io/qt-5/qopengldebugmessage.html

    **Detailed Description**

    Debug messages are usually created by the OpenGL server and then read by
    OpenGL clients (either from the OpenGL internal debug log, or logged in
    real-time). A debug message has a textual representation, a vendor-specific
    numeric id, a source, a type and a severity.

    It's also possible for applications or third-party libraries and toolkits to
    create and insert messages in the debug log. In order to do so, you can use
    the **createApplicationMessage** () or the **createThirdPartyMessage** ()
    static functions.

    **See also** **QOpenGLDebugLogger** .
    """

    AnySeverity: QOpenGLDebugMessage = ...
    AnySource: QOpenGLDebugMessage = ...
    AnyType: QOpenGLDebugMessage = ...
    InvalidSeverity: QOpenGLDebugMessage = ...
    InvalidSource: QOpenGLDebugMessage = ...
    InvalidType: QOpenGLDebugMessage = ...
    APISource: QOpenGLDebugMessage = ...
    ErrorType: QOpenGLDebugMessage = ...
    HighSeverity: QOpenGLDebugMessage = ...
    DeprecatedBehaviorType: QOpenGLDebugMessage = ...
    MediumSeverity: QOpenGLDebugMessage = ...
    WindowSystemSource: QOpenGLDebugMessage = ...
    LowSeverity: QOpenGLDebugMessage = ...
    ShaderCompilerSource: QOpenGLDebugMessage = ...
    UndefinedBehaviorType: QOpenGLDebugMessage = ...
    LastSeverity: QOpenGLDebugMessage = ...
    NotificationSeverity: QOpenGLDebugMessage = ...
    PortabilityType: QOpenGLDebugMessage = ...
    ThirdPartySource: QOpenGLDebugMessage = ...
    ApplicationSource: QOpenGLDebugMessage = ...
    PerformanceType: QOpenGLDebugMessage = ...
    LastSource: QOpenGLDebugMessage = ...
    OtherSource: QOpenGLDebugMessage = ...
    OtherType: QOpenGLDebugMessage = ...
    MarkerType: QOpenGLDebugMessage = ...
    GroupPushType: QOpenGLDebugMessage = ...
    GroupPopType: QOpenGLDebugMessage = ...
    LastType: QOpenGLDebugMessage = ...

    class Severities(object):
        ...

    class Severity(object):
        AnySeverity: QOpenGLDebugMessage.Severity = ...
        InvalidSeverity: QOpenGLDebugMessage.Severity = ...
        HighSeverity: QOpenGLDebugMessage.Severity = ...
        MediumSeverity: QOpenGLDebugMessage.Severity = ...
        LowSeverity: QOpenGLDebugMessage.Severity = ...
        LastSeverity: QOpenGLDebugMessage.Severity = ...
        NotificationSeverity: QOpenGLDebugMessage.Severity = ...

    class Source(object):
        AnySource: QOpenGLDebugMessage.Source = ...
        InvalidSource: QOpenGLDebugMessage.Source = ...
        APISource: QOpenGLDebugMessage.Source = ...
        WindowSystemSource: QOpenGLDebugMessage.Source = ...
        ShaderCompilerSource: QOpenGLDebugMessage.Source = ...
        ThirdPartySource: QOpenGLDebugMessage.Source = ...
        ApplicationSource: QOpenGLDebugMessage.Source = ...
        LastSource: QOpenGLDebugMessage.Source = ...
        OtherSource: QOpenGLDebugMessage.Source = ...

    class Sources(object):
        ...

    class Type(object):
        AnyType: QOpenGLDebugMessage.Type = ...
        InvalidType: QOpenGLDebugMessage.Type = ...
        ErrorType: QOpenGLDebugMessage.Type = ...
        DeprecatedBehaviorType: QOpenGLDebugMessage.Type = ...
        UndefinedBehaviorType: QOpenGLDebugMessage.Type = ...
        PortabilityType: QOpenGLDebugMessage.Type = ...
        PerformanceType: QOpenGLDebugMessage.Type = ...
        OtherType: QOpenGLDebugMessage.Type = ...
        MarkerType: QOpenGLDebugMessage.Type = ...
        GroupPushType: QOpenGLDebugMessage.Type = ...
        GroupPopType: QOpenGLDebugMessage.Type = ...
        LastType: QOpenGLDebugMessage.Type = ...

    class Types(object):
        ...

    @typing.overload
    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-5/qopengldebugmessage.html#QOpenGLDebugMessage

        **QOpenGLDebugMessage::QOpenGLDebugMessage()**

        Constructs a debug message with an empty message string, id set to 0,
        source set to **InvalidSource** , type set to **InvalidType** , and
        severity set to **InvalidSeverity** .

        **Note:** This constructor should not be used to create a debug message;
        instead, use the **createApplicationMessage** () or the
        **createThirdPartyMessage** () static functions.

        **See also** **createApplicationMessage** () and
        **createThirdPartyMessage** ().
        """
        ...

    @typing.overload
    def __init__(self, debugMessage: PySide2.QtGui.QOpenGLDebugMessage) -> None:
        """
        https://doc.qt.io/qt-5/qopengldebugmessage.html#QOpenGLDebugMessage-1

        **QOpenGLDebugMessage::QOpenGLDebugMessage(const QOpenGLDebugMessage &
        debugMessage )**

        Constructs a debug message as a copy of **debugMessage**.

        **See also** **operator=** ().
        """
        ...

    @staticmethod
    def __copy__() -> None:
        ...

    @staticmethod
    def createApplicationMessage(
        text: str,
        id: int = ...,
        severity: PySide2.QtGui.QOpenGLDebugMessage.Severity = ...,
        type: PySide2.QtGui.QOpenGLDebugMessage.Type = ...,
    ) -> PySide2.QtGui.QOpenGLDebugMessage:
        """
        https://doc.qt.io/qt-5/qopengldebugmessage.html#createApplicationMessage

        **[static] QOpenGLDebugMessage
        QOpenGLDebugMessage::createApplicationMessage(const QString & text ,
        GLuint id = 0, QOpenGLDebugMessage::Severity severity =
        NotificationSeverity, QOpenGLDebugMessage::Type type = OtherType)**

        Constructs and returns a debug message with **text** as its text, **id**
        as id, **severity** as severity, and **type** as type. The message
        source will be set to **ApplicationSource** .

        **See also** **QOpenGLDebugLogger::logMessage** () and
        **createThirdPartyMessage** ().
        """
        ...

    @staticmethod
    def createThirdPartyMessage(
        text: str,
        id: int = ...,
        severity: PySide2.QtGui.QOpenGLDebugMessage.Severity = ...,
        type: PySide2.QtGui.QOpenGLDebugMessage.Type = ...,
    ) -> PySide2.QtGui.QOpenGLDebugMessage:
        """
        https://doc.qt.io/qt-5/qopengldebugmessage.html#createThirdPartyMessage

        **[static] QOpenGLDebugMessage
        QOpenGLDebugMessage::createThirdPartyMessage(const QString & text ,
        GLuint id = 0, QOpenGLDebugMessage::Severity severity =
        NotificationSeverity, QOpenGLDebugMessage::Type type = OtherType)**

        Constructs and returns a debug message with **text** as its text, **id**
        as id, **severity** as severity, and **type** as type. The message
        source will be set to **ThirdPartySource** .

        **See also** **QOpenGLDebugLogger::logMessage** () and
        **createApplicationMessage** ().
        """
        ...

    def id(self) -> int:
        """
        https://doc.qt.io/qt-5/qopengldebugmessage.html#id

        **GLuint QOpenGLDebugMessage::id() const**

        Returns the id of the debug message. Ids are generally vendor-specific.
        """
        ...

    def message(self) -> str:
        """
        https://doc.qt.io/qt-5/qopengldebugmessage.html#message

        **QString QOpenGLDebugMessage::message() const**

        Returns the textual message contained by this debug message.
        """
        ...

    def severity(self) -> PySide2.QtGui.QOpenGLDebugMessage.Severity:
        """
        https://doc.qt.io/qt-5/qopengldebugmessage.html#severity

        **QOpenGLDebugMessage::Severity QOpenGLDebugMessage::severity() const**

        Returns the severity of the debug message.
        """
        ...

    def source(self) -> PySide2.QtGui.QOpenGLDebugMessage.Source:
        """
        https://doc.qt.io/qt-5/qopengldebugmessage.html#source

        **QOpenGLDebugMessage::Source QOpenGLDebugMessage::source() const**

        Returns the source of the debug message.
        """
        ...

    def swap(self, other: PySide2.QtGui.QOpenGLDebugMessage) -> None:
        """
        https://doc.qt.io/qt-5/qopengldebugmessage.html#swap

        **void QOpenGLDebugMessage::swap(QOpenGLDebugMessage & debugMessage )**

        Swaps the message **debugMessage** with this message. This operation is
        very fast and never fails.
        """
        ...

    def type(self) -> PySide2.QtGui.QOpenGLDebugMessage.Type:
        """
        https://doc.qt.io/qt-5/qopengldebugmessage.html#type

        **QOpenGLDebugMessage::Type QOpenGLDebugMessage::type() const**

        Returns the type of the debug message.
        """
        ...
