"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtGui, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui

bytes = str


class QTextTableCellFormat(PySide2.QtGui.QTextCharFormat):
    """
    https://doc.qt.io/qt-5/qtexttablecellformat.html

    **Detailed Description**

    The table cell format of a table cell in a document specifies the visual
    properties of the table cell.

    The padding properties of a table cell are controlled by **setLeftPadding**
    (), **setRightPadding** (), **setTopPadding** (), and **setBottomPadding**
    (). All the paddings can be set at once using **setPadding** ().

    **See also** **QTextFormat** , **QTextBlockFormat** , **QTextTableFormat** ,
    and **QTextCharFormat** .
    """

    @typing.overload
    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#QTextTableCellFormat

        **QTextTableCellFormat::QTextTableCellFormat()**

        Constructs a new table cell format object.

        This function was introduced in Qt 4.4.
        """
        ...

    @typing.overload
    def __init__(
        self, QTextTableCellFormat: PySide2.QtGui.QTextTableCellFormat
    ) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#QTextTableCellFormat

        **QTextTableCellFormat::QTextTableCellFormat()**

        Constructs a new table cell format object.

        This function was introduced in Qt 4.4.
        """
        ...

    @typing.overload
    def __init__(self, fmt: PySide2.QtGui.QTextFormat) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#QTextTableCellFormat

        **QTextTableCellFormat::QTextTableCellFormat()**

        Constructs a new table cell format object.

        This function was introduced in Qt 4.4.
        """
        ...

    @staticmethod
    def __copy__() -> None:
        ...

    def bottomBorder(self) -> float:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#bottomBorder

        **qreal QTextTableCellFormat::bottomBorder() const**

        Returns the bottom border width of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **setBottomBorder** ().
        """
        ...

    def bottomBorderBrush(self) -> PySide2.QtGui.QBrush:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#bottomBorderBrush

        **QBrush QTextTableCellFormat::bottomBorderBrush() const**

        Returns the bottom border brush of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **setBottomBorderBrush** ().
        """
        ...

    def bottomBorderStyle(self) -> PySide2.QtGui.QTextFrameFormat.BorderStyle:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#bottomBorderStyle

        **QTextFrameFormat::BorderStyle
        QTextTableCellFormat::bottomBorderStyle() const**

        Returns the bottom border style of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **setBottomBorderStyle** ().
        """
        ...

    def bottomPadding(self) -> float:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#bottomPadding

        **qreal QTextTableCellFormat::bottomPadding() const**

        Gets the bottom padding of the table cell.

        This function was introduced in Qt 4.4.

        **See also** **setBottomPadding** (), **leftPadding** (),
        **rightPadding** (), and **topPadding** ().
        """
        ...

    def isValid(self) -> bool:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#isValid

        **bool QTextTableCellFormat::isValid() const**

        Returns `true` if this table cell format is valid; otherwise returns
        `false`.

        This function was introduced in Qt 4.4.
        """
        ...

    def leftBorder(self) -> float:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#leftBorder

        **qreal QTextTableCellFormat::leftBorder() const**

        Returns the left border width of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **setLeftBorder** ().
        """
        ...

    def leftBorderBrush(self) -> PySide2.QtGui.QBrush:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#leftBorderBrush

        **QBrush QTextTableCellFormat::leftBorderBrush() const**

        Returns the left border brush of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **setLeftBorderBrush** ().
        """
        ...

    def leftBorderStyle(self) -> PySide2.QtGui.QTextFrameFormat.BorderStyle:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#leftBorderStyle

        **QTextFrameFormat::BorderStyle QTextTableCellFormat::leftBorderStyle()
        const**

        Returns the left border style of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **setLeftBorderStyle** ().
        """
        ...

    def leftPadding(self) -> float:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#leftPadding

        **qreal QTextTableCellFormat::leftPadding() const**

        Gets the left padding of the table cell.

        This function was introduced in Qt 4.4.

        **See also** **setLeftPadding** (), **rightPadding** (), **topPadding**
        (), and **bottomPadding** ().
        """
        ...

    def rightBorder(self) -> float:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#rightBorder

        **qreal QTextTableCellFormat::rightBorder() const**

        Returns the right border width of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **setRightBorder** ().
        """
        ...

    def rightBorderBrush(self) -> PySide2.QtGui.QBrush:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#rightBorderBrush

        **QBrush QTextTableCellFormat::rightBorderBrush() const**

        Returns the right border brush of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **setRightBorderBrush** ().
        """
        ...

    def rightBorderStyle(self) -> PySide2.QtGui.QTextFrameFormat.BorderStyle:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#rightBorderStyle

        **QTextFrameFormat::BorderStyle QTextTableCellFormat::rightBorderStyle()
        const**

        Returns the right border style of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **setRightBorderStyle** ().
        """
        ...

    def rightPadding(self) -> float:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#rightPadding

        **qreal QTextTableCellFormat::rightPadding() const**

        Gets the right padding of the table cell.

        This function was introduced in Qt 4.4.

        **See also** **setRightPadding** (), **leftPadding** (), **topPadding**
        (), and **bottomPadding** ().
        """
        ...

    def setBorder(self, width: float) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#setBorder

        **void QTextTableCellFormat::setBorder(qreal width )**

        Sets the left, right, top, and bottom border **width** of the table
        cell.

        This function was introduced in Qt 5.14.

        **See also** **setLeftBorder** (), **setRightBorder** (),
        **setTopBorder** (), **setBottomBorder** (), and
        **QTextTableFormat::setBorderCollapse** .
        """
        ...

    def setBorderBrush(self, brush: PySide2.QtGui.QBrush) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#setBorderBrush

        **void QTextTableCellFormat::setBorderBrush(const QBrush & brush )**

        Sets the left, right, top, and bottom border **brush** of the table
        cell.

        This function was introduced in Qt 5.14.

        **See also** **setLeftBorderBrush** (), **setRightBorderBrush** (),
        **setTopBorderBrush** (), **setBottomBorderBrush** (), and
        **QTextTableFormat::setBorderCollapse** .
        """
        ...

    def setBorderStyle(self, style: PySide2.QtGui.QTextFrameFormat.BorderStyle) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#setBorderStyle

        **void
        QTextTableCellFormat::setBorderStyle(QTextFrameFormat::BorderStyle style
        )**

        Sets the left, right, top, and bottom border **style** of the table
        cell.

        This function was introduced in Qt 5.14.

        **See also** **setLeftBorderStyle** (), **setRightBorderStyle** (),
        **setTopBorderStyle** (), **setBottomBorderStyle** (), and
        **QTextTableFormat::setBorderCollapse** .
        """
        ...

    def setBottomBorder(self, width: float) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#setBottomBorder

        **void QTextTableCellFormat::setBottomBorder(qreal width )**

        Sets the bottom border **width** of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **bottomBorder** () and
        **QTextTableFormat::setBorderCollapse** .
        """
        ...

    def setBottomBorderBrush(self, brush: PySide2.QtGui.QBrush) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#setBottomBorderBrush

        **void QTextTableCellFormat::setBottomBorderBrush(const QBrush & brush
        )**

        Sets the bottom border **brush** of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **bottomBorderBrush** () and
        **QTextTableFormat::setBorderCollapse** .
        """
        ...

    def setBottomBorderStyle(
        self, style: PySide2.QtGui.QTextFrameFormat.BorderStyle
    ) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#setBottomBorderStyle

        **void
        QTextTableCellFormat::setBottomBorderStyle(QTextFrameFormat::BorderStyle
        style )**

        Sets the bottom border **style** of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **bottomBorderStyle** () and
        **QTextTableFormat::setBorderCollapse** .
        """
        ...

    def setBottomPadding(self, padding: float) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#setBottomPadding

        **void QTextTableCellFormat::setBottomPadding(qreal padding )**

        Sets the bottom **padding** of the table cell.

        This function was introduced in Qt 4.4.

        **See also** **bottomPadding** (), **setLeftPadding** (),
        **setRightPadding** (), and **setTopPadding** ().
        """
        ...

    def setLeftBorder(self, width: float) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#setLeftBorder

        **void QTextTableCellFormat::setLeftBorder(qreal width )**

        Sets the left border **width** of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **leftBorder** () and
        **QTextTableFormat::setBorderCollapse** .
        """
        ...

    def setLeftBorderBrush(self, brush: PySide2.QtGui.QBrush) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#setLeftBorderBrush

        **void QTextTableCellFormat::setLeftBorderBrush(const QBrush & brush )**

        Sets the left border **brush** of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **leftBorderBrush** () and
        **QTextTableFormat::setBorderCollapse** .
        """
        ...

    def setLeftBorderStyle(
        self, style: PySide2.QtGui.QTextFrameFormat.BorderStyle
    ) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#setLeftBorderStyle

        **void
        QTextTableCellFormat::setLeftBorderStyle(QTextFrameFormat::BorderStyle
        style )**

        Sets the left border **style** of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **leftBorderStyle** () and
        **QTextTableFormat::setBorderCollapse** .
        """
        ...

    def setLeftPadding(self, padding: float) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#setLeftPadding

        **void QTextTableCellFormat::setLeftPadding(qreal padding )**

        Sets the left **padding** of the table cell.

        This function was introduced in Qt 4.4.

        **See also** **leftPadding** (), **setRightPadding** (),
        **setTopPadding** (), and **setBottomPadding** ().
        """
        ...

    def setPadding(self, padding: float) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#setPadding

        **void QTextTableCellFormat::setPadding(qreal padding )**

        Sets the left, right, top, and bottom **padding** of the table cell.

        This function was introduced in Qt 4.4.

        **See also** **setLeftPadding** (), **setRightPadding** (),
        **setTopPadding** (), and **setBottomPadding** ().
        """
        ...

    def setRightBorder(self, width: float) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#setRightBorder

        **void QTextTableCellFormat::setRightBorder(qreal width )**

        Sets the right border **width** of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **rightBorder** () and
        **QTextTableFormat::setBorderCollapse** .
        """
        ...

    def setRightBorderBrush(self, brush: PySide2.QtGui.QBrush) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#setRightBorderBrush

        **void QTextTableCellFormat::setRightBorderBrush(const QBrush & brush
        )**

        Sets the right border **brush** of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **rightBorderBrush** () and
        **QTextTableFormat::setBorderCollapse** .
        """
        ...

    def setRightBorderStyle(
        self, style: PySide2.QtGui.QTextFrameFormat.BorderStyle
    ) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#setRightBorderStyle

        **void
        QTextTableCellFormat::setRightBorderStyle(QTextFrameFormat::BorderStyle
        style )**

        Sets the right border **style** of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **rightBorderStyle** () and
        **QTextTableFormat::setBorderCollapse** .
        """
        ...

    def setRightPadding(self, padding: float) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#setRightPadding

        **void QTextTableCellFormat::setRightPadding(qreal padding )**

        Sets the right **padding** of the table cell.

        This function was introduced in Qt 4.4.

        **See also** **rightPadding** (), **setLeftPadding** (),
        **setTopPadding** (), and **setBottomPadding** ().
        """
        ...

    def setTopBorder(self, width: float) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#setTopBorder

        **void QTextTableCellFormat::setTopBorder(qreal width )**

        Sets the top border **width** of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **topBorder** () and
        **QTextTableFormat::setBorderCollapse** .
        """
        ...

    def setTopBorderBrush(self, brush: PySide2.QtGui.QBrush) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#setTopBorderBrush

        **void QTextTableCellFormat::setTopBorderBrush(const QBrush & brush )**

        Sets the top border **brush** of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **topBorderBrush** () and
        **QTextTableFormat::setBorderCollapse** .
        """
        ...

    def setTopBorderStyle(
        self, style: PySide2.QtGui.QTextFrameFormat.BorderStyle
    ) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#setTopBorderStyle

        **void
        QTextTableCellFormat::setTopBorderStyle(QTextFrameFormat::BorderStyle
        style )**

        Sets the top border **style** of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **topBorderStyle** () and
        **QTextTableFormat::setBorderCollapse** .
        """
        ...

    def setTopPadding(self, padding: float) -> None:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#setTopPadding

        **void QTextTableCellFormat::setTopPadding(qreal padding )**

        Sets the top **padding** of the table cell.

        This function was introduced in Qt 4.4.

        **See also** **topPadding** (), **setLeftPadding** (),
        **setRightPadding** (), and **setBottomPadding** ().
        """
        ...

    def topBorder(self) -> float:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#topBorder

        **qreal QTextTableCellFormat::topBorder() const**

        Returns the top border width of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **setTopBorder** ().
        """
        ...

    def topBorderBrush(self) -> PySide2.QtGui.QBrush:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#topBorderBrush

        **QBrush QTextTableCellFormat::topBorderBrush() const**

        Returns the top border brush of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **setTopBorderBrush** ().
        """
        ...

    def topBorderStyle(self) -> PySide2.QtGui.QTextFrameFormat.BorderStyle:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#topBorderStyle

        **QTextFrameFormat::BorderStyle QTextTableCellFormat::topBorderStyle()
        const**

        Returns the top border style of the table cell.

        This function was introduced in Qt 5.14.

        **See also** **setTopBorderStyle** ().
        """
        ...

    def topPadding(self) -> float:
        """
        https://doc.qt.io/qt-5/qtexttablecellformat.html#topPadding

        **qreal QTextTableCellFormat::topPadding() const**

        Gets the top padding of the table cell.

        This function was introduced in Qt 4.4.

        **See also** **setTopPadding** (), **leftPadding** (), **rightPadding**
        (), and **bottomPadding** ().
        """
        ...
