"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtGui, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui

bytes = str


class QTouchDevice(object):
    """
    https://doc.qt.io/qt-5/qtouchdevice.html

    **Detailed Description**

    Each **QTouchEvent**  contains a QTouchDevice pointer to allow accessing
    device-specific properties like type and capabilities. It is the
    responsibility of the platform or generic plug-ins to register the available
    touch devices via QWindowSystemInterface before generating any touch events.
    Applications do not need to instantiate this class, they should just access
    the global instances pointed to by **QTouchEvent::device** ().
    """

    TouchScreen: QTouchDevice = ...
    Position: QTouchDevice = ...
    TouchPad: QTouchDevice = ...
    Area: QTouchDevice = ...
    Pressure: QTouchDevice = ...
    Velocity: QTouchDevice = ...
    RawPositions: QTouchDevice = ...
    NormalizedPosition: QTouchDevice = ...
    MouseEmulation: QTouchDevice = ...

    class Capabilities(object):
        ...

    class CapabilityFlag(object):
        Position: QTouchDevice.CapabilityFlag = ...
        Area: QTouchDevice.CapabilityFlag = ...
        Pressure: QTouchDevice.CapabilityFlag = ...
        Velocity: QTouchDevice.CapabilityFlag = ...
        RawPositions: QTouchDevice.CapabilityFlag = ...
        NormalizedPosition: QTouchDevice.CapabilityFlag = ...
        MouseEmulation: QTouchDevice.CapabilityFlag = ...

    class DeviceType(object):
        TouchScreen: QTouchDevice.DeviceType = ...
        TouchPad: QTouchDevice.DeviceType = ...

    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-5/qtouchdevice.html#QTouchDevice

        **QTouchDevice::QTouchDevice()**

        Creates a new touch device instance. By default the name is empty, the
        only capability is Position and type is **TouchScreen** .
        """
        ...

    def capabilities(self) -> PySide2.QtGui.QTouchDevice.Capabilities:
        """
        https://doc.qt.io/qt-5/qtouchdevice.html#capabilities

        **QTouchDevice::Capabilities QTouchDevice::capabilities() const**

        Returns the touch device capabilities.

        **See also** **setCapabilities** ().
        """
        ...

    @staticmethod
    def devices() -> typing.List:
        """
        https://doc.qt.io/qt-5/qtouchdevice.html#devices

        **[static] QList<const QTouchDevice *> QTouchDevice::devices()**

        Returns a list of all registered devices.

        **Note:** The returned list cannot be used to add new devices. To add a
        simulated touch screen for an autotest, **QTest::createTouchDevice** ()
        can be used. To add real touch screens to QPA plugins, the private
        `QWindowSystemInterface::registerTouchDevice()` function can be used.
        """
        ...

    def maximumTouchPoints(self) -> int:
        """
        https://doc.qt.io/qt-5/qtouchdevice.html#maximumTouchPoints

        **int QTouchDevice::maximumTouchPoints() const**

        Returns the maximum number of simultaneous touch points (fingers) that
        can be detected.

        This function was introduced in Qt 5.2.

        **See also** **setMaximumTouchPoints** ().
        """
        ...

    def name(self) -> str:
        """
        https://doc.qt.io/qt-5/qtouchdevice.html#name

        **QString QTouchDevice::name() const**

        Returns the touch device name.

        This string may often be empty. It is however useful for systems that
        have more than one touch input device because there it can be used to
        differentiate between the devices (i.e. to tell from which device a
        **QTouchEvent**  originates from).

        **See also** **setName** ().
        """
        ...

    def setCapabilities(self, caps: PySide2.QtGui.QTouchDevice.Capabilities) -> None:
        """
        https://doc.qt.io/qt-5/qtouchdevice.html#setCapabilities

        **void QTouchDevice::setCapabilities(QTouchDevice::Capabilities caps )**

        Sets the capabilities **caps** supported by the device and its driver.

        **See also** **capabilities** ().
        """
        ...

    def setMaximumTouchPoints(self, max: int) -> None:
        """
        https://doc.qt.io/qt-5/qtouchdevice.html#setMaximumTouchPoints

        **void QTouchDevice::setMaximumTouchPoints(int max )**

        Sets the maximum number of simultaneous touchpoints **max** supported by
        the device and its driver.

        **See also** **maximumTouchPoints** ().
        """
        ...

    def setName(self, name: str) -> None:
        """
        https://doc.qt.io/qt-5/qtouchdevice.html#setName

        **void QTouchDevice::setName(const QString & name )**

        Sets the **name** (a unique identifier) for the device. In most systems
        it is enough to leave this unset and keep the default empty name. This
        identifier becomes important when having multiple touch devices and a
        need to differentiate between them.

        **See also** **name** ().
        """
        ...

    def setType(self, devType: PySide2.QtGui.QTouchDevice.DeviceType) -> None:
        """
        https://doc.qt.io/qt-5/qtouchdevice.html#setType

        **void QTouchDevice::setType(QTouchDevice::DeviceType devType )**

        Sets the device type **devType**.

        **See also** **type** ().
        """
        ...

    def type(self) -> PySide2.QtGui.QTouchDevice.DeviceType:
        """
        https://doc.qt.io/qt-5/qtouchdevice.html#type

        **QTouchDevice::DeviceType QTouchDevice::type() const**

        Returns the touch device type.

        **See also** **setType** ().
        """
        ...
