"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtHelp, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets
import PySide2.QtHelp

bytes = str


class QHelpFilterData(object):
    """
    https://doc.qt.io/qt-5/qhelpfilterdata.html

    **Detailed Description**

    By using **setComponents** () you may constrain the search results to
    documents that belong only to components specified on the given list. By
    using **setVersions** () you may constrain the search results to documents
    that belong only to versions specified on the given list.

    **See also** **QHelpFilterEngine** .
    """

    @typing.overload
    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-5/qhelpfilterdata.html#QHelpFilterData

        **QHelpFilterData::QHelpFilterData()**

        Constructs the empty filter.
        """
        ...

    @typing.overload
    def __init__(self, other: PySide2.QtHelp.QHelpFilterData) -> None:
        """
        https://doc.qt.io/qt-5/qhelpfilterdata.html#QHelpFilterData-1

        **QHelpFilterData::QHelpFilterData(const QHelpFilterData & other )**

        Constructs a copy of **other**.
        """
        ...

    @staticmethod
    def __copy__() -> None:
        ...

    def components(self) -> typing.List:
        """
        https://doc.qt.io/qt-5/qhelpfilterdata.html#components

        **QStringList QHelpFilterData::components() const**

        Returns the component list that is used for filtering the search
        results.

        **See also** **setComponents** ().
        """
        ...

    def setComponents(self, components: typing.Sequence) -> None:
        """
        https://doc.qt.io/qt-5/qhelpfilterdata.html#setComponents

        **void QHelpFilterData::setComponents(const QStringList & components )**

        Specifies the component list that is used for filtering the search
        results. Only results from components in the list **components** shall
        be returned.

        **See also** **components** ().
        """
        ...

    def setVersions(self, versions: typing.Sequence) -> None:
        """
        https://doc.qt.io/qt-5/qhelpfilterdata.html#setVersions

        **void QHelpFilterData::setVersions(const QList<QVersionNumber> &
        versions )**

        Specifies the version list that is used for filtering the search
        results. Only results from versions in the list **versions** shall be
        returned.

        **See also** **versions** ().
        """
        ...

    def swap(self, other: PySide2.QtHelp.QHelpFilterData) -> None:
        """
        https://doc.qt.io/qt-5/qhelpfilterdata.html#swap

        **void QHelpFilterData::swap(QHelpFilterData & other )**

        Swaps the filter **other** with this filter. This operation is very fast
        and never fails.
        """
        ...

    def versions(self) -> typing.List:
        """
        https://doc.qt.io/qt-5/qhelpfilterdata.html#versions

        **QList<QVersionNumber> QHelpFilterData::versions() const**

        Returns the version list that is used for filtering the search results.

        **See also** **setVersions** ().
        """
        ...
