"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtLocation, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtPositioning
import PySide2.QtLocation

bytes = str


class QGeoRoute(object):
    """
    https://doc.qt.io/qt-5/qgeoroute.html

    **Detailed Description**

    A QGeoRoute object contains high level information about a route, such as
    the length the route, the estimated travel time for the route, and enough
    information to render a basic image of the route on a map.

    The QGeoRoute object also contains a list of **QGeoRouteSegment**  objecs
    which describe subsections of the route in greater detail.

    Routing information is normally requested using
    **QGeoRoutingManager::calculateRoute** (), which returns a
    **QGeoRouteReply**  instance. If the operation is completed successfully the
    routing information can be accessed with **QGeoRouteReply::routes** ()

    **See also** **QGeoRoutingManager** .
    """

    @typing.overload
    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-5/qgeoroute.html#QGeoRoute

        **QGeoRoute::QGeoRoute()**

        Constructs a route object.
        """
        ...

    @typing.overload
    def __init__(self, other: PySide2.QtLocation.QGeoRoute) -> None:
        """
        https://doc.qt.io/qt-5/qgeoroute.html#QGeoRoute-1

        **QGeoRoute::QGeoRoute(const QGeoRoute & other )**

        Constructs a route object from the contents of **other**.
        """
        ...

    @staticmethod
    def __copy__() -> None:
        ...

    def bounds(self) -> PySide2.QtPositioning.QGeoRectangle:
        """
        https://doc.qt.io/qt-5/qgeoroute.html#bounds

        **QGeoRectangle QGeoRoute::bounds() const**

        Returns a bounding box which encompasses the entire route.

        **See also** **setBounds** ().
        """
        ...

    def distance(self) -> float:
        """
        https://doc.qt.io/qt-5/qgeoroute.html#distance

        **qreal QGeoRoute::distance() const**

        Returns the distance covered by this route, in meters.

        **See also** **setDistance** ().
        """
        ...

    def extendedAttributes(self) -> typing.Dict:
        """
        https://doc.qt.io/qt-5/qgeoroute.html#extendedAttributes

        **QVariantMap QGeoRoute::extendedAttributes() const**

        Returns the extended attributes associated with this route.

        This function was introduced in Qt 5.13.

        **See also** **setExtendedAttributes** ().
        """
        ...

    def firstRouteSegment(self) -> PySide2.QtLocation.QGeoRouteSegment:
        """
        https://doc.qt.io/qt-5/qgeoroute.html#firstRouteSegment

        **QGeoRouteSegment QGeoRoute::firstRouteSegment() const**

        Returns the first route segment in the route.

        Will return an invalid route segment if there are no route segments
        associated with the route.

        The remaining route segments can be accessed sequentially with
        **QGeoRouteSegment::nextRouteSegment** .

        **See also** **setFirstRouteSegment** ().
        """
        ...

    def path(self) -> typing.List:
        """
        https://doc.qt.io/qt-5/qgeoroute.html#path

        **QList<QGeoCoordinate> QGeoRoute::path() const**

        Returns the geometric shape of the route.

        The coordinates should be listed in the order in which they would be
        traversed by someone traveling along this segment of the route.

        **See also** **setPath** ().
        """
        ...

    def request(self) -> PySide2.QtLocation.QGeoRouteRequest:
        """
        https://doc.qt.io/qt-5/qgeoroute.html#request

        **QGeoRouteRequest QGeoRoute::request() const**

        Returns the route request which describes the criteria used in the
        calculation of this route.

        **See also** **setRequest** ().
        """
        ...

    def routeId(self) -> str:
        """
        https://doc.qt.io/qt-5/qgeoroute.html#routeId

        **QString QGeoRoute::routeId() const**

        Returns the identifier of this route.

        Service providers which support the updating of routes commonly assign
        identifiers to routes. If this route did not come from such a service
        provider the function will return an empty string.

        **See also** **setRouteId** ().
        """
        ...

    def setBounds(self, bounds: PySide2.QtPositioning.QGeoRectangle) -> None:
        """
        https://doc.qt.io/qt-5/qgeoroute.html#setBounds

        **void QGeoRoute::setBounds(const QGeoRectangle & bounds )**

        Sets the bounding box which encompasses the entire route to **bounds**.

        **See also** **bounds** ().
        """
        ...

    def setDistance(self, distance: float) -> None:
        """
        https://doc.qt.io/qt-5/qgeoroute.html#setDistance

        **void QGeoRoute::setDistance(qreal distance )**

        Sets the distance covered by this route, in meters, to **distance**.

        **See also** **distance** ().
        """
        ...

    def setExtendedAttributes(self, extendedAttributes: typing.Dict) -> None:
        """
        https://doc.qt.io/qt-5/qgeoroute.html#setExtendedAttributes

        **void QGeoRoute::setExtendedAttributes(const QVariantMap &
        extendedAttributes )**

        Sets the extended attributes **extendedAttributes** associated with this
        route.

        This function was introduced in Qt 5.13.

        **See also** **extendedAttributes** ().
        """
        ...

    def setFirstRouteSegment(
        self, routeSegment: PySide2.QtLocation.QGeoRouteSegment
    ) -> None:
        """
        https://doc.qt.io/qt-5/qgeoroute.html#setFirstRouteSegment

        **void QGeoRoute::setFirstRouteSegment(const QGeoRouteSegment &
        routeSegment )**

        Sets the first route segment in the route to **routeSegment**.

        **See also** **firstRouteSegment** ().
        """
        ...

    def setPath(self, path: typing.Sequence) -> None:
        """
        https://doc.qt.io/qt-5/qgeoroute.html#setPath

        **void QGeoRoute::setPath(const QList<QGeoCoordinate> & path )**

        Sets the geometric shape of the route to **path**.

        The coordinates in **path** should be listed in the order in which they
        would be traversed by someone traveling along this segment of the route.

        **See also** **path** ().
        """
        ...

    def setRequest(self, request: PySide2.QtLocation.QGeoRouteRequest) -> None:
        """
        https://doc.qt.io/qt-5/qgeoroute.html#setRequest

        **void QGeoRoute::setRequest(const QGeoRouteRequest & request )**

        Sets the route request which describes the criteria used in the
        calculcation of this route to **request**.

        **See also** **request** ().
        """
        ...

    def setRouteId(self, id: str) -> None:
        """
        https://doc.qt.io/qt-5/qgeoroute.html#setRouteId

        **void QGeoRoute::setRouteId(const QString & id )**

        Sets the identifier of this route to **id**.

        Service providers which support the updating of routes commonly assign
        identifiers to routes. If this route came from such a service provider
        changing the identifier will probably cause route updates to stop
        working.

        **See also** **routeId** ().
        """
        ...

    def setTravelMode(
        self, mode: PySide2.QtLocation.QGeoRouteRequest.TravelMode
    ) -> None:
        """
        https://doc.qt.io/qt-5/qgeoroute.html#setTravelMode

        **void QGeoRoute::setTravelMode(QGeoRouteRequest::TravelMode mode )**

        Sets the travel mode for this route to **mode**.

        This should be one of the travel modes returned by **request**
        ().travelModes().

        **See also** **travelMode** ().
        """
        ...

    def setTravelTime(self, secs: int) -> None:
        """
        https://doc.qt.io/qt-5/qgeoroute.html#setTravelTime

        **void QGeoRoute::setTravelTime(int secs )**

        Sets the estimated amount of time it will take to traverse this route,
        in seconds, to **secs**.

        **See also** **travelTime** ().
        """
        ...

    def travelMode(self) -> PySide2.QtLocation.QGeoRouteRequest.TravelMode:
        """
        https://doc.qt.io/qt-5/qgeoroute.html#travelMode

        **QGeoRouteRequest::TravelMode QGeoRoute::travelMode() const**

        Returns the travel mode for the this route.

        This should be one of the travel modes returned by **request**
        ().travelModes().

        **See also** **setTravelMode** ().
        """
        ...

    def travelTime(self) -> int:
        """
        https://doc.qt.io/qt-5/qgeoroute.html#travelTime

        **int QGeoRoute::travelTime() const**

        Returns the estimated amount of time it will take to traverse this
        route, in seconds.

        **See also** **setTravelTime** ().
        """
        ...
