"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtLocation, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtPositioning
import PySide2.QtLocation

bytes = str


class QPlaceContent(object):
    """
    https://doc.qt.io/qt-5/qplacecontent.html

    **Detailed Description**

    Rich content such as **images** , **reviews**  and **editorials**  inherit
    from the QPlaceContent class which contains common properties such as an
    attribution string and content contributor, which may take the form of a
    **user**  and/or **supplier** . It is possible that a user from a supplier
    is contributing content, hence both fields could be filled in
    simultaneously.

    **Note:** Some providers may **require** that the attribution string be
    displayed to the user whenever a piece of content is viewed.

    Conversion between QPlaceContent and it's subclasses can be easily performed
    without casting. Due to the way it has been implemented, object slicing is
    not an issue, the following code is valid:

    **QPlaceImage**  image;
        image.setUrl(**QUrl** ("www.example.com"));
    **QPlaceContent**  content = image;

        **QPlaceImage**  image2;
    image2 = content;
        **qDebug** () << image2.url(); //image2.url() ==
    "www.example.com"

    The rich content of a place is typically made available as paginated items.
    The ability to convert between QPlaceContent and it's subclasses means that
    code which handles the mechanics of paging can be easily shared for each of
    the sub types.

    At present the QPlaceContent class is not extensible by 3rd parties.

    Note: The Places API considers content objects to be 'retrieve-only'
    objects. Submission of content to a provider is not a supported use case.

    **See also** **QPlaceImage** , **QPlaceReview** , and **QPlaceEditorial** .
    """

    NoType: QPlaceContent = ...
    ImageType: QPlaceContent = ...
    ReviewType: QPlaceContent = ...
    EditorialType: QPlaceContent = ...
    CustomType: QPlaceContent = ...

    class Type(object):
        NoType: QPlaceContent.Type = ...
        ImageType: QPlaceContent.Type = ...
        ReviewType: QPlaceContent.Type = ...
        EditorialType: QPlaceContent.Type = ...
        CustomType: QPlaceContent.Type = ...

    @typing.overload
    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-5/qplacecontent.html#QPlaceContent

        **QPlaceContent::QPlaceContent()**

        Constructs an default content object which has no type.
        """
        ...

    @typing.overload
    def __init__(self, other: PySide2.QtLocation.QPlaceContent) -> None:
        """
        https://doc.qt.io/qt-5/qplacecontent.html#QPlaceContent-1

        **QPlaceContent::QPlaceContent(const QPlaceContent & other )**

        Constructs a new copy of **other**.
        """
        ...

    @staticmethod
    def __copy__() -> None:
        ...

    def attribution(self) -> str:
        """
        https://doc.qt.io/qt-5/qplacecontent.html#attribution

        **QString QPlaceContent::attribution() const**

        Returns a rich text attribution string.

        **Note** : Some providers may require that the attribution of a
        particular content item always be displayed when the content item is
        shown.

        **See also** **setAttribution** ().
        """
        ...

    def setAttribution(self, attribution: str) -> None:
        """
        https://doc.qt.io/qt-5/qplacecontent.html#setAttribution

        **void QPlaceContent::setAttribution(const QString & attribution )**

        Sets a rich text **attribution** string for this content item.

        **See also** **attribution** ().
        """
        ...

    def setSupplier(self, supplier: PySide2.QtLocation.QPlaceSupplier) -> None:
        """
        https://doc.qt.io/qt-5/qplacecontent.html#setSupplier

        **void QPlaceContent::setSupplier(const QPlaceSupplier & supplier )**

        Sets the **supplier** of the content.

        **See also** **supplier** ().
        """
        ...

    def setUser(self, user: PySide2.QtLocation.QPlaceUser) -> None:
        """
        https://doc.qt.io/qt-5/qplacecontent.html#setUser

        **void QPlaceContent::setUser(const QPlaceUser & user )**

        Sets the **user** who contributed this content.

        **See also** **user** ().
        """
        ...

    def supplier(self) -> PySide2.QtLocation.QPlaceSupplier:
        """
        https://doc.qt.io/qt-5/qplacecontent.html#supplier

        **QPlaceSupplier QPlaceContent::supplier() const**

        Returns the supplier who contributed this content.

        **See also** **setSupplier** ().
        """
        ...

    def type(self) -> PySide2.QtLocation.QPlaceContent.Type:
        """
        https://doc.qt.io/qt-5/qplacecontent.html#type

        **QPlaceContent::Type QPlaceContent::type() const**

        Returns the content type.
        """
        ...

    def user(self) -> PySide2.QtLocation.QPlaceUser:
        """
        https://doc.qt.io/qt-5/qplacecontent.html#user

        **QPlaceUser QPlaceContent::user() const**

        Returns the user who contributed this content.

        **See also** **setUser** ().
        """
        ...
