"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtLocation, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtPositioning
import PySide2.QtLocation

bytes = str


class QPlaceDetailsReply(PySide2.QtLocation.QPlaceReply):
    """
    https://doc.qt.io/qt-5/qplacedetailsreply.html

    **Detailed Description**

    See **Fetching Place Details**  for an example on how to use a details
    reply.

    **See also** **QPlaceManager** .
    """

    def __init__(self, parent: typing.Optional[PySide2.QtCore.QObject] = ...) -> None:
        """
        https://doc.qt.io/qt-5/qplacedetailsreply.html#QPlaceDetailsReply

        **QPlaceDetailsReply::QPlaceDetailsReply(QObject * parent = nullptr)**

        Constructs a details reply with a given **parent**.
        """
        ...

    def place(self) -> PySide2.QtLocation.QPlace:
        """
        https://doc.qt.io/qt-5/qplacedetailsreply.html#place

        **QPlace QPlaceDetailsReply::place() const**

        Returns the place that was fetched.

        **See also** **setPlace** ().
        """
        ...

    def setPlace(self, place: PySide2.QtLocation.QPlace) -> None:
        """
        https://doc.qt.io/qt-5/qplacedetailsreply.html#setPlace

        **[protected] void QPlaceDetailsReply::setPlace(const QPlace & place )**

        Sets the fetched **place** of the reply.

        **See also** **place** ().
        """
        ...

    def type(self) -> PySide2.QtLocation.QPlaceReply.Type:
        """
        https://doc.qt.io/qt-5/qplacedetailsreply.html#type

        **[override virtual] QPlaceReply::Type QPlaceDetailsReply::type()
        const**

        Reimplements: **QPlaceReply::type** () const.

        Returns the type of reply.
        """
        ...
