"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtLocation, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtPositioning
import PySide2.QtLocation

bytes = str


class QPlaceImage(PySide2.QtLocation.QPlaceContent):
    """
    https://doc.qt.io/qt-5/qplaceimage.html

    **Detailed Description**

    Each QPlaceImage represents a set of metadata about an image such as it's
    url, identifier and MIME type. These are properties in addition to those
    provided by **QPlaceContent** .

    Note: The Places API only supports images as 'retrieve-only' objects.
    Submitting images to a provider is not a supported use case.

    **See also** **QPlaceContent** .
    """

    @typing.overload
    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-5/qplaceimage.html#QPlaceImage

        **QPlaceImage::QPlaceImage()**

        Constructs an new QPlaceImage.
        """
        ...

    @typing.overload
    def __init__(self, other: PySide2.QtLocation.QPlaceContent) -> None:
        """
        https://doc.qt.io/qt-5/qplaceimage.html#QPlaceImage-1

        **QPlaceImage::QPlaceImage(const QPlaceContent & other )**

        Constructs a copy of **other** if possible, otherwise constructs a
        default image.
        """
        ...

    def imageId(self) -> str:
        """
        https://doc.qt.io/qt-5/qplaceimage.html#imageId

        **QString QPlaceImage::imageId() const**

        Returns the image's identifier.

        **See also** **setImageId** ().
        """
        ...

    def mimeType(self) -> str:
        """
        https://doc.qt.io/qt-5/qplaceimage.html#mimeType

        **QString QPlaceImage::mimeType() const**

        Returns the image's MIME type.

        **See also** **setMimeType** ().
        """
        ...

    def setImageId(self, identifier: str) -> None:
        """
        https://doc.qt.io/qt-5/qplaceimage.html#setImageId

        **void QPlaceImage::setImageId(const QString & identifier )**

        Sets image's **identifier**.

        **See also** **imageId** ().
        """
        ...

    def setMimeType(self, data: str) -> None:
        """
        https://doc.qt.io/qt-5/qplaceimage.html#setMimeType

        **void QPlaceImage::setMimeType(const QString & type )**

        Sets image's MIME **type**.

        **See also** **mimeType** ().
        """
        ...

    def setUrl(self, url: PySide2.QtCore.QUrl) -> None:
        """
        https://doc.qt.io/qt-5/qplaceimage.html#setUrl

        **void QPlaceImage::setUrl(const QUrl & url )**

        Sets the image's **url**.

        **See also** **url** ().
        """
        ...

    def url(self) -> PySide2.QtCore.QUrl:
        """
        https://doc.qt.io/qt-5/qplaceimage.html#url

        **QUrl QPlaceImage::url() const**

        Returns the image's url.

        **See also** **setUrl** ().
        """
        ...
