"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtLocation, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtPositioning
import PySide2.QtLocation

bytes = str


class QPlaceSearchReply(PySide2.QtLocation.QPlaceReply):
    """
    https://doc.qt.io/qt-5/qplacesearchreply.html

    **Detailed Description**

    See **Discovery/Search**  for an example on how to use a search reply.

    **See also** **QPlaceSearchRequest**  and **QPlaceManager** .
    """

    def __init__(self, parent: typing.Optional[PySide2.QtCore.QObject] = ...) -> None:
        """
        https://doc.qt.io/qt-5/qplacesearchreply.html#QPlaceSearchReply

        **QPlaceSearchReply::QPlaceSearchReply(QObject * parent = nullptr)**

        Constructs a search reply with a given **parent**.
        """
        ...

    def nextPageRequest(self) -> PySide2.QtLocation.QPlaceSearchRequest:
        """
        https://doc.qt.io/qt-5/qplacesearchreply.html#nextPageRequest

        **QPlaceSearchRequest QPlaceSearchReply::nextPageRequest() const**

        Returns a place search request which can be used to request the next
        page of search results. An empty place search request is returned if
        there is no next page of results.

        **See also** **previousPageRequest** () and **setNextPageRequest** ().
        """
        ...

    def previousPageRequest(self) -> PySide2.QtLocation.QPlaceSearchRequest:
        """
        https://doc.qt.io/qt-5/qplacesearchreply.html#previousPageRequest

        **QPlaceSearchRequest QPlaceSearchReply::previousPageRequest() const**

        Returns a place search request which can be used to request the previous
        page of search results. An empty place search request is returned if
        there is no previous page of results.

        **See also** **nextPageRequest** () and **setPreviousPageRequest** ().
        """
        ...

    def request(self) -> PySide2.QtLocation.QPlaceSearchRequest:
        """
        https://doc.qt.io/qt-5/qplacesearchreply.html#request

        **QPlaceSearchRequest QPlaceSearchReply::request() const**

        Returns the search request that was used to generate this reply.

        **See also** **setRequest** ().
        """
        ...

    def results(self) -> typing.List:
        """
        https://doc.qt.io/qt-5/qplacesearchreply.html#results

        **QList<QPlaceSearchResult> QPlaceSearchReply::results() const**

        Returns a list of search results;

        **See also** **setResults** ().
        """
        ...

    def setNextPageRequest(self, next: PySide2.QtLocation.QPlaceSearchRequest) -> None:
        """
        https://doc.qt.io/qt-5/qplacesearchreply.html#setNextPageRequest

        **[protected] void QPlaceSearchReply::setNextPageRequest(const
        QPlaceSearchRequest & next )**

        Sets the next page of search results request to **next**.

        **See also** **nextPageRequest** ().
        """
        ...

    def setPreviousPageRequest(
        self, previous: PySide2.QtLocation.QPlaceSearchRequest
    ) -> None:
        """
        https://doc.qt.io/qt-5/qplacesearchreply.html#setPreviousPageRequest

        **[protected] void QPlaceSearchReply::setPreviousPageRequest(const
        QPlaceSearchRequest & previous )**

        Sets the previous page of search results request to **previous**.

        **See also** **previousPageRequest** ().
        """
        ...

    def setRequest(self, request: PySide2.QtLocation.QPlaceSearchRequest) -> None:
        """
        https://doc.qt.io/qt-5/qplacesearchreply.html#setRequest

        **[protected] void QPlaceSearchReply::setRequest(const
        QPlaceSearchRequest & request )**

        Sets the search **request** used to generate this reply.

        **See also** **request** ().
        """
        ...

    def setResults(self, results: typing.Sequence) -> None:
        """
        https://doc.qt.io/qt-5/qplacesearchreply.html#setResults

        **[protected] void QPlaceSearchReply::setResults(const
        QList<QPlaceSearchResult> & results )**

        Sets the list of search **results**.

        **See also** **results** ().
        """
        ...

    def type(self) -> PySide2.QtLocation.QPlaceReply.Type:
        """
        https://doc.qt.io/qt-5/qplacesearchreply.html#type

        **[override virtual] QPlaceReply::Type QPlaceSearchReply::type() const**

        Reimplements: **QPlaceReply::type** () const.

        Returns the type of reply.
        """
        ...
