"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtMultimedia, except for defaults which are replaced by "...".
"""
import PySide2
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtNetwork
import PySide2.QtMultimediaWidgets
import PySide2.QtMultimedia

bytes = str


class QAudio(object):
    """
    https://doc.qt.io/qt-5/qaudio.html

    **Detailed Description**
    """

    ActiveState: QAudio = ...
    AudioInput: QAudio = ...
    LinearVolumeScale: QAudio = ...
    NoError: QAudio = ...
    UnknownRole: QAudio = ...
    AudioOutput: QAudio = ...
    CubicVolumeScale: QAudio = ...
    MusicRole: QAudio = ...
    OpenError: QAudio = ...
    SuspendedState: QAudio = ...
    IOError: QAudio = ...
    LogarithmicVolumeScale: QAudio = ...
    StoppedState: QAudio = ...
    VideoRole: QAudio = ...
    DecibelVolumeScale: QAudio = ...
    IdleState: QAudio = ...
    UnderrunError: QAudio = ...
    VoiceCommunicationRole: QAudio = ...
    AlarmRole: QAudio = ...
    FatalError: QAudio = ...
    InterruptedState: QAudio = ...
    NotificationRole: QAudio = ...
    RingtoneRole: QAudio = ...
    AccessibilityRole: QAudio = ...
    SonificationRole: QAudio = ...
    GameRole: QAudio = ...
    CustomRole: QAudio = ...

    class Error(object):
        NoError: QAudio.Error = ...
        OpenError: QAudio.Error = ...
        IOError: QAudio.Error = ...
        UnderrunError: QAudio.Error = ...
        FatalError: QAudio.Error = ...

    class Mode(object):
        AudioInput: QAudio.Mode = ...
        AudioOutput: QAudio.Mode = ...

    class Role(object):
        UnknownRole: QAudio.Role = ...
        MusicRole: QAudio.Role = ...
        VideoRole: QAudio.Role = ...
        VoiceCommunicationRole: QAudio.Role = ...
        AlarmRole: QAudio.Role = ...
        NotificationRole: QAudio.Role = ...
        RingtoneRole: QAudio.Role = ...
        AccessibilityRole: QAudio.Role = ...
        SonificationRole: QAudio.Role = ...
        GameRole: QAudio.Role = ...
        CustomRole: QAudio.Role = ...

    class State(object):
        ActiveState: QAudio.State = ...
        SuspendedState: QAudio.State = ...
        StoppedState: QAudio.State = ...
        IdleState: QAudio.State = ...
        InterruptedState: QAudio.State = ...

    class VolumeScale(object):
        LinearVolumeScale: QAudio.VolumeScale = ...
        CubicVolumeScale: QAudio.VolumeScale = ...
        LogarithmicVolumeScale: QAudio.VolumeScale = ...
        DecibelVolumeScale: QAudio.VolumeScale = ...

    @staticmethod
    def convertVolume(
        volume: float,
        from_: PySide2.QtMultimedia.QAudio.VolumeScale,
        to: PySide2.QtMultimedia.QAudio.VolumeScale,
    ) -> float:
        """
        https://doc.qt.io/qt-5/qaudio.html#convertVolume

        **qreal QAudio::convertVolume(qreal volume , QAudio::VolumeScale from ,
        QAudio::VolumeScale to )**

        Converts an audio **volume** **from** a volume scale **to** another, and
        returns the result.

        Depending on the context, different scales are used to represent audio
        volume. All Qt Multimedia classes that have an audio volume use a linear
        scale, the reason is that the loudness of a speaker is controlled by
        modulating its voltage on a linear scale. The human ear on the other
        hand, perceives loudness in a logarithmic way. Using a logarithmic scale
        for volume controls is therefore appropriate in most applications. The
        decibel scale is logarithmic by nature and is commonly used to define
        sound levels, it is usually used for UI volume controls in professional
        audio applications. The cubic scale is a computationally cheap
        approximation of a logarithmic scale, it provides more control over
        lower volume levels.

        The following example shows how to convert the volume value from a
        slider control before passing it to a **QMediaPlayer** . As a result,
        the perceived increase in volume is the same when increasing the volume
        slider from 20 to 30 as it is from 50 to 60:

        void applyVolume(int volumeSliderValue)
            {
                //
        volumeSliderValue is in the range [0..100]

                **qreal**
        linearVolume = QAudio::convertVolume(volumeSliderValue / **qreal**
        (100.0),
        QAudio::LogarithmicVolumeScale,
        QAudio::LinearVolumeScale);

                player.setVolume(**qRound**
        (linearVolume * 100));
            }

        This function was introduced in Qt 5.8.

        **See also** **VolumeScale** , **QMediaPlayer::setVolume** (),
        **QAudioOutput::setVolume** (), **QAudioInput::setVolume** (),
        **QSoundEffect::setVolume** (), and **QMediaRecorder::setVolume** ().
        """
        ...
