"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtMultimedia, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtNetwork
import PySide2.QtMultimediaWidgets
import PySide2.QtMultimedia

bytes = str


class QAudioRecorder(PySide2.QtMultimedia.QMediaRecorder):
    """
    https://doc.qt.io/qt-5/qaudiorecorder.html

    **Detailed Description**

    The QAudioRecorder class is a high level media recording class and contains
    the same functionality as **QMediaRecorder** .

    audioRecorder = new **QAudioRecorder** ;

        **QAudioEncoderSettings**
    audioSettings;
        audioSettings.setCodec("audio/amr");
    audioSettings.setQuality(QMultimedia::HighQuality);
    audioRecorder->setEncodingSettings(audioSettings);
    audioRecorder->setOutputLocation(**QUrl** ::fromLocalFile("test.amr"));
    audioRecorder->record();

    In addition QAudioRecorder provides functionality for selecting the audio
    input.

    const **QStringList**  inputs = audioRecorder->audioInputs();
    **QString**  selectedInput = audioRecorder->defaultAudioInput();
    for (const **QString**  &input : inputs) {
            **QString**  description
    = audioRecorder->audioInputDescription(input);
            // show descriptions
    to user and allow selection
            selectedInput = input;
        }
    audioRecorder->setAudioInput(selectedInput);

    The **Audio Recorder Example**  shows how to use this class in more detail.

    **See also** **QMediaRecorder**  and **QAudioInputSelectorControl** .
    """

    def __init__(self, parent: typing.Optional[PySide2.QtCore.QObject] = ...) -> None:
        """
        https://doc.qt.io/qt-5/qaudiorecorder.html#QAudioRecorder

        **QAudioRecorder::QAudioRecorder(QObject * parent = nullptr)**

        Constructs an audio recorder. The **parent** is passed to
        **QMediaObject** .
        """
        ...

    def audioInput(self) -> str:
        """
        https://doc.qt.io/qt-5/qaudiorecorder.html#audioInput

        **QString QAudioRecorder::audioInput() const**

        Returns the active audio input name.

        **Note:** Getter function for property audioInput.

        **See also** **setAudioInput** ().
        """
        ...

    def audioInputDescription(self, name: str) -> str:
        """
        https://doc.qt.io/qt-5/qaudiorecorder.html#audioInputDescription

        **QString QAudioRecorder::audioInputDescription(const QString & name )
        const**

        Returns the readable translated description of the audio input device
        with **name**.
        """
        ...

    def audioInputs(self) -> typing.List:
        """
        https://doc.qt.io/qt-5/qaudiorecorder.html#audioInputs

        **QStringList QAudioRecorder::audioInputs() const**

        Returns a list of available audio inputs
        """
        ...

    def defaultAudioInput(self) -> str:
        """
        https://doc.qt.io/qt-5/qaudiorecorder.html#defaultAudioInput

        **QString QAudioRecorder::defaultAudioInput() const**

        Returns the default audio input name.
        """
        ...

    def setAudioInput(self, name: str) -> None:
        """
        https://doc.qt.io/qt-5/qaudiorecorder.html#setAudioInput

        **[slot] void QAudioRecorder::setAudioInput(const QString & name )**

        Set the active audio input to **name**.

        **Note:** Setter function for property **audioInput** .

        **See also** **audioInput** ().
        """
        ...

    @property
    def audioInputChanged(self) -> PySide2.QtCore.SignalInstance:
        """
        https://doc.qt.io/qt-5/qaudiorecorder.html#audioInputChanged

        **[signal] void QAudioRecorder::audioInputChanged(const QString & name
        )**

        Signal emitted when active audio input changes to **name**.

        **Note:** Notifier signal for property **audioInput** .
        """
        ...

    @property
    def availableAudioInputsChanged(self) -> PySide2.QtCore.SignalInstance:
        """
        https://doc.qt.io/qt-5/qaudiorecorder.html#availableAudioInputsChanged

        **[signal] void QAudioRecorder::availableAudioInputsChanged()**

        Signal is emitted when the available audio inputs change.
        """
        ...
