"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtMultimedia, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtNetwork
import PySide2.QtMultimediaWidgets
import PySide2.QtMultimedia

bytes = str


class QMediaAvailabilityControl(PySide2.QtMultimedia.QMediaControl):
    """
    https://doc.qt.io/qt-5/qmediaavailabilitycontrol.html

    **Detailed Description**

    An instance of **QMediaObject**  (or its derived classes) can report any
    changes in availability via this control.

    The interface name of QMediaAvailabilityControl is `org.qt-
    project.qt.mediaavailabilitycontrol/5.0` as defined in
    **QMediaAvailabilityControl_iid** .

    **See also** **QMediaService::requestControl** () and **QMediaObject** .
    """

    def __init__(self, parent: typing.Optional[PySide2.QtCore.QObject] = ...) -> None:
        """
        https://doc.qt.io/qt-5/qmediaavailabilitycontrol.html#QMediaAvailability
        Control

        **[protected]
        QMediaAvailabilityControl::QMediaAvailabilityControl(QObject * parent =
        nullptr)**

        Constructs an availability control object with **parent**.
        """
        ...

    def availability(self) -> PySide2.QtMultimedia.QMultimedia.AvailabilityStatus:
        """
        https://doc.qt.io/qt-5/qmediaavailabilitycontrol.html#availability

        **[pure virtual] QMultimedia::AvailabilityStatus
        QMediaAvailabilityControl::availability() const**

        Returns the current availability of this instance of the media service.
        If the availability changes at run time (for example, some other media
        client takes all media resources) the availabilityChanges() signal
        should be emitted.
        """
        ...

    @property
    def availabilityChanged(self) -> PySide2.QtCore.SignalInstance:
        """
        https://doc.qt.io/qt-5/qmediaavailabilitycontrol.html#availabilityChange
        d

        **[signal] void QMediaAvailabilityControl::availabilityChanged(QMultimed
        ia::AvailabilityStatus availability )**

        Signal emitted when the current **availability** value changed.
        """
        ...
