"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtMultimedia, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtNetwork
import PySide2.QtMultimediaWidgets
import PySide2.QtMultimedia

bytes = str


class QMediaServiceSupportedDevicesInterface(object):
    """
    https://doc.qt.io/qt-5/qmediaservicesupporteddevicesinterface.html

    **Detailed Description**

    A **QMediaServiceProviderPlugin**  may implement this interface.
    """

    def __init__(self) -> None:
        ...

    def deviceDescription(
        self, service: PySide2.QtCore.QByteArray, device: PySide2.QtCore.QByteArray
    ) -> str:
        """
        https://doc.qt.io/qt-5/qmediaservicesupporteddevicesinterface.html#devic
        eDescription

        **[pure virtual] QString
        QMediaServiceSupportedDevicesInterface::deviceDescription(const
        QByteArray & service , const QByteArray & device )**

        Returns the description of a **device** available for a **service**
        type.
        """
        ...

    def devices(self, service: PySide2.QtCore.QByteArray) -> typing.List:
        """
        https://doc.qt.io/qt-5/qmediaservicesupporteddevicesinterface.html#devic
        es

        **[pure virtual] QList<QByteArray>
        QMediaServiceSupportedDevicesInterface::devices(const QByteArray &
        service ) const**

        Returns a list of devices available for a **service** type.
        """
        ...
