"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtMultimedia, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtNetwork
import PySide2.QtMultimediaWidgets
import PySide2.QtMultimedia

bytes = str


class QMediaServiceSupportedFormatsInterface(object):
    """
    https://doc.qt.io/qt-5/qmediaservicesupportedformatsinterface.html

    **Detailed Description**

    A **QMediaServiceProviderPlugin**  may implement this interface.
    """

    def __init__(self) -> None:
        ...

    def hasSupport(
        self, mimeType: str, codecs: typing.Sequence
    ) -> PySide2.QtMultimedia.QMultimedia.SupportEstimate:
        """
        https://doc.qt.io/qt-5/qmediaservicesupportedformatsinterface.html#hasSu
        pport

        **[pure virtual] QMultimedia::SupportEstimate
        QMediaServiceSupportedFormatsInterface::hasSupport(const QString &
        mimeType , const QStringList & codecs ) const**

        Returns the level of support a media service plug-in has for a
        **mimeType** and set of **codecs**.
        """
        ...

    def supportedMimeTypes(self) -> typing.List:
        """
        https://doc.qt.io/qt-5/qmediaservicesupportedformatsinterface.html#suppo
        rtedMimeTypes

        **[pure virtual] QStringList
        QMediaServiceSupportedFormatsInterface::supportedMimeTypes() const**

        Returns a list of MIME types supported by the media service plug-in.
        """
        ...
