"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtMultimedia, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtNetwork
import PySide2.QtMultimediaWidgets
import PySide2.QtMultimedia

bytes = str


class QMediaVideoProbeControl(PySide2.QtMultimedia.QMediaControl):
    """
    https://doc.qt.io/qt-5/qmediavideoprobecontrol.html

    **Detailed Description**

    **QVideoProbe**  is the client facing class for probing video - this class
    is implemented by media backends to provide this functionality.

    The interface name of QMediaVideoProbeControl is `org.qt-
    project.qt.mediavideoprobecontrol/5.0` as defined in
    **QMediaVideoProbeControl_iid** .

    **See also** **QVideoProbe** , **QMediaService::requestControl** (),
    **QMediaPlayer** , and **QCamera** .
    """

    def __init__(self, parent: typing.Optional[PySide2.QtCore.QObject] = ...) -> None:
        """
        https://doc.qt.io/qt-5/qmediavideoprobecontrol.html#QMediaVideoProbeCont
        rol

        **[protected] QMediaVideoProbeControl::QMediaVideoProbeControl(QObject *
        parent = nullptr)**

        Create a new media video probe control object with the given **parent**.
        """
        ...

    @property
    def flush(self) -> PySide2.QtCore.SignalInstance:
        """
        https://doc.qt.io/qt-5/qmediavideoprobecontrol.html#flush

        **[signal] void QMediaVideoProbeControl::flush()**

        This signal should be emitted when it is required to release all frames.
        """
        ...

    @property
    def videoFrameProbed(self) -> PySide2.QtCore.SignalInstance:
        """
        https://doc.qt.io/qt-5/qmediavideoprobecontrol.html#videoFrameProbed

        **[signal] void QMediaVideoProbeControl::videoFrameProbed(const
        QVideoFrame & frame )**

        This signal should be emitted when a video **frame** is processed in the
        media service.
        """
        ...
