"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtOpenGLFunctions, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtGui
import PySide2.QtOpenGLFunctions

bytes = str


class QOpenGLFunctions_1_0(PySide2.QtGui.QAbstractOpenGLFunctions):
    """
    https://doc.qt.io/qt-5/qopenglfunctions-1-0.html

    **Detailed Description**

    This class is a wrapper for functions from OpenGL 1.0 specification. See
    reference pages on **opengl.org**  for function documentation.

    **See also** **QAbstractOpenGLFunctions** .
    """

    def __init__(self) -> None:
        ...

    def glAccum(self, op: int, value: float) -> None:
        ...

    def glAlphaFunc(self, func: int, ref: float) -> None:
        ...

    def glBegin(self, mode: int) -> None:
        ...

    def glBlendFunc(self, sfactor: int, dfactor: int) -> None:
        ...

    def glCallList(self, list: int) -> None:
        ...

    def glCallLists(self, n: int, type: int, lists: int) -> None:
        ...

    def glClear(self, mask: int) -> None:
        ...

    def glClearAccum(self, red: float, green: float, blue: float, alpha: float) -> None:
        ...

    def glClearColor(self, red: float, green: float, blue: float, alpha: float) -> None:
        ...

    def glClearDepth(self, depth: float) -> None:
        ...

    def glClearIndex(self, c: float) -> None:
        ...

    def glClearStencil(self, s: int) -> None:
        ...

    def glClipPlane(self, plane: int, equation: typing.Sequence) -> None:
        ...

    def glColor3b(self, red: int, green: int, blue: int) -> None:
        ...

    def glColor3bv(self, v: bytes) -> None:
        ...

    def glColor3d(self, red: float, green: float, blue: float) -> None:
        ...

    def glColor3dv(self, v: typing.Sequence) -> None:
        ...

    def glColor3f(self, red: float, green: float, blue: float) -> None:
        ...

    def glColor3fv(self, v: typing.Sequence) -> None:
        ...

    def glColor3i(self, red: int, green: int, blue: int) -> None:
        ...

    def glColor3iv(self, v: typing.Sequence) -> None:
        ...

    def glColor3s(self, red: int, green: int, blue: int) -> None:
        ...

    def glColor3sv(self, v: typing.Sequence) -> None:
        ...

    def glColor3ub(self, red: int, green: int, blue: int) -> None:
        ...

    def glColor3ubv(self, v: bytes) -> None:
        ...

    def glColor3ui(self, red: int, green: int, blue: int) -> None:
        ...

    def glColor3uiv(self, v: typing.Sequence) -> None:
        ...

    def glColor3us(self, red: int, green: int, blue: int) -> None:
        ...

    def glColor3usv(self, v: typing.Sequence) -> None:
        ...

    def glColor4b(self, red: int, green: int, blue: int, alpha: int) -> None:
        ...

    def glColor4bv(self, v: bytes) -> None:
        ...

    def glColor4d(self, red: float, green: float, blue: float, alpha: float) -> None:
        ...

    def glColor4dv(self, v: typing.Sequence) -> None:
        ...

    def glColor4f(self, red: float, green: float, blue: float, alpha: float) -> None:
        ...

    def glColor4fv(self, v: typing.Sequence) -> None:
        ...

    def glColor4i(self, red: int, green: int, blue: int, alpha: int) -> None:
        ...

    def glColor4iv(self, v: typing.Sequence) -> None:
        ...

    def glColor4s(self, red: int, green: int, blue: int, alpha: int) -> None:
        ...

    def glColor4sv(self, v: typing.Sequence) -> None:
        ...

    def glColor4ub(self, red: int, green: int, blue: int, alpha: int) -> None:
        ...

    def glColor4ubv(self, v: bytes) -> None:
        ...

    def glColor4ui(self, red: int, green: int, blue: int, alpha: int) -> None:
        ...

    def glColor4uiv(self, v: typing.Sequence) -> None:
        ...

    def glColor4us(self, red: int, green: int, blue: int, alpha: int) -> None:
        ...

    def glColor4usv(self, v: typing.Sequence) -> None:
        ...

    def glColorMask(self, red: int, green: int, blue: int, alpha: int) -> None:
        ...

    def glColorMaterial(self, face: int, mode: int) -> None:
        ...

    def glCopyPixels(self, x: int, y: int, width: int, height: int, type: int) -> None:
        ...

    def glCullFace(self, mode: int) -> None:
        ...

    def glDeleteLists(self, list: int, range: int) -> None:
        ...

    def glDepthFunc(self, func: int) -> None:
        ...

    def glDepthMask(self, flag: int) -> None:
        ...

    def glDepthRange(self, nearVal: float, farVal: float) -> None:
        ...

    def glDisable(self, cap: int) -> None:
        ...

    def glDrawBuffer(self, mode: int) -> None:
        ...

    def glDrawPixels(
        self, width: int, height: int, format: int, type: int, pixels: int
    ) -> None:
        ...

    def glEdgeFlag(self, flag: int) -> None:
        ...

    def glEnable(self, cap: int) -> None:
        ...

    def glEnd(self) -> None:
        ...

    def glEndList(self) -> None:
        ...

    def glEvalCoord1d(self, u: float) -> None:
        ...

    def glEvalCoord1dv(self, u: typing.Sequence) -> None:
        ...

    def glEvalCoord1f(self, u: float) -> None:
        ...

    def glEvalCoord1fv(self, u: typing.Sequence) -> None:
        ...

    def glEvalCoord2d(self, u: float, v: float) -> None:
        ...

    def glEvalCoord2dv(self, u: typing.Sequence) -> None:
        ...

    def glEvalCoord2f(self, u: float, v: float) -> None:
        ...

    def glEvalCoord2fv(self, u: typing.Sequence) -> None:
        ...

    def glEvalMesh1(self, mode: int, i1: int, i2: int) -> None:
        ...

    def glEvalMesh2(self, mode: int, i1: int, i2: int, j1: int, j2: int) -> None:
        ...

    def glEvalPoint1(self, i: int) -> None:
        ...

    def glEvalPoint2(self, i: int, j: int) -> None:
        ...

    def glFinish(self) -> None:
        ...

    def glFlush(self) -> None:
        ...

    def glFogf(self, pname: int, param: float) -> None:
        ...

    def glFogfv(self, pname: int, params: typing.Sequence) -> None:
        ...

    def glFogi(self, pname: int, param: int) -> None:
        ...

    def glFogiv(self, pname: int, params: typing.Sequence) -> None:
        ...

    def glFrontFace(self, mode: int) -> None:
        ...

    def glFrustum(
        self,
        left: float,
        right: float,
        bottom: float,
        top: float,
        zNear: float,
        zFar: float,
    ) -> None:
        ...

    def glGenLists(self, range: int) -> int:
        ...

    def glGetError(self) -> int:
        ...

    def glGetString(self, name: int) -> bytes:
        ...

    def glHint(self, target: int, mode: int) -> None:
        ...

    def glIndexMask(self, mask: int) -> None:
        ...

    def glIndexd(self, c: float) -> None:
        ...

    def glIndexdv(self, c: typing.Sequence) -> None:
        ...

    def glIndexf(self, c: float) -> None:
        ...

    def glIndexfv(self, c: typing.Sequence) -> None:
        ...

    def glIndexi(self, c: int) -> None:
        ...

    def glIndexiv(self, c: typing.Sequence) -> None:
        ...

    def glIndexs(self, c: int) -> None:
        ...

    def glIndexsv(self, c: typing.Sequence) -> None:
        ...

    def glInitNames(self) -> None:
        ...

    def glIsEnabled(self, cap: int) -> int:
        ...

    def glIsList(self, list: int) -> int:
        ...

    def glLightModelf(self, pname: int, param: float) -> None:
        ...

    def glLightModelfv(self, pname: int, params: typing.Sequence) -> None:
        ...

    def glLightModeli(self, pname: int, param: int) -> None:
        ...

    def glLightModeliv(self, pname: int, params: typing.Sequence) -> None:
        ...

    def glLightf(self, light: int, pname: int, param: float) -> None:
        ...

    def glLightfv(self, light: int, pname: int, params: typing.Sequence) -> None:
        ...

    def glLighti(self, light: int, pname: int, param: int) -> None:
        ...

    def glLightiv(self, light: int, pname: int, params: typing.Sequence) -> None:
        ...

    def glLineStipple(self, factor: int, pattern: int) -> None:
        ...

    def glLineWidth(self, width: float) -> None:
        ...

    def glListBase(self, base: int) -> None:
        ...

    def glLoadIdentity(self) -> None:
        ...

    def glLoadMatrixd(self, m: typing.Sequence) -> None:
        ...

    def glLoadMatrixf(self, m: typing.Sequence) -> None:
        ...

    def glLoadName(self, name: int) -> None:
        ...

    def glLogicOp(self, opcode: int) -> None:
        ...

    def glMap1d(
        self,
        target: int,
        u1: float,
        u2: float,
        stride: int,
        order: int,
        points: typing.Sequence,
    ) -> None:
        ...

    def glMap1f(
        self,
        target: int,
        u1: float,
        u2: float,
        stride: int,
        order: int,
        points: typing.Sequence,
    ) -> None:
        ...

    def glMap2d(
        self,
        target: int,
        u1: float,
        u2: float,
        ustride: int,
        uorder: int,
        v1: float,
        v2: float,
        vstride: int,
        vorder: int,
        points: typing.Sequence,
    ) -> None:
        ...

    def glMap2f(
        self,
        target: int,
        u1: float,
        u2: float,
        ustride: int,
        uorder: int,
        v1: float,
        v2: float,
        vstride: int,
        vorder: int,
        points: typing.Sequence,
    ) -> None:
        ...

    def glMapGrid1d(self, un: int, u1: float, u2: float) -> None:
        ...

    def glMapGrid1f(self, un: int, u1: float, u2: float) -> None:
        ...

    def glMapGrid2d(
        self, un: int, u1: float, u2: float, vn: int, v1: float, v2: float
    ) -> None:
        ...

    def glMapGrid2f(
        self, un: int, u1: float, u2: float, vn: int, v1: float, v2: float
    ) -> None:
        ...

    def glMaterialf(self, face: int, pname: int, param: float) -> None:
        ...

    def glMaterialfv(self, face: int, pname: int, params: typing.Sequence) -> None:
        ...

    def glMateriali(self, face: int, pname: int, param: int) -> None:
        ...

    def glMaterialiv(self, face: int, pname: int, params: typing.Sequence) -> None:
        ...

    def glMatrixMode(self, mode: int) -> None:
        ...

    def glMultMatrixd(self, m: typing.Sequence) -> None:
        ...

    def glMultMatrixf(self, m: typing.Sequence) -> None:
        ...

    def glNewList(self, list: int, mode: int) -> None:
        ...

    def glNormal3b(self, nx: int, ny: int, nz: int) -> None:
        ...

    def glNormal3bv(self, v: bytes) -> None:
        ...

    def glNormal3d(self, nx: float, ny: float, nz: float) -> None:
        ...

    def glNormal3dv(self, v: typing.Sequence) -> None:
        ...

    def glNormal3f(self, nx: float, ny: float, nz: float) -> None:
        ...

    def glNormal3fv(self, v: typing.Sequence) -> None:
        ...

    def glNormal3i(self, nx: int, ny: int, nz: int) -> None:
        ...

    def glNormal3iv(self, v: typing.Sequence) -> None:
        ...

    def glNormal3s(self, nx: int, ny: int, nz: int) -> None:
        ...

    def glNormal3sv(self, v: typing.Sequence) -> None:
        ...

    def glOrtho(
        self,
        left: float,
        right: float,
        bottom: float,
        top: float,
        zNear: float,
        zFar: float,
    ) -> None:
        ...

    def glPassThrough(self, token: float) -> None:
        ...

    def glPixelMapfv(self, map: int, mapsize: int, values: typing.Sequence) -> None:
        ...

    def glPixelMapuiv(self, map: int, mapsize: int, values: typing.Sequence) -> None:
        ...

    def glPixelMapusv(self, map: int, mapsize: int, values: typing.Sequence) -> None:
        ...

    def glPixelStoref(self, pname: int, param: float) -> None:
        ...

    def glPixelStorei(self, pname: int, param: int) -> None:
        ...

    def glPixelTransferf(self, pname: int, param: float) -> None:
        ...

    def glPixelTransferi(self, pname: int, param: int) -> None:
        ...

    def glPixelZoom(self, xfactor: float, yfactor: float) -> None:
        ...

    def glPointSize(self, size: float) -> None:
        ...

    def glPolygonMode(self, face: int, mode: int) -> None:
        ...

    def glPopAttrib(self) -> None:
        ...

    def glPopMatrix(self) -> None:
        ...

    def glPopName(self) -> None:
        ...

    def glPushAttrib(self, mask: int) -> None:
        ...

    def glPushMatrix(self) -> None:
        ...

    def glPushName(self, name: int) -> None:
        ...

    def glRasterPos2d(self, x: float, y: float) -> None:
        ...

    def glRasterPos2dv(self, v: typing.Sequence) -> None:
        ...

    def glRasterPos2f(self, x: float, y: float) -> None:
        ...

    def glRasterPos2fv(self, v: typing.Sequence) -> None:
        ...

    def glRasterPos2i(self, x: int, y: int) -> None:
        ...

    def glRasterPos2iv(self, v: typing.Sequence) -> None:
        ...

    def glRasterPos2s(self, x: int, y: int) -> None:
        ...

    def glRasterPos2sv(self, v: typing.Sequence) -> None:
        ...

    def glRasterPos3d(self, x: float, y: float, z: float) -> None:
        ...

    def glRasterPos3dv(self, v: typing.Sequence) -> None:
        ...

    def glRasterPos3f(self, x: float, y: float, z: float) -> None:
        ...

    def glRasterPos3fv(self, v: typing.Sequence) -> None:
        ...

    def glRasterPos3i(self, x: int, y: int, z: int) -> None:
        ...

    def glRasterPos3iv(self, v: typing.Sequence) -> None:
        ...

    def glRasterPos3s(self, x: int, y: int, z: int) -> None:
        ...

    def glRasterPos3sv(self, v: typing.Sequence) -> None:
        ...

    def glRasterPos4d(self, x: float, y: float, z: float, w: float) -> None:
        ...

    def glRasterPos4dv(self, v: typing.Sequence) -> None:
        ...

    def glRasterPos4f(self, x: float, y: float, z: float, w: float) -> None:
        ...

    def glRasterPos4fv(self, v: typing.Sequence) -> None:
        ...

    def glRasterPos4i(self, x: int, y: int, z: int, w: int) -> None:
        ...

    def glRasterPos4iv(self, v: typing.Sequence) -> None:
        ...

    def glRasterPos4s(self, x: int, y: int, z: int, w: int) -> None:
        ...

    def glRasterPos4sv(self, v: typing.Sequence) -> None:
        ...

    def glReadBuffer(self, mode: int) -> None:
        ...

    def glRectd(self, x1: float, y1: float, x2: float, y2: float) -> None:
        ...

    def glRectdv(self, v1: typing.Sequence, v2: typing.Sequence) -> None:
        ...

    def glRectf(self, x1: float, y1: float, x2: float, y2: float) -> None:
        ...

    def glRectfv(self, v1: typing.Sequence, v2: typing.Sequence) -> None:
        ...

    def glRecti(self, x1: int, y1: int, x2: int, y2: int) -> None:
        ...

    def glRectiv(self, v1: typing.Sequence, v2: typing.Sequence) -> None:
        ...

    def glRects(self, x1: int, y1: int, x2: int, y2: int) -> None:
        ...

    def glRectsv(self, v1: typing.Sequence, v2: typing.Sequence) -> None:
        ...

    def glRenderMode(self, mode: int) -> int:
        ...

    def glRotated(self, angle: float, x: float, y: float, z: float) -> None:
        ...

    def glRotatef(self, angle: float, x: float, y: float, z: float) -> None:
        ...

    def glScaled(self, x: float, y: float, z: float) -> None:
        ...

    def glScalef(self, x: float, y: float, z: float) -> None:
        ...

    def glScissor(self, x: int, y: int, width: int, height: int) -> None:
        ...

    def glShadeModel(self, mode: int) -> None:
        ...

    def glStencilFunc(self, func: int, ref: int, mask: int) -> None:
        ...

    def glStencilMask(self, mask: int) -> None:
        ...

    def glStencilOp(self, fail: int, zfail: int, zpass: int) -> None:
        ...

    def glTexCoord1d(self, s: float) -> None:
        ...

    def glTexCoord1dv(self, v: typing.Sequence) -> None:
        ...

    def glTexCoord1f(self, s: float) -> None:
        ...

    def glTexCoord1fv(self, v: typing.Sequence) -> None:
        ...

    def glTexCoord1i(self, s: int) -> None:
        ...

    def glTexCoord1iv(self, v: typing.Sequence) -> None:
        ...

    def glTexCoord1s(self, s: int) -> None:
        ...

    def glTexCoord1sv(self, v: typing.Sequence) -> None:
        ...

    def glTexCoord2d(self, s: float, t: float) -> None:
        ...

    def glTexCoord2dv(self, v: typing.Sequence) -> None:
        ...

    def glTexCoord2f(self, s: float, t: float) -> None:
        ...

    def glTexCoord2fv(self, v: typing.Sequence) -> None:
        ...

    def glTexCoord2i(self, s: int, t: int) -> None:
        ...

    def glTexCoord2iv(self, v: typing.Sequence) -> None:
        ...

    def glTexCoord2s(self, s: int, t: int) -> None:
        ...

    def glTexCoord2sv(self, v: typing.Sequence) -> None:
        ...

    def glTexCoord3d(self, s: float, t: float, r: float) -> None:
        ...

    def glTexCoord3dv(self, v: typing.Sequence) -> None:
        ...

    def glTexCoord3f(self, s: float, t: float, r: float) -> None:
        ...

    def glTexCoord3fv(self, v: typing.Sequence) -> None:
        ...

    def glTexCoord3i(self, s: int, t: int, r: int) -> None:
        ...

    def glTexCoord3iv(self, v: typing.Sequence) -> None:
        ...

    def glTexCoord3s(self, s: int, t: int, r: int) -> None:
        ...

    def glTexCoord3sv(self, v: typing.Sequence) -> None:
        ...

    def glTexCoord4d(self, s: float, t: float, r: float, q: float) -> None:
        ...

    def glTexCoord4dv(self, v: typing.Sequence) -> None:
        ...

    def glTexCoord4f(self, s: float, t: float, r: float, q: float) -> None:
        ...

    def glTexCoord4fv(self, v: typing.Sequence) -> None:
        ...

    def glTexCoord4i(self, s: int, t: int, r: int, q: int) -> None:
        ...

    def glTexCoord4iv(self, v: typing.Sequence) -> None:
        ...

    def glTexCoord4s(self, s: int, t: int, r: int, q: int) -> None:
        ...

    def glTexCoord4sv(self, v: typing.Sequence) -> None:
        ...

    def glTexEnvf(self, target: int, pname: int, param: float) -> None:
        ...

    def glTexEnvfv(self, target: int, pname: int, params: typing.Sequence) -> None:
        ...

    def glTexEnvi(self, target: int, pname: int, param: int) -> None:
        ...

    def glTexEnviv(self, target: int, pname: int, params: typing.Sequence) -> None:
        ...

    def glTexGend(self, coord: int, pname: int, param: float) -> None:
        ...

    def glTexGendv(self, coord: int, pname: int, params: typing.Sequence) -> None:
        ...

    def glTexGenf(self, coord: int, pname: int, param: float) -> None:
        ...

    def glTexGenfv(self, coord: int, pname: int, params: typing.Sequence) -> None:
        ...

    def glTexGeni(self, coord: int, pname: int, param: int) -> None:
        ...

    def glTexGeniv(self, coord: int, pname: int, params: typing.Sequence) -> None:
        ...

    def glTexImage1D(
        self,
        target: int,
        level: int,
        internalformat: int,
        width: int,
        border: int,
        format: int,
        type: int,
        pixels: int,
    ) -> None:
        ...

    def glTexImage2D(
        self,
        target: int,
        level: int,
        internalformat: int,
        width: int,
        height: int,
        border: int,
        format: int,
        type: int,
        pixels: int,
    ) -> None:
        ...

    def glTexParameterf(self, target: int, pname: int, param: float) -> None:
        ...

    def glTexParameterfv(
        self, target: int, pname: int, params: typing.Sequence
    ) -> None:
        ...

    def glTexParameteri(self, target: int, pname: int, param: int) -> None:
        ...

    def glTexParameteriv(
        self, target: int, pname: int, params: typing.Sequence
    ) -> None:
        ...

    def glTranslated(self, x: float, y: float, z: float) -> None:
        ...

    def glTranslatef(self, x: float, y: float, z: float) -> None:
        ...

    def glVertex2d(self, x: float, y: float) -> None:
        ...

    def glVertex2dv(self, v: typing.Sequence) -> None:
        ...

    def glVertex2f(self, x: float, y: float) -> None:
        ...

    def glVertex2fv(self, v: typing.Sequence) -> None:
        ...

    def glVertex2i(self, x: int, y: int) -> None:
        ...

    def glVertex2iv(self, v: typing.Sequence) -> None:
        ...

    def glVertex2s(self, x: int, y: int) -> None:
        ...

    def glVertex2sv(self, v: typing.Sequence) -> None:
        ...

    def glVertex3d(self, x: float, y: float, z: float) -> None:
        ...

    def glVertex3dv(self, v: typing.Sequence) -> None:
        ...

    def glVertex3f(self, x: float, y: float, z: float) -> None:
        ...

    def glVertex3fv(self, v: typing.Sequence) -> None:
        ...

    def glVertex3i(self, x: int, y: int, z: int) -> None:
        ...

    def glVertex3iv(self, v: typing.Sequence) -> None:
        ...

    def glVertex3s(self, x: int, y: int, z: int) -> None:
        ...

    def glVertex3sv(self, v: typing.Sequence) -> None:
        ...

    def glVertex4d(self, x: float, y: float, z: float, w: float) -> None:
        ...

    def glVertex4dv(self, v: typing.Sequence) -> None:
        ...

    def glVertex4f(self, x: float, y: float, z: float, w: float) -> None:
        ...

    def glVertex4fv(self, v: typing.Sequence) -> None:
        ...

    def glVertex4i(self, x: int, y: int, z: int, w: int) -> None:
        ...

    def glVertex4iv(self, v: typing.Sequence) -> None:
        ...

    def glVertex4s(self, x: int, y: int, z: int, w: int) -> None:
        ...

    def glVertex4sv(self, v: typing.Sequence) -> None:
        ...

    def glViewport(self, x: int, y: int, width: int, height: int) -> None:
        ...

    def initializeOpenGLFunctions(self) -> bool:
        ...
