"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtPositioning, except for defaults which are replaced by "...".
"""
import PySide2
import PySide2.QtCore
import PySide2.QtPositioning

bytes = str


class QGeoPositionInfoSourceFactory(object):
    """
    https://doc.qt.io/qt-5/qgeopositioninfosourcefactory.html

    **Detailed Description**

    The other functions must be overridden by all plugins, other than
    sourcePriority() which defaults to returning 0. Higher values of priority
    will be preferred to lower ones.
    """

    def __init__(self) -> None:
        ...

    def areaMonitor(
        self, parent: PySide2.QtCore.QObject
    ) -> PySide2.QtPositioning.QGeoAreaMonitorSource:
        """
        https://doc.qt.io/qt-5/qgeopositioninfosourcefactory.html#areaMonitor

        **[pure virtual] QGeoAreaMonitorSource
        *QGeoPositionInfoSourceFactory::areaMonitor(QObject * parent )**

        Returns a new **QGeoAreaMonitorSource**  associated with this plugin
        with parent **parent**. Can also return 0, in which case the plugin
        loader will use the factory with the next highest priority.
        """
        ...

    def positionInfoSource(
        self, parent: PySide2.QtCore.QObject
    ) -> PySide2.QtPositioning.QGeoPositionInfoSource:
        """
        https://doc.qt.io/qt-5/qgeopositioninfosourcefactory.html#positionInfoSo
        urce

        **[pure virtual] QGeoPositionInfoSource
        *QGeoPositionInfoSourceFactory::positionInfoSource(QObject * parent )**

        Returns a new **QGeoPositionInfoSource**  associated with this plugin
        with parent **parent**. Can also return 0, in which case the plugin
        loader will use the factory with the next highest priority.
        """
        ...

    def satelliteInfoSource(
        self, parent: PySide2.QtCore.QObject
    ) -> PySide2.QtPositioning.QGeoSatelliteInfoSource:
        """
        https://doc.qt.io/qt-5/qgeopositioninfosourcefactory.html#satelliteInfoS
        ource

        **[pure virtual] QGeoSatelliteInfoSource
        *QGeoPositionInfoSourceFactory::satelliteInfoSource(QObject * parent )**

        Returns a new **QGeoSatelliteInfoSource**  associated with this plugin
        with parent **parent**. Can also return 0, in which case the plugin
        loader will use the factory with the next highest priority.
        """
        ...
