"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtQuick, except for defaults which are replaced by "...".
"""
import PySide2
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtQml
import PySide2.QtQuick

bytes = str


class QQuickItemGrabResult(PySide2.QtCore.QObject):
    """
    https://doc.qt.io/qt-5/qquickitemgrabresult.html

    **Detailed Description**

    **See also** **QQuickItem::grabToImage** ().
    """

    def event(self, arg__1: PySide2.QtCore.QEvent) -> bool:
        ...

    def image(self) -> PySide2.QtGui.QImage:
        """
        https://doc.qt.io/qt-5/qquickitemgrabresult.html#image-prop

        **image : const QImage**

        This property holds the pixel results from a grab.

        If the grab is not yet complete or if it failed, a null image is
        returned (`image.isNull()` will return `true`).

        **Access functions:**

        QImage **image** () const
        """
        ...

    def saveToFile(self, fileName: str) -> bool:
        """
        https://doc.qt.io/qt-5/qquickitemgrabresult.html#saveToFile

        **bool QQuickItemGrabResult::saveToFile(const QString & fileName )
        const**

        Saves the grab result as an image to **fileName**. Returns true if
        successful; otherwise returns false.

        **Note:** In Qt versions prior to 5.9, this function is marked as
        non-`const`.

        **Note:** This function can be invoked via the meta-object system and
        from QML. See **Q_INVOKABLE** .
        """
        ...

    def url(self) -> PySide2.QtCore.QUrl:
        """
        https://doc.qt.io/qt-5/qquickitemgrabresult.html#url-prop

        **url : const QUrl**

        This property holds a URL which can be used in conjunction with URL
        based image consumers, such as the **QtQuick::Image**  type.

        The URL is valid until the **QQuickItemGrabResult**  object is deleted.

        The URL does not represent a valid file or location to read it from, it
        is primarily a key to access images through Qt Quick's image-based
        types.

        **Access functions:**

        QUrl **url** () const

        **Member Function Documentation**
        """
        ...

    @property
    def ready(self) -> PySide2.QtCore.SignalInstance:
        """
        https://doc.qt.io/qt-5/qquickitemgrabresult.html#ready

        **[signal] void QQuickItemGrabResult::ready()**

        This signal is emitted when the grab has completed.
        """
        ...
