"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtScript, except for defaults which are replaced by "...".
"""
import PySide2
import PySide2.QtCore
import PySide2.QtScript

bytes = str


class QScriptClassPropertyIterator(object):
    """
    https://doc.qt.io/qt-5/qscriptclasspropertyiterator.html

    **Detailed Description**

    This class is only relevant if you have subclassed **QScriptClass**  and
    want to provide enumeration of your custom properties (e.g. when objects of
    your class are used with **QScriptValueIterator** , or with the for-in
    statement in scripts).

    The **object** () function returns the Qt Script object the iterator is
    traversing.

    **toFront** (), **hasNext** () and **next** () provide forward iteration.

    **toBack** (), **hasPrevious** () and **previous** () provide backward
    iteration.

    **name** (), **id** () and **flags** () return information about the last
    property that was jumped over using **next** () or **previous** ().

    **See also** **QScriptClass::newIterator** () and **QScriptValueIterator** .
    """

    def __init__(self, object: PySide2.QtScript.QScriptValue) -> None:
        """
        https://doc.qt.io/qt-5/qscriptclasspropertyiterator.html#QScriptClassPro
        pertyIterator

        **[protected]
        QScriptClassPropertyIterator::QScriptClassPropertyIterator(const
        QScriptValue & object )**

        Constructs an iterator for traversing **object**.

        Subclasses should ensure that the iterator is set to the front of the
        sequence of properties (before the first property).
        """
        ...

    def flags(self) -> PySide2.QtScript.QScriptValue.PropertyFlags:
        """
        https://doc.qt.io/qt-5/qscriptclasspropertyiterator.html#flags

        **[virtual] QScriptValue::PropertyFlags
        QScriptClassPropertyIterator::flags() const**

        Returns the flags of the last property that was jumped over using
        **next** () or **previous** ().

        The default implementation calls the propertyFlags() function of
        **object** () with argument **name** ().
        """
        ...

    def hasNext(self) -> bool:
        """
        https://doc.qt.io/qt-5/qscriptclasspropertyiterator.html#hasNext

        **[pure virtual] bool QScriptClassPropertyIterator::hasNext() const**

        Returns true if there is at least one item ahead of the iterator (i.e.
        the iterator is **not** at the back of the property sequence); otherwise
        returns false.

        **See also** **next** () and **hasPrevious** ().
        """
        ...

    def hasPrevious(self) -> bool:
        """
        https://doc.qt.io/qt-5/qscriptclasspropertyiterator.html#hasPrevious

        **[pure virtual] bool QScriptClassPropertyIterator::hasPrevious()
        const**

        Returns true if there is at least one item behind the iterator (i.e. the
        iterator is **not** at the front of the property sequence); otherwise
        returns false.

        **See also** **previous** () and **hasNext** ().
        """
        ...

    def id(self) -> int:
        """
        https://doc.qt.io/qt-5/qscriptclasspropertyiterator.html#id

        **[virtual] uint QScriptClassPropertyIterator::id() const**

        Returns the id of the last property that was jumped over using **next**
        () or **previous** ().

        The default implementation returns 0.

        **See also** **name** ().
        """
        ...

    def name(self) -> PySide2.QtScript.QScriptString:
        """
        https://doc.qt.io/qt-5/qscriptclasspropertyiterator.html#name

        **[pure virtual] QScriptString QScriptClassPropertyIterator::name()
        const**

        Returns the name of the last property that was jumped over using
        **next** () or **previous** ().

        **See also** **id** ().
        """
        ...

    def next(self) -> None:
        """
        https://doc.qt.io/qt-5/qscriptclasspropertyiterator.html#next

        **[pure virtual] void QScriptClassPropertyIterator::next()**

        Advances the iterator by one position.

        Calling this function on an iterator located at the back of the
        container leads to undefined results.

        **See also** **hasNext** (), **previous** (), and **name** ().
        """
        ...

    def object(self) -> PySide2.QtScript.QScriptValue:
        """
        https://doc.qt.io/qt-5/qscriptclasspropertyiterator.html#object

        **QScriptValue QScriptClassPropertyIterator::object() const**

        Returns the Qt Script object this iterator is traversing.
        """
        ...

    def previous(self) -> None:
        """
        https://doc.qt.io/qt-5/qscriptclasspropertyiterator.html#previous

        **[pure virtual] void QScriptClassPropertyIterator::previous()**

        Moves the iterator back by one position.

        Calling this function on an iterator located at the front of the
        container leads to undefined results.

        **See also** **hasPrevious** (), **next** (), and **name** ().
        """
        ...

    def toBack(self) -> None:
        """
        https://doc.qt.io/qt-5/qscriptclasspropertyiterator.html#toBack

        **[pure virtual] void QScriptClassPropertyIterator::toBack()**

        Moves the iterator to the back of the **QScriptValue**  (after the last
        property).

        **See also** **toFront** () and **previous** ().
        """
        ...

    def toFront(self) -> None:
        """
        https://doc.qt.io/qt-5/qscriptclasspropertyiterator.html#toFront

        **[pure virtual] void QScriptClassPropertyIterator::toFront()**

        Moves the iterator to the front of the **QScriptValue**  (before the
        first property).

        **See also** **toBack** () and **next** ().
        """
        ...
