"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtScript, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtScript

bytes = str


class QScriptString(object):
    """
    https://doc.qt.io/qt-5/qscriptstring.html

    **Detailed Description**

    QScriptString can be used to achieve faster (repeated) property
    getting/setting, and comparison of property names, of script objects.

    To get a QScriptString representation of a string, pass the string to
    **QScriptEngine::toStringHandle** (). The typical usage pattern is to
    register one or more pre-defined strings when setting up your script
    environment, then subsequently use the relevant QScriptString as argument to
    e.g. **QScriptValue::property** ().

    Call the **toString** () function to obtain the string that a QScriptString
    represents.

    Call the **toArrayIndex** () function to convert a QScriptString to an array
    index. This is useful when using **QScriptClass**  to implement array-like
    objects.
    """

    @typing.overload
    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-5/qscriptstring.html#QScriptString

        **QScriptString::QScriptString()**

        Constructs an invalid QScriptString.
        """
        ...

    @typing.overload
    def __init__(self, other: PySide2.QtScript.QScriptString) -> None:
        """
        https://doc.qt.io/qt-5/qscriptstring.html#QScriptString-1

        **QScriptString::QScriptString(const QScriptString & other )**

        Constructs a new QScriptString that is a copy of **other**.
        """
        ...

    @staticmethod
    def __copy__() -> None:
        ...

    def isValid(self) -> bool:
        """
        https://doc.qt.io/qt-5/qscriptstring.html#isValid

        **bool QScriptString::isValid() const**

        Returns true if this **QScriptString**  is valid; otherwise returns
        false.
        """
        ...

    def toArrayIndex(self) -> typing.Tuple:
        """
        https://doc.qt.io/qt-5/qscriptstring.html#toArrayIndex

        **quint32 QScriptString::toArrayIndex(bool * ok = nullptr) const**

        Attempts to convert this **QScriptString**  to a Qt Script array index,
        and returns the result.

        If a conversion error occurs, * **ok** is set to false; otherwise *
        **ok** is set to true.

        This function was introduced in Qt 4.6.
        """
        ...

    def toString(self) -> str:
        """
        https://doc.qt.io/qt-5/qscriptstring.html#toString

        **QString QScriptString::toString() const**

        Returns the string that this **QScriptString**  represents, or a null
        string if this **QScriptString**  is not valid.

        **See also** **isValid** ().
        """
        ...
