"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtScriptTools, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtWidgets
import PySide2.QtScript
import PySide2.QtScriptTools

bytes = str


class QScriptEngineDebugger(PySide2.QtCore.QObject):
    """
    https://doc.qt.io/qt-5/qscriptenginedebugger.html

    **Detailed Description**

    The QScriptEngineDebugger class provides a debugger that can be embedded
    into Qt applications that use Qt Script. The debugger enables the
    application user to inspect the state of the script environment and control
    script execution.

    To attach the debugger to a script engine, call the **attachTo** ()
    function.

    **QScriptEngine**  engine;
            **QScriptEngineDebugger**  debugger;
    debugger.attachTo(&engine);

    Once the debugger has been attached to a script engine, you can proceed to
    evaluate scripts as usual, e.g. by calling **QScriptEngine::evaluate** ().
    The debugger will be triggered when an uncaught exception occurs, or when a
    `debugger` statement is encountered in a script. It is also possible to
    interrupt script evaluation at an arbitrary time by triggering the
    **InterruptAction** . For instance, to start the debugger when script
    evaluation starts, you trigger the action before you begin to **evaluate()**
    the script.

    debugger->action(**QScriptEngineDebugger** ::InterruptAction)->trigger();
    engine->evaluate(contents, fileName);

    By default, the **standard debugger window**  is shown when evaluation is
    suspended. This can be changed by calling the **setAutoShowStandardWindow**
    () function.

    The debugger defines a set of **actions**  that are available, such as
    stopping execution or printing the contents of a variable. It also provides
    a set of widgets (components) that display the information available from
    the debugger and that trigger the actions on request. The actions available
    are identified by the **DebuggerAction**  enum, and the widgets are
    identified by the **DebuggerWidget**  enum.

    Access to the individual debugger widgets is provided by the **widget** ()
    function. This makes it possible to arrange the widgets in a custom manner.
    Similarly, the **action** () function provides access to the various
    debugger actions.

    The **createStandardToolBar** () function creates a standard toolbar, and
    the **createStandardMenu** () function creates a standard menu; these
    functions can be useful if you are creating a custom debugger configuration.

    The **evaluationSuspended** () signal is emitted when the debugger has
    suspended script evaluation and entered interactive mode, i.e., the mode in
    which it accepts input from the user. The **evaluationResumed** () signal is
    emitted when script evaluation is resumed, i.e, when execution control is
    given back to the script engine. The **state** () function returns the
    debugger's current state.

    When calling **QScriptEngine::evaluate** () it is useful to pass a
    descriptive script name (file name) as second argument, as this is the name
    that will be displayed by the debugger in the **ScriptsWidget** ; if a name
    is not passed, the script will be labelled "anonymous".

    When evaluation is suspended, the debugger will also suspend the event loop
    of the script. In the following snippet, the call to
    **QScriptEngine::evaluate** () causes the debugger to be triggered, and the
    function call does not return until the user has finished interacting with
    the debugger.

    engine.evaluate("debugger");

    When the Qt Script debugger is running, the C++ application itself is not
    "frozen". This means that it is possible that more scripts are evaluated,
    even though the debugger has suspended evaluation of the **current** script
    evaluation. For example, a C++ timer might trigger that causes a script
    function to be called, or the user might click on a button in the main
    application user interface whose clicked() signal is connected to a script
    function. This kind of nested evaluation is permitted. The debugger will
    enter interactive mode for the new script if an exception is thrown or a
    breakpoint is reached. Note that it will not stop when encountering
    `debugger` statements.

    Nested evaluation requires some thought when deciding how the debugger is
    presented to the user; for example, whether a modal dialog is suitable, or
    whether some parts of the main application user interface should be disabled
    while the debugger is running.

    Debugging inside of a **paintEvent** () is currently not supported. If you
    need to debug painting-related script code, that code should be evaluated
    outside of the C++ paintEvent(), e.g. by rendering to an image, like the
    Context2D and Tetrix Qt Script examples do. This will make the code safe for
    debugging.

    The debugger adds some special properties to the script engine: `__FILE__`
    holds the name of the script in which the current evaluation occurs, and
    `__LINE__` holds the current line number. These are useful when doing
    print()-style debugging (the messages appear in the debugger's debug output
    widget).

    The **Qt Script Debugger Manual**  describes how to use the debugger. The
    **Context2D example**  shows how to integrate the debugger in applications.

    **See also** **QScriptEngine**  and **Context2D Example** .
    """

    ConsoleWidget: QScriptEngineDebugger = ...
    InterruptAction: QScriptEngineDebugger = ...
    RunningState: QScriptEngineDebugger = ...
    ContinueAction: QScriptEngineDebugger = ...
    StackWidget: QScriptEngineDebugger = ...
    SuspendedState: QScriptEngineDebugger = ...
    ScriptsWidget: QScriptEngineDebugger = ...
    StepIntoAction: QScriptEngineDebugger = ...
    LocalsWidget: QScriptEngineDebugger = ...
    StepOverAction: QScriptEngineDebugger = ...
    CodeWidget: QScriptEngineDebugger = ...
    StepOutAction: QScriptEngineDebugger = ...
    CodeFinderWidget: QScriptEngineDebugger = ...
    RunToCursorAction: QScriptEngineDebugger = ...
    BreakpointsWidget: QScriptEngineDebugger = ...
    RunToNewScriptAction: QScriptEngineDebugger = ...
    DebugOutputWidget: QScriptEngineDebugger = ...
    ToggleBreakpointAction: QScriptEngineDebugger = ...
    ClearDebugOutputAction: QScriptEngineDebugger = ...
    ErrorLogWidget: QScriptEngineDebugger = ...
    ClearErrorLogAction: QScriptEngineDebugger = ...
    ClearConsoleAction: QScriptEngineDebugger = ...
    FindInScriptAction: QScriptEngineDebugger = ...
    FindNextInScriptAction: QScriptEngineDebugger = ...
    FindPreviousInScriptAction: QScriptEngineDebugger = ...
    GoToLineAction: QScriptEngineDebugger = ...

    class DebuggerAction(object):
        InterruptAction: QScriptEngineDebugger.DebuggerAction = ...
        ContinueAction: QScriptEngineDebugger.DebuggerAction = ...
        StepIntoAction: QScriptEngineDebugger.DebuggerAction = ...
        StepOverAction: QScriptEngineDebugger.DebuggerAction = ...
        StepOutAction: QScriptEngineDebugger.DebuggerAction = ...
        RunToCursorAction: QScriptEngineDebugger.DebuggerAction = ...
        RunToNewScriptAction: QScriptEngineDebugger.DebuggerAction = ...
        ToggleBreakpointAction: QScriptEngineDebugger.DebuggerAction = ...
        ClearDebugOutputAction: QScriptEngineDebugger.DebuggerAction = ...
        ClearErrorLogAction: QScriptEngineDebugger.DebuggerAction = ...
        ClearConsoleAction: QScriptEngineDebugger.DebuggerAction = ...
        FindInScriptAction: QScriptEngineDebugger.DebuggerAction = ...
        FindNextInScriptAction: QScriptEngineDebugger.DebuggerAction = ...
        FindPreviousInScriptAction: QScriptEngineDebugger.DebuggerAction = ...
        GoToLineAction: QScriptEngineDebugger.DebuggerAction = ...

    class DebuggerState(object):
        RunningState: QScriptEngineDebugger.DebuggerState = ...
        SuspendedState: QScriptEngineDebugger.DebuggerState = ...

    class DebuggerWidget(object):
        ConsoleWidget: QScriptEngineDebugger.DebuggerWidget = ...
        StackWidget: QScriptEngineDebugger.DebuggerWidget = ...
        ScriptsWidget: QScriptEngineDebugger.DebuggerWidget = ...
        LocalsWidget: QScriptEngineDebugger.DebuggerWidget = ...
        CodeWidget: QScriptEngineDebugger.DebuggerWidget = ...
        CodeFinderWidget: QScriptEngineDebugger.DebuggerWidget = ...
        BreakpointsWidget: QScriptEngineDebugger.DebuggerWidget = ...
        DebugOutputWidget: QScriptEngineDebugger.DebuggerWidget = ...
        ErrorLogWidget: QScriptEngineDebugger.DebuggerWidget = ...

    def __init__(self, parent: typing.Optional[PySide2.QtCore.QObject] = ...) -> None:
        """
        https://doc.qt.io/qt-5/qscriptenginedebugger.html#QScriptEngineDebugger

        **QScriptEngineDebugger::QScriptEngineDebugger(QObject * parent =
        nullptr)**

        Constructs a new QScriptEngineDebugger object with the given **parent**.

        To attach a **QScriptEngine**  to the debugger, use **attachTo** ()
        function.
        """
        ...

    def action(
        self, action: PySide2.QtScriptTools.QScriptEngineDebugger.DebuggerAction
    ) -> PySide2.QtWidgets.QAction:
        """
        https://doc.qt.io/qt-5/qscriptenginedebugger.html#action

        **QAction
        *QScriptEngineDebugger::action(QScriptEngineDebugger::DebuggerAction
        action ) const**

        Returns a pointer to the specified **action**. The actions available are
        given by the **DebuggerAction**  enum.

        With this function, you can add the actions to your own widgets,
        toolbars, and menus. It is also convenient if you, for example, wish to
        spice things up with your own groovy icons. The code example below shows
        how to add actions to a **QToolBar** .

        **QAction**  *continueAction =
        debugger->action(**QScriptEngineDebugger** ::ContinueAction);
        **QAction**  *stepOverAction =
        debugger->action(**QScriptEngineDebugger** ::StepOverAction);
        **QAction**  *stepIntoAction =
        debugger->action(**QScriptEngineDebugger** ::StepIntoAction);
        **QToolBar**  *toolBar = new **QToolBar** ;
        toolBar->addAction(continueAction);

        Note that **QScriptEngineDebugger**  has already added the actions to
        its **standard widgets**  and **standard window** .

        **See also** **widget** (), **createStandardMenu** (),
        **createStandardToolBar** (), and **standardWindow** ().
        """
        ...

    def attachTo(self, engine: PySide2.QtScript.QScriptEngine) -> None:
        """
        https://doc.qt.io/qt-5/qscriptenginedebugger.html#attachTo

        **void QScriptEngineDebugger::attachTo(QScriptEngine * engine )**

        Attaches to the given **engine**.

        The debugger will install a custom agent (using
        **QScriptEngine::setAgent** ()) to monitor the engine. While the
        debugger is attached, you should not change the agent; however, if you
        do have to perform additional monitoring, you must set a proxy agent
        that forwards all events to the debugger's agent.

        **See also** **detach** ().
        """
        ...

    def autoShowStandardWindow(self) -> bool:
        """
        https://doc.qt.io/qt-5/qscriptenginedebugger.html#autoShowStandardWindow

        **bool QScriptEngineDebugger::autoShowStandardWindow() const**

        Returns whether the standard debugger window is automatically shown when
        evaluation is suspended.

        The default is true.

        **See also** **setAutoShowStandardWindow** ().
        """
        ...

    def createStandardMenu(
        self, parent: typing.Optional[PySide2.QtWidgets.QWidget] = ...
    ) -> PySide2.QtWidgets.QMenu:
        """
        https://doc.qt.io/qt-5/qscriptenginedebugger.html#createStandardMenu

        **QMenu *QScriptEngineDebugger::createStandardMenu(QWidget * parent =
        nullptr)**

        Creates a standard debugger menu with the given **parent**. Returns the
        new menu object.

        **See also** **createStandardToolBar** ().
        """
        ...

    def createStandardToolBar(
        self, parent: typing.Optional[PySide2.QtWidgets.QWidget] = ...
    ) -> PySide2.QtWidgets.QToolBar:
        """
        https://doc.qt.io/qt-5/qscriptenginedebugger.html#createStandardToolBar

        **QToolBar *QScriptEngineDebugger::createStandardToolBar(QWidget *
        parent = nullptr)**

        Creates a standard debugger toolbar with the given **parent**. Returns
        the new toolbar object.

        **See also** **createStandardMenu** ().
        """
        ...

    def setAutoShowStandardWindow(self, autoShow: bool) -> None:
        """
        https://doc.qt.io/qt-5/qscriptenginedebugger.html#setAutoShowStandardWin
        dow

        **void QScriptEngineDebugger::setAutoShowStandardWindow(bool autoShow
        )**

        Sets whether the standard debugger window is automatically shown when
        evaluation is suspended. If **autoShow** is true, the window will be
        automatically shown, otherwise it will not.

        **See also** **autoShowStandardWindow** ().
        """
        ...

    def standardWindow(self) -> PySide2.QtWidgets.QMainWindow:
        """
        https://doc.qt.io/qt-5/qscriptenginedebugger.html#standardWindow

        **QMainWindow *QScriptEngineDebugger::standardWindow() const**

        Returns a main window with a standard configuration of the debugger's
        components.

        **See also** **createStandardMenu** () and **createStandardToolBar** ().
        """
        ...

    def state(self) -> PySide2.QtScriptTools.QScriptEngineDebugger.DebuggerState:
        """
        https://doc.qt.io/qt-5/qscriptenginedebugger.html#state

        **QScriptEngineDebugger::DebuggerState QScriptEngineDebugger::state()
        const**

        Returns the current state of the debugger.

        This function was introduced in Qt 4.6.

        **See also** **evaluationResumed** () and **evaluationSuspended** ().
        """
        ...

    def widget(
        self, widget: PySide2.QtScriptTools.QScriptEngineDebugger.DebuggerWidget
    ) -> PySide2.QtWidgets.QWidget:
        """
        https://doc.qt.io/qt-5/qscriptenginedebugger.html#widget

        **QWidget
        *QScriptEngineDebugger::widget(QScriptEngineDebugger::DebuggerWidget
        widget ) const**

        Returns a pointer to the instance of the specified standard **widget**.
        The widgets available are defined by the **DebuggerWidget**  enum.

        A main window containing all widgets is returned by **standardWindow**
        (). If you do not want to use this window, you can fetch the individual
        widgets with this function. For instance, the code example below shows
        how to set up a layout containing a **code window**  and a **stack
        widget** .

        **QWidget**  *codeWindow = debugger->widget(**QScriptEngineDebugger**
        ::CodeWidget);
                **QWidget**  *stackWidget =
        debugger->widget(**QScriptEngineDebugger** ::StackWidget);
        **QLayout**  *layout = new **QHBoxLayout** ;
        layout->addWidget(codeWindow);
                layout->addWidget(stackWidget);

        Note that you need to set **setAutoShowStandardWindow** () to false; if
        not, the standard window will be shown regardless.

        **See also** **action** (), **standardWindow** (), and
        **setAutoShowStandardWindow** ().
        """
        ...

    @property
    def evaluationResumed(self) -> PySide2.QtCore.SignalInstance:
        """
        https://doc.qt.io/qt-5/qscriptenginedebugger.html#evaluationResumed

        **[signal] void QScriptEngineDebugger::evaluationResumed()**

        This signal is emitted when the debugger has resumed script evaluation
        (e.g. the user gave the "continue" command).

        **See also** **evaluationSuspended** ().
        """
        ...

    @property
    def evaluationSuspended(self) -> PySide2.QtCore.SignalInstance:
        """
        https://doc.qt.io/qt-5/qscriptenginedebugger.html#evaluationSuspended

        **[signal] void QScriptEngineDebugger::evaluationSuspended()**

        This signal is emitted when the debugger has suspended script evaluation
        for whatever reason (e.g. due to an uncaught script exception, or due to
        a breakpoint being triggered).

        **See also** **evaluationResumed** ().
        """
        ...
