"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtSensors, except for defaults which are replaced by "...".
"""
import PySide2
import PySide2.QtCore
import PySide2.QtSensors

bytes = str


class QDistanceReading(PySide2.QtSensors.QSensorReading):
    """
    https://doc.qt.io/qt-5/qdistancereading.html

    **Detailed Description**

    The QDistanceReading class holds distance reading in cm from the proximity
    sensor. Note: Some proximity sensor only support two values for distance, a
    near and far value. In this case, the sensor should report its maximum range
    value to represent the far state, and a lesser value to represent the near
    state.

    **QDistanceReading Units**

    The distance is measured in cm

    The distance sensor is typically located in the front face of a device, and
    thus will measure the distance of an object from the device's front face.
    """

    def __init__(self, parent: PySide2.QtCore.QObject) -> None:
        ...

    def copyValuesFrom(self, other: PySide2.QtSensors.QSensorReading) -> None:
        ...

    def distance(self) -> float:
        """
        https://doc.qt.io/qt-5/qdistancereading.html#distance-prop

        **distance : const qreal**

        distance of object from front face of device

        **Access functions:**

        qreal **distance** () const

        **See also** **QDistanceReading Units** .

        **Member Function Documentation**
        """
        ...

    def setDistance(self, distance: float) -> None:
        """
        https://doc.qt.io/qt-5/qdistancereading.html#setDistance

        **void QDistanceReading::setDistance(qreal distance )**

        Sets distance to **distance**.

        **See also** **distance** ().
        """
        ...
