"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtSensors, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtSensors

bytes = str


class QHolsterSensor(PySide2.QtSensors.QSensor):
    """
    https://doc.qt.io/qt-5/qholstersensor.html

    **Detailed Description**

    The only behavioural difference is that this class sets the type properly.

    This class also features a **reading** () function that returns a
    **QHolsterReading**  instead of a **QSensorReading** .

    For details about how the sensor works, see **QHolsterReading** .

    **See also** **QHolsterReading** .
    """

    def __init__(self, parent: typing.Optional[PySide2.QtCore.QObject] = ...) -> None:
        """
        https://doc.qt.io/qt-5/qholstersensor.html#QHolsterSensor

        **QHolsterSensor::QHolsterSensor(QObject * parent = Q_NULLPTR)**

        Construct the sensor as a child of **parent**.
        """
        ...

    def reading(self) -> PySide2.QtSensors.QHolsterReading:
        """
        https://doc.qt.io/qt-5/qholstersensor.html#reading

        **QHolsterReading *QHolsterSensor::reading() const**

        Returns the reading class for this sensor.

        **See also** **QSensor::reading** ().
        """
        ...
