"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtSensors, except for defaults which are replaced by "...".
"""
import PySide2
import PySide2.QtCore
import PySide2.QtSensors

bytes = str


class QIRProximityReading(PySide2.QtSensors.QSensorReading):
    """
    https://doc.qt.io/qt-5/qirproximityreading.html

    **Detailed Description**

    The IR (infra-red) proximity sensor detects proximity by beaming out infra-
    red light and detecting how much of the light returns.

    The biggest limitation of this technology is that there is no reliable way
    to turn the reflectance values into distances unless both the item being
    detected and the ambient conditions are known.

    **QIRProximityReading Units**

    The sensor reports reflectance as a decimal fraction in the range of 0 - 1.
    That is, 0 indicates nothing was detected within the range of the sensor and
    1 indicates the infra-red signal returned at the full power level that it
    was sent at.

    With some IR sensors, it is quite uncommon to reach the top and the bottom
    of the value range, and some parts of the range ends might not be obtainable
    at all. This is due to the behavior of the sensor hardware. With these
    sensors, the absolute value of reflectance should never be used directly.
    Instead, applications should react to the relative change of the reading
    values. Use **QProximitySensor**  if it is only necessary to check if
    something is close to the device or not.
    """

    def __init__(self, parent: PySide2.QtCore.QObject) -> None:
        ...

    def copyValuesFrom(self, other: PySide2.QtSensors.QSensorReading) -> None:
        ...

    def reflectance(self) -> float:
        """
        https://doc.qt.io/qt-5/qirproximityreading.html#reflectance-prop

        **reflectance : const qreal**

        Holds the reflectance value.

        The reflectance is a decimal fraction (from 0 to 1) indicating how much
        of the transmitted infra-red light was returned.

        **Access functions:**

        qreal **reflectance** () const

        **See also** **QIRProximityReading Units** .

        **Member Function Documentation**
        """
        ...

    def setReflectance(self, reflectance: float) -> None:
        """
        https://doc.qt.io/qt-5/qirproximityreading.html#setReflectance

        **void QIRProximityReading::setReflectance(qreal reflectance )**

        Sets the reflectance value to **reflectance**.

        **See also** **reflectance** ().
        """
        ...
