"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtSensors, except for defaults which are replaced by "...".
"""
import PySide2
import PySide2.QtCore
import PySide2.QtSensors

bytes = str


class QLidReading(PySide2.QtSensors.QSensorReading):
    """
    https://doc.qt.io/qt-5/qlidreading.html

    **Detailed Description**

    A normal laptop has what we call a front lid.

    If the laptop can be converted to a tablet by rotating or closing the lid
    where the display is out, this is known as a back lid.

    **QLidReading Units**

    The Lid sensor can detect if a device's lid is closed or not. A lid can be a
    laptop, a laptop that converts to a tablet, or even a cover for a tablet or
    phone.
    """

    def __init__(self, parent: PySide2.QtCore.QObject) -> None:
        ...

    def backLidClosed(self) -> bool:
        """
        https://doc.qt.io/qt-5/qlidreading.html#backLidClosed-prop

        **backLidClosed : const bool**

        This property holds a value indicating whether the back lid is closed. A
        back lid can be when a convertable laptop is closed into to tablet mode
        without keyboard.

        **Access functions:**

        bool **backLidClosed** () const

        **See also** **QLidReading Units** .
        """
        ...

    def copyValuesFrom(self, other: PySide2.QtSensors.QSensorReading) -> None:
        ...

    def frontLidClosed(self) -> bool:
        """
        https://doc.qt.io/qt-5/qlidreading.html#frontLidClosed-prop

        **frontLidClosed : const bool**

        This property holds a value indicating whether the front lid is closed.
        A front lid would be a normal laptop lid.

        **Access functions:**

        bool **frontLidClosed** () const

        **See also** **QLidReading Units** .

        **Member Function Documentation**
        """
        ...

    def setBackLidClosed(self, closed: bool) -> None:
        """
        https://doc.qt.io/qt-5/qlidreading.html#setBackLidClosed

        **void QLidReading::setBackLidClosed(bool closed )**

        Sets the **backLidClosed**  value to **closed**.

        **See also** **backLidClosed** ().
        """
        ...

    def setFrontLidClosed(self, closed: bool) -> None:
        """
        https://doc.qt.io/qt-5/qlidreading.html#setFrontLidClosed

        **void QLidReading::setFrontLidClosed(bool closed )**

        Sets the **frontLidClosed**  value to **closed**.

        **See also** **frontLidClosed** ().
        """
        ...
