"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtSensors, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtSensors

bytes = str


class QRotationSensor(PySide2.QtSensors.QSensor):
    """
    https://doc.qt.io/qt-5/qrotationsensor.html

    **Detailed Description**

    The only behavioural difference is that this class sets the type properly.

    This class also features a **reading** () function that returns a
    **QRotationReading**  instead of a **QSensorReading** .

    For details about how the sensor works, see **QRotationReading** .

    **See also** **QRotationReading** .
    """

    def __init__(self, parent: typing.Optional[PySide2.QtCore.QObject] = ...) -> None:
        """
        https://doc.qt.io/qt-5/qrotationsensor.html#QRotationSensor

        **QRotationSensor::QRotationSensor(QObject * parent = Q_NULLPTR)**

        Construct the sensor as a child of **parent**.
        """
        ...

    def hasZ(self) -> bool:
        """
        https://doc.qt.io/qt-5/qrotationsensor.html#hasZ-prop

        **hasZ : const bool**

        This property holds a value indicating if the z angle is available.

        Returns true if z is available. Returns false if z is not available.

        **Access functions:**

        bool **hasZ** () const

        **Notifier signal:**

        void **hasZChanged** (bool **hasZ** )

        **Member Function Documentation**
        """
        ...

    def reading(self) -> PySide2.QtSensors.QRotationReading:
        """
        https://doc.qt.io/qt-5/qrotationsensor.html#reading

        **QRotationReading *QRotationSensor::reading() const**

        Returns the reading class for this sensor.

        **See also** **QSensor::reading** ().
        """
        ...

    def setHasZ(self, hasZ: bool) -> None:
        """
        https://doc.qt.io/qt-5/qrotationsensor.html#setHasZ

        **void QRotationSensor::setHasZ(bool hasZ )**

        Sets whether the z angle is available to **hasZ**. This is to be called
        from the backend. By default the **hasZ**  property is true, so a
        backend only has to call this if its rotation sensor can not report z
        angles.

        This function was introduced in Qt 5.1.

        **See also** **hasZ** ().
        """
        ...

    @property
    def hasZChanged(self) -> PySide2.QtCore.SignalInstance:
        ...
