"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtSensors, except for defaults which are replaced by "...".
"""
import typing

bytes = str


class QSensorGesturePluginInterface(object):
    """
    https://doc.qt.io/qt-5/qsensorgestureplugininterface.html

    **Detailed Description**

    The QSensorGesturePluginInterface class is implemented in sensor gesture
    plugins to register sensor gesture recognizers with
    **QSensorGestureManager** .

    **See also** **QtSensorGestures Plugins** .
    """

    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-5/qsensorgestureplugininterface.html#QSensorGesture
        PluginInterface

        **QSensorGesturePluginInterface::QSensorGesturePluginInterface()**

        Construct the QSensorGesturePluginInterface.
        """
        ...

    def createRecognizers(self) -> typing.List:
        """
        https://doc.qt.io/qt-5/qsensorgestureplugininterface.html#createRecogniz
        ers

        **[pure virtual] QList<QSensorGestureRecognizer *>
        QSensorGesturePluginInterface::createRecognizers()**

        Called by the manager to create the recognizers. Plugins should
        initialize and register their recognizers using
        **QSensorGestureManager::registerSensorGestureRecognizer** () here.

        **See also** **QSensorGestureManager** .
        """
        ...

    def name(self) -> str:
        """
        https://doc.qt.io/qt-5/qsensorgestureplugininterface.html#name

        **[pure virtual] QString QSensorGesturePluginInterface::name() const**

        Returns this plugins name.
        """
        ...

    def supportedIds(self) -> typing.List:
        """
        https://doc.qt.io/qt-5/qsensorgestureplugininterface.html#supportedIds

        **[pure virtual] QStringList
        QSensorGesturePluginInterface::supportedIds() const**

        Returns a list of the recognizer Id's that this plugin supports.
        """
        ...
