"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtSensors, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtSensors

bytes = str


class QTapSensor(PySide2.QtSensors.QSensor):
    """
    https://doc.qt.io/qt-5/qtapsensor.html

    **Detailed Description**

    The only behavioural difference is that this class sets the type properly.

    This class also features a **reading** () function that returns a
    **QTapReading**  instead of a **QSensorReading** .

    For details about how the sensor works, see **QTapReading** .

    **See also** **QTapReading** .
    """

    def __init__(self, parent: typing.Optional[PySide2.QtCore.QObject] = ...) -> None:
        """
        https://doc.qt.io/qt-5/qtapsensor.html#QTapSensor

        **QTapSensor::QTapSensor(QObject * parent = Q_NULLPTR)**

        Construct the sensor as a child of **parent**.
        """
        ...

    def reading(self) -> PySide2.QtSensors.QTapReading:
        """
        https://doc.qt.io/qt-5/qtapsensor.html#reading

        **QTapReading *QTapSensor::reading() const**

        Returns the reading class for this sensor.

        **See also** **QSensor::reading** ().
        """
        ...

    def returnDoubleTapEvents(self) -> bool:
        """
        https://doc.qt.io/qt-5/qtapsensor.html#returnDoubleTapEvents-prop

        **returnDoubleTapEvents : bool**

        This property holds a value indicating if double tap events should be
        reported.

        Set to true (the default) to have the sensor report only on double tap
        events. Set to false to have the sensor report only on individual tap
        events.

        It is not possible to have the sensor report both single and double tap
        events. If both are needed the app should create 2 sensor objects.

        The property must be set before calling **start** ().

        **Access functions:**

        bool **returnDoubleTapEvents** () const
        void
        **setReturnDoubleTapEvents** (bool **returnDoubleTapEvents** )

        **Notifier signal:**

        void **returnDoubleTapEventsChanged** (bool **returnDoubleTapEvents** )

        **Member Function Documentation**
        """
        ...

    def setReturnDoubleTapEvents(self, returnDoubleTapEvents: bool) -> None:
        """
        https://doc.qt.io/qt-5/qtapsensor.html#returnDoubleTapEvents-prop

        **returnDoubleTapEvents : bool**

        This property holds a value indicating if double tap events should be
        reported.

        Set to true (the default) to have the sensor report only on double tap
        events. Set to false to have the sensor report only on individual tap
        events.

        It is not possible to have the sensor report both single and double tap
        events. If both are needed the app should create 2 sensor objects.

        The property must be set before calling **start** ().

        **Access functions:**

        bool **returnDoubleTapEvents** () const
        void
        **setReturnDoubleTapEvents** (bool **returnDoubleTapEvents** )

        **Notifier signal:**

        void **returnDoubleTapEventsChanged** (bool **returnDoubleTapEvents** )

        **Member Function Documentation**
        """
        ...

    @property
    def returnDoubleTapEventsChanged(self) -> PySide2.QtCore.SignalInstance:
        ...
