"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtWebEngineWidgets, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets
import PySide2.QtPrintSupport
import PySide2.QtWebChannel
import PySide2.QtWebEngineCore
import PySide2.QtWebEngineWidgets

bytes = str


class QWebEngineScriptCollection(object):
    """
    https://doc.qt.io/qt-5/qwebenginescriptcollection.html

    **Detailed Description**

    QWebEngineScriptCollection manages a set of user scripts.

    Use **QWebEnginePage::scripts** () and **QWebEngineProfile::scripts** () to
    access the collection of scripts associated with a single page or a number
    of pages sharing the same profile.

    **See also** **Script Injection** .
    """

    def clear(self) -> None:
        """
        https://doc.qt.io/qt-5/qwebenginescriptcollection.html#clear

        **void QWebEngineScriptCollection::clear()**

        Removes all scripts from this collection.
        """
        ...

    def contains(self, value: PySide2.QtWebEngineWidgets.QWebEngineScript) -> bool:
        """
        https://doc.qt.io/qt-5/qwebenginescriptcollection.html#contains

        **bool QWebEngineScriptCollection::contains(const QWebEngineScript &
        value ) const**

        Returns `true` if the collection contains an occurrence of **value** ;
        otherwise returns `false`.
        """
        ...

    def count(self) -> int:
        """
        https://doc.qt.io/qt-5/qwebenginescriptcollection.html#count

        **int QWebEngineScriptCollection::count() const**

        Returns the number of elements in the collection.
        """
        ...

    def findScript(self, name: str) -> PySide2.QtWebEngineWidgets.QWebEngineScript:
        """
        https://doc.qt.io/qt-5/qwebenginescriptcollection.html#findScript

        **QWebEngineScript QWebEngineScriptCollection::findScript(const QString
        & name ) const**

        Returns the first script found in the collection with the name **name**
        , or a null **QWebEngineScript**  if none was found.

        **Note:** The order in which the script collection is traversed is
        undefined, which means this should be used when the unicity is
        guaranteed at the application level.

        **See also** **findScripts** ().
        """
        ...

    def findScripts(self, name: str) -> typing.List:
        """
        https://doc.qt.io/qt-5/qwebenginescriptcollection.html#findScripts

        **QList<QWebEngineScript> QWebEngineScriptCollection::findScripts(const
        QString & name ) const**

        Returns the list of scripts in the collection with the name **name** ,
        or an empty list if none was found.
        """
        ...

    @typing.overload
    def insert(self, arg__1: PySide2.QtWebEngineWidgets.QWebEngineScript) -> None:
        """
        https://doc.qt.io/qt-5/qwebenginescriptcollection.html#insert

        **void QWebEngineScriptCollection::insert(const QWebEngineScript & s )**

        Inserts the script **s** into the collection.
        """
        ...

    @typing.overload
    def insert(self, list: typing.Sequence) -> None:
        """
        https://doc.qt.io/qt-5/qwebenginescriptcollection.html#insert-1

        **void QWebEngineScriptCollection::insert(const QList<QWebEngineScript>
        & list )**

        Inserts scripts from the list **list** into the collection.
        """
        ...

    def isEmpty(self) -> bool:
        """
        https://doc.qt.io/qt-5/qwebenginescriptcollection.html#isEmpty

        **bool QWebEngineScriptCollection::isEmpty() const**

        Returns `true` if the collection is empty; otherwise returns `false`.
        """
        ...

    def remove(self, arg__1: PySide2.QtWebEngineWidgets.QWebEngineScript) -> bool:
        """
        https://doc.qt.io/qt-5/qwebenginescriptcollection.html#remove

        **bool QWebEngineScriptCollection::remove(const QWebEngineScript &
        script )**

        Removes **script** from the collection.

        Returns `true` if the script was found and successfully removed from the
        collection; otherwise returns `false`.
        """
        ...

    def size(self) -> int:
        """
        https://doc.qt.io/qt-5/qwebenginescriptcollection.html#size

        **int QWebEngineScriptCollection::size() const**

        Returns the number of elements in the collection.
        """
        ...

    def toList(self) -> typing.List:
        """
        https://doc.qt.io/qt-5/qwebenginescriptcollection.html#toList

        **QList<QWebEngineScript> QWebEngineScriptCollection::toList() const**

        Returns a list with the values of the scripts used in this collection.
        """
        ...
