"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtWebEngineWidgets, except for defaults which are replaced by "...".
"""
import PySide2
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets
import PySide2.QtPrintSupport
import PySide2.QtWebChannel
import PySide2.QtWebEngineCore
import PySide2.QtWebEngineWidgets

bytes = str


class QWebEngineSettings(object):
    """
    https://doc.qt.io/qt-5/qwebenginesettings.html

    **Detailed Description**

    QWebEngineSettings allows configuration of browser properties, such as font
    sizes and families, the location of a custom style sheet, and generic
    attributes, such as JavaScript support. Individual attributes are set using
    the **setAttribute** () function. The **WebAttribute**  enum further
    describes each attribute.

    Each **QWebEnginePage**  object has its own QWebEngineSettings object, which
    configures the settings for that page. If a setting is not configured for a
    web engine page, it is looked up in the settings of the profile the page
    belongs to.

    **See also** **QWebEnginePage::settings** () and
    **QWebEngineView::settings** ().
    """

    AutoLoadImages: QWebEngineSettings = ...
    MinimumFontSize: QWebEngineSettings = ...
    StandardFont: QWebEngineSettings = ...
    DisallowUnknownUrlSchemes: QWebEngineSettings = ...
    FixedFont: QWebEngineSettings = ...
    JavascriptEnabled: QWebEngineSettings = ...
    MinimumLogicalFontSize: QWebEngineSettings = ...
    AllowUnknownUrlSchemesFromUserInteraction: QWebEngineSettings = ...
    DefaultFontSize: QWebEngineSettings = ...
    JavascriptCanOpenWindows: QWebEngineSettings = ...
    SerifFont: QWebEngineSettings = ...
    AllowAllUnknownUrlSchemes: QWebEngineSettings = ...
    DefaultFixedFontSize: QWebEngineSettings = ...
    JavascriptCanAccessClipboard: QWebEngineSettings = ...
    SansSerifFont: QWebEngineSettings = ...
    CursiveFont: QWebEngineSettings = ...
    LinksIncludedInFocusChain: QWebEngineSettings = ...
    FantasyFont: QWebEngineSettings = ...
    LocalStorageEnabled: QWebEngineSettings = ...
    LocalContentCanAccessRemoteUrls: QWebEngineSettings = ...
    PictographFont: QWebEngineSettings = ...
    XSSAuditingEnabled: QWebEngineSettings = ...
    SpatialNavigationEnabled: QWebEngineSettings = ...
    LocalContentCanAccessFileUrls: QWebEngineSettings = ...
    HyperlinkAuditingEnabled: QWebEngineSettings = ...
    ScrollAnimatorEnabled: QWebEngineSettings = ...
    ErrorPageEnabled: QWebEngineSettings = ...
    PluginsEnabled: QWebEngineSettings = ...
    FullScreenSupportEnabled: QWebEngineSettings = ...
    ScreenCaptureEnabled: QWebEngineSettings = ...
    WebGLEnabled: QWebEngineSettings = ...
    Accelerated2dCanvasEnabled: QWebEngineSettings = ...
    AutoLoadIconsForPage: QWebEngineSettings = ...
    TouchIconsEnabled: QWebEngineSettings = ...
    FocusOnNavigationEnabled: QWebEngineSettings = ...
    PrintElementBackgrounds: QWebEngineSettings = ...
    AllowRunningInsecureContent: QWebEngineSettings = ...
    AllowGeolocationOnInsecureOrigins: QWebEngineSettings = ...
    AllowWindowActivationFromJavaScript: QWebEngineSettings = ...
    ShowScrollBars: QWebEngineSettings = ...
    PlaybackRequiresUserGesture: QWebEngineSettings = ...
    WebRTCPublicInterfacesOnly: QWebEngineSettings = ...
    JavascriptCanPaste: QWebEngineSettings = ...
    DnsPrefetchEnabled: QWebEngineSettings = ...
    PdfViewerEnabled: QWebEngineSettings = ...

    class FontFamily(object):
        StandardFont: QWebEngineSettings.FontFamily = ...
        FixedFont: QWebEngineSettings.FontFamily = ...
        SerifFont: QWebEngineSettings.FontFamily = ...
        SansSerifFont: QWebEngineSettings.FontFamily = ...
        CursiveFont: QWebEngineSettings.FontFamily = ...
        FantasyFont: QWebEngineSettings.FontFamily = ...
        PictographFont: QWebEngineSettings.FontFamily = ...

    class FontSize(object):
        MinimumFontSize: QWebEngineSettings.FontSize = ...
        MinimumLogicalFontSize: QWebEngineSettings.FontSize = ...
        DefaultFontSize: QWebEngineSettings.FontSize = ...
        DefaultFixedFontSize: QWebEngineSettings.FontSize = ...

    class UnknownUrlSchemePolicy(object):
        DisallowUnknownUrlSchemes: QWebEngineSettings.UnknownUrlSchemePolicy = ...
        AllowUnknownUrlSchemesFromUserInteraction: QWebEngineSettings.UnknownUrlSchemePolicy = (
            ...
        )
        AllowAllUnknownUrlSchemes: QWebEngineSettings.UnknownUrlSchemePolicy = ...

    class WebAttribute(object):
        AutoLoadImages: QWebEngineSettings.WebAttribute = ...
        JavascriptEnabled: QWebEngineSettings.WebAttribute = ...
        JavascriptCanOpenWindows: QWebEngineSettings.WebAttribute = ...
        JavascriptCanAccessClipboard: QWebEngineSettings.WebAttribute = ...
        LinksIncludedInFocusChain: QWebEngineSettings.WebAttribute = ...
        LocalStorageEnabled: QWebEngineSettings.WebAttribute = ...
        LocalContentCanAccessRemoteUrls: QWebEngineSettings.WebAttribute = ...
        XSSAuditingEnabled: QWebEngineSettings.WebAttribute = ...
        SpatialNavigationEnabled: QWebEngineSettings.WebAttribute = ...
        LocalContentCanAccessFileUrls: QWebEngineSettings.WebAttribute = ...
        HyperlinkAuditingEnabled: QWebEngineSettings.WebAttribute = ...
        ScrollAnimatorEnabled: QWebEngineSettings.WebAttribute = ...
        ErrorPageEnabled: QWebEngineSettings.WebAttribute = ...
        PluginsEnabled: QWebEngineSettings.WebAttribute = ...
        FullScreenSupportEnabled: QWebEngineSettings.WebAttribute = ...
        ScreenCaptureEnabled: QWebEngineSettings.WebAttribute = ...
        WebGLEnabled: QWebEngineSettings.WebAttribute = ...
        Accelerated2dCanvasEnabled: QWebEngineSettings.WebAttribute = ...
        AutoLoadIconsForPage: QWebEngineSettings.WebAttribute = ...
        TouchIconsEnabled: QWebEngineSettings.WebAttribute = ...
        FocusOnNavigationEnabled: QWebEngineSettings.WebAttribute = ...
        PrintElementBackgrounds: QWebEngineSettings.WebAttribute = ...
        AllowRunningInsecureContent: QWebEngineSettings.WebAttribute = ...
        AllowGeolocationOnInsecureOrigins: QWebEngineSettings.WebAttribute = ...
        AllowWindowActivationFromJavaScript: QWebEngineSettings.WebAttribute = ...
        ShowScrollBars: QWebEngineSettings.WebAttribute = ...
        PlaybackRequiresUserGesture: QWebEngineSettings.WebAttribute = ...
        WebRTCPublicInterfacesOnly: QWebEngineSettings.WebAttribute = ...
        JavascriptCanPaste: QWebEngineSettings.WebAttribute = ...
        DnsPrefetchEnabled: QWebEngineSettings.WebAttribute = ...
        PdfViewerEnabled: QWebEngineSettings.WebAttribute = ...

    @staticmethod
    def defaultSettings() -> PySide2.QtWebEngineWidgets.QWebEngineSettings:
        """
        https://doc.qt.io/qt-5/qwebenginesettings.html#defaultSettings

        **[static] QWebEngineSettings *QWebEngineSettings::defaultSettings()**

        Returns the settings for a web engine page that belongs to the default
        profile. All web pages not specifically created with another profile
        belong to the default profile.
        """
        ...

    def defaultTextEncoding(self) -> str:
        """
        https://doc.qt.io/qt-5/qwebenginesettings.html#defaultTextEncoding

        **QString QWebEngineSettings::defaultTextEncoding() const**

        Returns the default text encoding.

        **See also** **setDefaultTextEncoding** ().
        """
        ...

    def fontFamily(
        self, which: PySide2.QtWebEngineWidgets.QWebEngineSettings.FontFamily
    ) -> str:
        """
        https://doc.qt.io/qt-5/qwebenginesettings.html#fontFamily

        **QString QWebEngineSettings::fontFamily(QWebEngineSettings::FontFamily
        which ) const**

        Returns the actual font family for the specified generic font family,
        **which**.

        **See also** **setFontFamily** ().
        """
        ...

    def fontSize(
        self, type: PySide2.QtWebEngineWidgets.QWebEngineSettings.FontSize
    ) -> int:
        """
        https://doc.qt.io/qt-5/qwebenginesettings.html#fontSize

        **int QWebEngineSettings::fontSize(QWebEngineSettings::FontSize type )
        const**

        Returns the default font size for **type** in pixels.

        **See also** **setFontSize** ().
        """
        ...

    @staticmethod
    def globalSettings() -> PySide2.QtWebEngineWidgets.QWebEngineSettings:
        ...

    def resetAttribute(
        self, attr: PySide2.QtWebEngineWidgets.QWebEngineSettings.WebAttribute
    ) -> None:
        """
        https://doc.qt.io/qt-5/qwebenginesettings.html#resetAttribute

        **void
        QWebEngineSettings::resetAttribute(QWebEngineSettings::WebAttribute
        attribute )**

        Resets the setting of **attribute** to the value specified in the
        profile that the page belongs to.
        """
        ...

    def resetFontFamily(
        self, which: PySide2.QtWebEngineWidgets.QWebEngineSettings.FontFamily
    ) -> None:
        """
        https://doc.qt.io/qt-5/qwebenginesettings.html#resetFontFamily

        **void
        QWebEngineSettings::resetFontFamily(QWebEngineSettings::FontFamily which
        )**

        Resets the actual font family specified by **which** to the one
        specified in the profile that the page belongs to.
        """
        ...

    def resetFontSize(
        self, type: PySide2.QtWebEngineWidgets.QWebEngineSettings.FontSize
    ) -> None:
        """
        https://doc.qt.io/qt-5/qwebenginesettings.html#resetFontSize

        **void QWebEngineSettings::resetFontSize(QWebEngineSettings::FontSize
        type )**

        Resets the font size for **type** to the size specified in the profile
        that the page belongs to.
        """
        ...

    def resetUnknownUrlSchemePolicy(self) -> None:
        """
        https://doc.qt.io/qt-5/qwebenginesettings.html#resetUnknownUrlSchemePoli
        cy

        **void QWebEngineSettings::resetUnknownUrlSchemePolicy()**

        Removes the policy for handling navigation requests to URLs with unknown
        schemes.

        This function was introduced in Qt 5.11.

        **See also** **unknownUrlSchemePolicy**  and
        **setUnknownUrlSchemePolicy** .
        """
        ...

    def setAttribute(
        self, attr: PySide2.QtWebEngineWidgets.QWebEngineSettings.WebAttribute, on: bool
    ) -> None:
        """
        https://doc.qt.io/qt-5/qwebenginesettings.html#setAttribute

        **void QWebEngineSettings::setAttribute(QWebEngineSettings::WebAttribute
        attribute , bool on )**

        Enables or disables the specified **attribute** feature depending on the
        value of **on**.
        """
        ...

    def setDefaultTextEncoding(self, encoding: str) -> None:
        """
        https://doc.qt.io/qt-5/qwebenginesettings.html#setDefaultTextEncoding

        **void QWebEngineSettings::setDefaultTextEncoding(const QString &
        encoding )**

        Specifies the default text encoding system.

        The value of **encoding** must be a string describing an encoding such
        as "utf-8" or "iso-8859-1". If left empty, a default value will be used.
        For a more extensive list of encoding names see **QTextCodec** .

        **See also** **defaultTextEncoding** ().
        """
        ...

    def setFontFamily(
        self,
        which: PySide2.QtWebEngineWidgets.QWebEngineSettings.FontFamily,
        family: str,
    ) -> None:
        """
        https://doc.qt.io/qt-5/qwebenginesettings.html#setFontFamily

        **void QWebEngineSettings::setFontFamily(QWebEngineSettings::FontFamily
        which , const QString & family )**

        Sets the actual font family to **family** for the specified generic
        family, **which**.

        **See also** **fontFamily** ().
        """
        ...

    def setFontSize(
        self, type: PySide2.QtWebEngineWidgets.QWebEngineSettings.FontSize, size: int
    ) -> None:
        """
        https://doc.qt.io/qt-5/qwebenginesettings.html#setFontSize

        **void QWebEngineSettings::setFontSize(QWebEngineSettings::FontSize type
        , int size )**

        Sets the font size for **type** to **size** in pixels.

        **See also** **fontSize** ().
        """
        ...

    def setUnknownUrlSchemePolicy(
        self,
        policy: PySide2.QtWebEngineWidgets.QWebEngineSettings.UnknownUrlSchemePolicy,
    ) -> None:
        """
        https://doc.qt.io/qt-5/qwebenginesettings.html#setUnknownUrlSchemePolicy

        **void QWebEngineSettings::setUnknownUrlSchemePolicy(QWebEngineSettings:
        :UnknownUrlSchemePolicy policy )**

        Sets the policy for handling navigation requests to URLs with unknown
        schemes to **policy**. Default is
        **QWebEngineSettings::AllowUnknownUrlSchemesFromUserInteraction** .

        This function was introduced in Qt 5.11.

        **See also** **unknownUrlSchemePolicy**  and
        **resetUnknownUrlSchemePolicy** .
        """
        ...

    def testAttribute(
        self, attr: PySide2.QtWebEngineWidgets.QWebEngineSettings.WebAttribute
    ) -> bool:
        """
        https://doc.qt.io/qt-5/qwebenginesettings.html#testAttribute

        **bool
        QWebEngineSettings::testAttribute(QWebEngineSettings::WebAttribute
        attribute ) const**

        Returns `true` if **attribute** is enabled; otherwise returns `false`.
        """
        ...

    def unknownUrlSchemePolicy(
        self,
    ) -> PySide2.QtWebEngineWidgets.QWebEngineSettings.UnknownUrlSchemePolicy:
        """
        https://doc.qt.io/qt-5/qwebenginesettings.html#unknownUrlSchemePolicy

        **QWebEngineSettings::UnknownUrlSchemePolicy
        QWebEngineSettings::unknownUrlSchemePolicy() const**

        Returns the currently selected policy for handling navigation requests
        to URLs with unknown schemes. Default is
        **QWebEngineSettings::AllowUnknownUrlSchemesFromUserInteraction** .

        This function was introduced in Qt 5.11.

        **See also** **setUnknownUrlSchemePolicy**  and
        **resetUnknownUrlSchemePolicy** .
        """
        ...
