"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtWidgets, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets

bytes = str


class QDateEdit(PySide2.QtWidgets.QDateTimeEdit):
    """
    https://doc.qt.io/qt-5/qdateedit.html

    **Detailed Description**

    ![](images/windows-dateedit.png)

    Many of the properties and functions provided by QDateEdit are implemented
    in **QDateTimeEdit** . These are the relevant properties of this class:

    * **date**  holds the date displayed by the widget.
      * **minimumDate**
    defines the minimum (earliest) date that can be set by the user.
      *
    **maximumDate**  defines the maximum (latest) date that can be set by the
    user.
      * **displayFormat**  contains a string that is used to format the
    date displayed in the widget.

    **See also** **QTimeEdit**  and **QDateTimeEdit** .
    """

    @typing.overload
    def __init__(
        self,
        date: PySide2.QtCore.QDate,
        parent: typing.Optional[PySide2.QtWidgets.QWidget] = ...,
    ) -> None:
        """
        https://doc.qt.io/qt-5/qdateedit.html#QDateEdit

        **QDateEdit::QDateEdit(QWidget * parent = nullptr)**

        Constructs an empty date editor with a **parent**.
        """
        ...

    @typing.overload
    def __init__(
        self, parent: typing.Optional[PySide2.QtWidgets.QWidget] = ...
    ) -> None:
        """
        https://doc.qt.io/qt-5/qdateedit.html#QDateEdit-1

        **QDateEdit::QDateEdit(const QDate & date , QWidget * parent =
        nullptr)**

        Constructs an empty date editor with a **parent**. The date is set to
        **date**.
        """
        ...
