"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtWidgets, except for defaults which are replaced by "...".
"""
import PySide2
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets

bytes = str


class QGraphicsSceneMoveEvent(PySide2.QtWidgets.QGraphicsSceneEvent):
    """
    https://doc.qt.io/qt-5/qgraphicsscenemoveevent.html

    **Detailed Description**

    A **QGraphicsWidget**  sends itself a QGraphicsSceneMoveEvent immediately
    when its local position changes. The delivery is implemented as part of
    **QGraphicsItem::itemChange** ().

    It's similar to **QMoveEvent** , but its positions, **oldPos** () and
    **newPos** (), use **QPointF**  instead of **QPoint** .

    **See also** **QGraphicsItem::setPos** (),
    **QGraphicsItem::ItemPositionChange** , and
    **QGraphicsItem::ItemPositionHasChanged** .
    """

    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-5/qgraphicsscenemoveevent.html#QGraphicsSceneMoveEv
        ent-1

        **QGraphicsSceneMoveEvent::QGraphicsSceneMoveEvent()**

        Constructs a QGraphicsSceneMoveEvent.
        """
        ...

    def newPos(self) -> PySide2.QtCore.QPointF:
        """
        https://doc.qt.io/qt-5/qgraphicsscenemoveevent.html#newPos

        **QPointF QGraphicsSceneMoveEvent::newPos() const**

        Returns the new position (i.e., the current position).

        **See also** **oldPos** () and **QGraphicsItem::setPos** ().
        """
        ...

    def oldPos(self) -> PySide2.QtCore.QPointF:
        """
        https://doc.qt.io/qt-5/qgraphicsscenemoveevent.html#oldPos

        **QPointF QGraphicsSceneMoveEvent::oldPos() const**

        Returns the old position (i.e., the position immediately before the
        widget was moved).

        **See also** **newPos** () and **QGraphicsItem::setPos** ().
        """
        ...

    def setNewPos(self, pos: PySide2.QtCore.QPointF) -> None:
        """
        https://doc.qt.io/qt-5/qgraphicsscenemoveevent.html#newPos

        **QPointF QGraphicsSceneMoveEvent::newPos() const**

        Returns the new position (i.e., the current position).

        **See also** **oldPos** () and **QGraphicsItem::setPos** ().
        """
        ...

    def setOldPos(self, pos: PySide2.QtCore.QPointF) -> None:
        """
        https://doc.qt.io/qt-5/qgraphicsscenemoveevent.html#oldPos

        **QPointF QGraphicsSceneMoveEvent::oldPos() const**

        Returns the old position (i.e., the position immediately before the
        widget was moved).

        **See also** **newPos** () and **QGraphicsItem::setPos** ().
        """
        ...
