"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtWidgets, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets

bytes = str


class QPanGesture(PySide2.QtWidgets.QGesture):
    """
    https://doc.qt.io/qt-5/qpangesture.html

    **Detailed Description**

    ![](images/pangesture.png)

    For an overview of gesture handling in Qt and information on using gestures
    in your applications, see the **Gestures in Widgets and Graphics View**
    document.

    **See also** **QPinchGesture**  and **QSwipeGesture** .
    """

    def __init__(self, parent: typing.Optional[PySide2.QtCore.QObject] = ...) -> None:
        ...

    def acceleration(self) -> float:
        """
        https://doc.qt.io/qt-5/qpangesture.html#acceleration-prop

        **acceleration : qreal**

        This property holds the acceleration in the motion of the touch point
        for this gesture

        **Access functions:**

        qreal **acceleration** () const
        void **setAcceleration** (qreal
        **value** )
        """
        ...

    def delta(self) -> PySide2.QtCore.QPointF:
        """
        https://doc.qt.io/qt-5/qpangesture.html#delta-prop

        **delta : const QPointF**

        This property holds the offset from the previous input position to the
        current input

        This is essentially the same as the difference between **offset** () and
        **lastOffset** ().

        **Access functions:**

        QPointF **delta** () const
        """
        ...

    def lastOffset(self) -> PySide2.QtCore.QPointF:
        """
        https://doc.qt.io/qt-5/qpangesture.html#lastOffset-prop

        **lastOffset : QPointF**

        This property holds the last offset recorded for this gesture

        The last offset contains the change in position of the user's input as
        reported in the **offset**  property when a previous gesture event was
        delivered for this gesture.

        If no previous event was delivered with information about this gesture
        (i.e., this gesture object contains information about the first movement
        in the gesture) then this property contains a zero size.

        **Access functions:**

        QPointF **lastOffset** () const
        void **setLastOffset** (const QPointF
        & **value** )
        """
        ...

    def offset(self) -> PySide2.QtCore.QPointF:
        """
        https://doc.qt.io/qt-5/qpangesture.html#offset-prop

        **offset : QPointF**

        This property holds the total offset from the first input position to
        the current input position

        The offset measures the total change in position of the user's input
        covered by the gesture on the input device.

        **Access functions:**

        QPointF **offset** () const
        void **setOffset** (const QPointF &
        **value** )

        **Member Function Documentation**
        """
        ...

    def setAcceleration(self, value: float) -> None:
        """
        https://doc.qt.io/qt-5/qpangesture.html#acceleration-prop

        **acceleration : qreal**

        This property holds the acceleration in the motion of the touch point
        for this gesture

        **Access functions:**

        qreal **acceleration** () const
        void **setAcceleration** (qreal
        **value** )
        """
        ...

    def setLastOffset(self, value: PySide2.QtCore.QPointF) -> None:
        """
        https://doc.qt.io/qt-5/qpangesture.html#lastOffset-prop

        **lastOffset : QPointF**

        This property holds the last offset recorded for this gesture

        The last offset contains the change in position of the user's input as
        reported in the **offset**  property when a previous gesture event was
        delivered for this gesture.

        If no previous event was delivered with information about this gesture
        (i.e., this gesture object contains information about the first movement
        in the gesture) then this property contains a zero size.

        **Access functions:**

        QPointF **lastOffset** () const
        void **setLastOffset** (const QPointF
        & **value** )
        """
        ...

    def setOffset(self, value: PySide2.QtCore.QPointF) -> None:
        """
        https://doc.qt.io/qt-5/qpangesture.html#offset-prop

        **offset : QPointF**

        This property holds the total offset from the first input position to
        the current input position

        The offset measures the total change in position of the user's input
        covered by the gesture on the input device.

        **Access functions:**

        QPointF **offset** () const
        void **setOffset** (const QPointF &
        **value** )

        **Member Function Documentation**
        """
        ...
