"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtWidgets, except for defaults which are replaced by "...".
"""
import PySide2
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets

bytes = str


class QSizeGrip(PySide2.QtWidgets.QWidget):
    """
    https://doc.qt.io/qt-5/qsizegrip.html

    **Detailed Description**

    This widget works like the standard Windows resize handle. In the X11
    version this resize handle generally works differently from the one provided
    by the system if the X11 window manager does not support necessary modern
    post-ICCCM specifications.

    Put this widget anywhere in a widget tree and the user can use it to resize
    the top-level window or any widget with the **Qt::SubWindow**  flag set.
    Generally, this should be in the lower right-hand corner.

    Note that **QStatusBar**  already uses this widget, so if you have a status
    bar (e.g., you are using **QMainWindow** ), then you don't need to use this
    widget explicitly. The same goes for **QDialog** , for which you can just
    call **QDialog::setSizeGripEnabled()** .

    On some platforms the size grip automatically hides itself when the window
    is shown full screen or maximised.

    ![Screenshot of a Fusion style size grip](images/fusion-statusbar-
    sizegrip.png)A size grip widget at the bottom-right corner of a main window,
    shown in the **Fusion widget style** .

    The QSizeGrip class inherits **QWidget**  and reimplements the
    **mousePressEvent()**  and **mouseMoveEvent()**  functions to feature the
    resize functionality, and the **paintEvent()**  function to render the size
    grip widget.

    **See also** **QStatusBar**  and **QWidget::windowState** ().
    """

    def __init__(self, parent: PySide2.QtWidgets.QWidget) -> None:
        """
        https://doc.qt.io/qt-5/qsizegrip.html#QSizeGrip

        **QSizeGrip::QSizeGrip(QWidget * parent )**

        Constructs a resize corner as a child widget of the given **parent**.
        """
        ...

    def event(self, arg__1: PySide2.QtCore.QEvent) -> bool:
        """
        https://doc.qt.io/qt-5/qsizegrip.html#event

        **[override virtual protected] bool QSizeGrip::event(QEvent * event )**

        Reimplements: **QWidget::event** (QEvent *event).
        """
        ...

    def eventFilter(
        self, arg__1: PySide2.QtCore.QObject, arg__2: PySide2.QtCore.QEvent
    ) -> bool:
        """
        https://doc.qt.io/qt-5/qsizegrip.html#eventFilter

        **[override virtual protected] bool QSizeGrip::eventFilter(QObject * o ,
        QEvent * e )**

        Reimplements: **QObject::eventFilter** (QObject *watched, QEvent
        *event).
        """
        ...

    def hideEvent(self, hideEvent: PySide2.QtGui.QHideEvent) -> None:
        """
        https://doc.qt.io/qt-5/qsizegrip.html#hideEvent

        **[override virtual protected] void QSizeGrip::hideEvent(QHideEvent *
        hideEvent )**

        Reimplements: **QWidget::hideEvent** (QHideEvent *event).
        """
        ...

    def mouseMoveEvent(self, arg__1: PySide2.QtGui.QMouseEvent) -> None:
        """
        https://doc.qt.io/qt-5/qsizegrip.html#mouseMoveEvent

        **[override virtual protected] void
        QSizeGrip::mouseMoveEvent(QMouseEvent * event )**

        Reimplements: **QWidget::mouseMoveEvent** (QMouseEvent *event).

        Resizes the top-level widget containing this widget. The mouse move
        event is passed in the **event** parameter.
        """
        ...

    def mousePressEvent(self, arg__1: PySide2.QtGui.QMouseEvent) -> None:
        """
        https://doc.qt.io/qt-5/qsizegrip.html#mousePressEvent

        **[override virtual protected] void
        QSizeGrip::mousePressEvent(QMouseEvent * event )**

        Reimplements: **QWidget::mousePressEvent** (QMouseEvent *event).

        Receives the mouse press events for the widget, and primes the resize
        operation. The mouse press event is passed in the **event** parameter.
        """
        ...

    def mouseReleaseEvent(self, mouseEvent: PySide2.QtGui.QMouseEvent) -> None:
        """
        https://doc.qt.io/qt-5/qsizegrip.html#mouseReleaseEvent

        **[override virtual protected] void
        QSizeGrip::mouseReleaseEvent(QMouseEvent * mouseEvent )**

        Reimplements: **QWidget::mouseReleaseEvent** (QMouseEvent *event).
        """
        ...

    def moveEvent(self, moveEvent: PySide2.QtGui.QMoveEvent) -> None:
        """
        https://doc.qt.io/qt-5/qsizegrip.html#moveEvent

        **[override virtual protected] void QSizeGrip::moveEvent(QMoveEvent *
        moveEvent )**

        Reimplements: **QWidget::moveEvent** (QMoveEvent *event).
        """
        ...

    def paintEvent(self, arg__1: PySide2.QtGui.QPaintEvent) -> None:
        """
        https://doc.qt.io/qt-5/qsizegrip.html#paintEvent

        **[override virtual protected] void QSizeGrip::paintEvent(QPaintEvent *
        event )**

        Reimplements: **QWidget::paintEvent** (QPaintEvent *event).

        Paints the resize grip.

        Resize grips are usually rendered as small diagonal textured lines in
        the lower-right corner. The paint event is passed in the **event**
        parameter.
        """
        ...

    def setVisible(self, arg__1: bool) -> None:
        """
        https://doc.qt.io/qt-5/qsizegrip.html#setVisible

        **[override virtual] void QSizeGrip::setVisible(bool visible )**

        Reimplements an access function for property: **QWidget::visible** .
        """
        ...

    def showEvent(self, showEvent: PySide2.QtGui.QShowEvent) -> None:
        """
        https://doc.qt.io/qt-5/qsizegrip.html#showEvent

        **[override virtual protected] void QSizeGrip::showEvent(QShowEvent *
        showEvent )**

        Reimplements: **QWidget::showEvent** (QShowEvent *event).
        """
        ...

    def sizeHint(self) -> PySide2.QtCore.QSize:
        """
        https://doc.qt.io/qt-5/qsizegrip.html#sizeHint

        **[override virtual] QSize QSizeGrip::sizeHint() const**

        Reimplements an access function for property: **QWidget::sizeHint** .
        """
        ...
