"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtWidgets, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets

bytes = str


class QStyleOptionFrame(PySide2.QtWidgets.QStyleOption):
    """
    https://doc.qt.io/qt-5/qstyleoptionframe.html

    **Detailed Description**

    QStyleOptionFrame is used for drawing several built-in Qt widgets, including
    **QFrame** , **QGroupBox** , **QLineEdit** , and **QMenu** .

    An instance of the QStyleOptionFrame class has **type**  **SO_Frame**  and
    **version**  3.

    The type is used internally by **QStyleOption** , its subclasses, and
    **qstyleoption_cast** () to determine the type of style option. In general
    you do not need to worry about this unless you want to create your own
    **QStyleOption**  subclass and your own styles. The version is used by
    **QStyleOption**  subclasses to implement extensions without breaking
    compatibility. If you use **qstyleoption_cast** (), you normally do not need
    to check it.

    For an example demonstrating how style options can be used, see the
    **Styles**  example.

    **See also** **QStyleOption** .
    """

    None_: QStyleOptionFrame = ...
    Flat: QStyleOptionFrame = ...
    Rounded: QStyleOptionFrame = ...
    Version: QStyleOptionFrame = ...
    Type: QStyleOptionFrame = ...

    class FrameFeature(object):
        None_: QStyleOptionFrame.FrameFeature = ...
        Flat: QStyleOptionFrame.FrameFeature = ...
        Rounded: QStyleOptionFrame.FrameFeature = ...

    class FrameFeatures(object):
        ...

    class StyleOptionType(object):
        Type: QStyleOptionFrame.StyleOptionType = ...

    class StyleOptionVersion(object):
        Version: QStyleOptionFrame.StyleOptionVersion = ...

    @typing.overload
    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-5/qstyleoptionframe.html#QStyleOptionFrame

        **QStyleOptionFrame::QStyleOptionFrame()**

        Constructs a QStyleOptionFrame, initializing the members variables to
        their default values.
        """
        ...

    @typing.overload
    def __init__(self, other: PySide2.QtWidgets.QStyleOptionFrame) -> None:
        """
        https://doc.qt.io/qt-5/qstyleoptionframe.html#QStyleOptionFrame-1

        **QStyleOptionFrame::QStyleOptionFrame(const QStyleOptionFrame & other
        )**

        Constructs a copy of the **other** style option.
        """
        ...

    @typing.overload
    def __init__(self, version: int) -> None:
        """
        https://doc.qt.io/qt-5/qstyleoptionframe.html#QStyleOptionFrame

        **QStyleOptionFrame::QStyleOptionFrame()**

        Constructs a QStyleOptionFrame, initializing the members variables to
        their default values.
        """
        ...
