"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtWidgets, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets

bytes = str


class QStyleOptionHeader(PySide2.QtWidgets.QStyleOption):
    """
    https://doc.qt.io/qt-5/qstyleoptionheader.html

    **Detailed Description**

    QStyleOptionHeader contains all the information that **QStyle**  functions
    need to draw the item views' header pane, header sort arrow, and header
    label.

    For performance reasons, the access to the member variables is direct (i.e.,
    using the `.` or `->` operator). This low-level feel makes the structures
    straightforward to use and emphasizes that these are simply parameters used
    by the style functions.

    For an example demonstrating how style options can be used, see the
    **Styles**  example.

    **See also** **QStyleOption** .
    """

    Beginning: QStyleOptionHeader = ...
    None_: QStyleOptionHeader = ...
    NotAdjacent: QStyleOptionHeader = ...
    Middle: QStyleOptionHeader = ...
    NextIsSelected: QStyleOptionHeader = ...
    SortUp: QStyleOptionHeader = ...
    Version: QStyleOptionHeader = ...
    End: QStyleOptionHeader = ...
    PreviousIsSelected: QStyleOptionHeader = ...
    SortDown: QStyleOptionHeader = ...
    NextAndPreviousAreSelected: QStyleOptionHeader = ...
    OnlyOneSection: QStyleOptionHeader = ...
    Type: QStyleOptionHeader = ...

    class SectionPosition(object):
        Beginning: QStyleOptionHeader.SectionPosition = ...
        Middle: QStyleOptionHeader.SectionPosition = ...
        End: QStyleOptionHeader.SectionPosition = ...
        OnlyOneSection: QStyleOptionHeader.SectionPosition = ...

    class SelectedPosition(object):
        NotAdjacent: QStyleOptionHeader.SelectedPosition = ...
        NextIsSelected: QStyleOptionHeader.SelectedPosition = ...
        PreviousIsSelected: QStyleOptionHeader.SelectedPosition = ...
        NextAndPreviousAreSelected: QStyleOptionHeader.SelectedPosition = ...

    class SortIndicator(object):
        None_: QStyleOptionHeader.SortIndicator = ...
        SortUp: QStyleOptionHeader.SortIndicator = ...
        SortDown: QStyleOptionHeader.SortIndicator = ...

    class StyleOptionType(object):
        Type: QStyleOptionHeader.StyleOptionType = ...

    class StyleOptionVersion(object):
        Version: QStyleOptionHeader.StyleOptionVersion = ...

    @typing.overload
    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-5/qstyleoptionheader.html#QStyleOptionHeader

        **QStyleOptionHeader::QStyleOptionHeader()**

        Constructs a QStyleOptionHeader, initializing the members variables to
        their default values.
        """
        ...

    @typing.overload
    def __init__(self, other: PySide2.QtWidgets.QStyleOptionHeader) -> None:
        """
        https://doc.qt.io/qt-5/qstyleoptionheader.html#QStyleOptionHeader-1

        **QStyleOptionHeader::QStyleOptionHeader(const QStyleOptionHeader &
        other )**

        Constructs a copy of the **other** style option.
        """
        ...

    @typing.overload
    def __init__(self, version: int) -> None:
        """
        https://doc.qt.io/qt-5/qstyleoptionheader.html#QStyleOptionHeader

        **QStyleOptionHeader::QStyleOptionHeader()**

        Constructs a QStyleOptionHeader, initializing the members variables to
        their default values.
        """
        ...
