"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtWidgets, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets

bytes = str


class QStyleOptionTabBarBase(PySide2.QtWidgets.QStyleOption):
    """
    https://doc.qt.io/qt-5/qstyleoptiontabbarbase.html

    **Detailed Description**

    QStyleOptionTabBarBase contains all the information that **QStyle**
    functions need to draw the tab bar base. Note that this is only drawn for a
    standalone **QTabBar**  (one that isn't part of a **QTabWidget** ).

    For performance reasons, the access to the member variables is direct (i.e.,
    using the `.` or `->` operator). This low-level feel makes the structures
    straightforward to use and emphasizes that these are simply parameters used
    by the style functions.

    For an example demonstrating how style options can be used, see the
    **Styles**  example.

    **See also** **QStyleOption**  and **QTabBar::drawBase** ().
    """

    Version: QStyleOptionTabBarBase = ...
    Type: QStyleOptionTabBarBase = ...

    class StyleOptionType(object):
        Type: QStyleOptionTabBarBase.StyleOptionType = ...

    class StyleOptionVersion(object):
        Version: QStyleOptionTabBarBase.StyleOptionVersion = ...

    @typing.overload
    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-5/qstyleoptiontabbarbase.html#QStyleOptionTabBarBas
        e

        **QStyleOptionTabBarBase::QStyleOptionTabBarBase()**

        Construct a QStyleOptionTabBarBase, initializing the members vaiables to
        their default values.
        """
        ...

    @typing.overload
    def __init__(self, other: PySide2.QtWidgets.QStyleOptionTabBarBase) -> None:
        """
        https://doc.qt.io/qt-5/qstyleoptiontabbarbase.html#QStyleOptionTabBarBas
        e-1

        **QStyleOptionTabBarBase::QStyleOptionTabBarBase(const
        QStyleOptionTabBarBase & other )**

        Constructs a copy of **other**.
        """
        ...

    @typing.overload
    def __init__(self, version: int) -> None:
        """
        https://doc.qt.io/qt-5/qstyleoptiontabbarbase.html#QStyleOptionTabBarBas
        e

        **QStyleOptionTabBarBase::QStyleOptionTabBarBase()**

        Construct a QStyleOptionTabBarBase, initializing the members vaiables to
        their default values.
        """
        ...
