"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtWidgets, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets

bytes = str


class QStyleOptionToolBox(PySide2.QtWidgets.QStyleOption):
    """
    https://doc.qt.io/qt-5/qstyleoptiontoolbox.html

    **Detailed Description**

    QStyleOptionToolBox contains all the information that **QStyle**  functions
    need to draw **QToolBox** .

    For performance reasons, the access to the member variables is direct (i.e.,
    using the `.` or `->` operator). This low-level feel makes the structures
    straightforward to use and emphasizes that these are simply parameters used
    by the style functions.

    For an example demonstrating how style options can be used, see the
    **Styles**  example.

    **See also** **QStyleOption**  and **QToolBox** .
    """

    Beginning: QStyleOptionToolBox = ...
    NotAdjacent: QStyleOptionToolBox = ...
    Middle: QStyleOptionToolBox = ...
    NextIsSelected: QStyleOptionToolBox = ...
    End: QStyleOptionToolBox = ...
    PreviousIsSelected: QStyleOptionToolBox = ...
    Version: QStyleOptionToolBox = ...
    OnlyOneTab: QStyleOptionToolBox = ...
    Type: QStyleOptionToolBox = ...

    class SelectedPosition(object):
        NotAdjacent: QStyleOptionToolBox.SelectedPosition = ...
        NextIsSelected: QStyleOptionToolBox.SelectedPosition = ...
        PreviousIsSelected: QStyleOptionToolBox.SelectedPosition = ...

    class StyleOptionType(object):
        Type: QStyleOptionToolBox.StyleOptionType = ...

    class StyleOptionVersion(object):
        Version: QStyleOptionToolBox.StyleOptionVersion = ...

    class TabPosition(object):
        Beginning: QStyleOptionToolBox.TabPosition = ...
        Middle: QStyleOptionToolBox.TabPosition = ...
        End: QStyleOptionToolBox.TabPosition = ...
        OnlyOneTab: QStyleOptionToolBox.TabPosition = ...

    @typing.overload
    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-5/qstyleoptiontoolbox.html#QStyleOptionToolBox

        **QStyleOptionToolBox::QStyleOptionToolBox()**

        Creates a QStyleOptionToolBox, initializing the members variables to
        their default values.
        """
        ...

    @typing.overload
    def __init__(self, other: PySide2.QtWidgets.QStyleOptionToolBox) -> None:
        """
        https://doc.qt.io/qt-5/qstyleoptiontoolbox.html#QStyleOptionToolBox-1

        **QStyleOptionToolBox::QStyleOptionToolBox(const QStyleOptionToolBox &
        other )**

        Constructs a copy of the **other** style option.
        """
        ...

    @typing.overload
    def __init__(self, version: int) -> None:
        """
        https://doc.qt.io/qt-5/qstyleoptiontoolbox.html#QStyleOptionToolBox

        **QStyleOptionToolBox::QStyleOptionToolBox()**

        Creates a QStyleOptionToolBox, initializing the members variables to
        their default values.
        """
        ...
