"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtWidgets, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets

bytes = str


class QStyleOptionViewItem(PySide2.QtWidgets.QStyleOption):
    """
    https://doc.qt.io/qt-5/qstyleoptionviewitem.html

    **Detailed Description**

    QStyleOptionViewItem contains all the information that **QStyle**  functions
    need to draw the items for Qt's model/view classes.

    For performance reasons, the access to the member variables is direct (i.e.,
    using the `.` or `->` operator). This low-level feel makes the structures
    straightforward to use and emphasizes that these are simply parameters used
    by the style functions.

    For an example demonstrating how style options can be used, see the
    **Styles**  example.

    **See also** **QStyleOption**  and **Model/View Programming** .
    """

    Invalid: QStyleOptionViewItem = ...
    Left: QStyleOptionViewItem = ...
    None_: QStyleOptionViewItem = ...
    Beginning: QStyleOptionViewItem = ...
    Right: QStyleOptionViewItem = ...
    WrapText: QStyleOptionViewItem = ...
    Alternate: QStyleOptionViewItem = ...
    Middle: QStyleOptionViewItem = ...
    Top: QStyleOptionViewItem = ...
    Bottom: QStyleOptionViewItem = ...
    End: QStyleOptionViewItem = ...
    HasCheckIndicator: QStyleOptionViewItem = ...
    OnlyOne: QStyleOptionViewItem = ...
    Version: QStyleOptionViewItem = ...
    HasDisplay: QStyleOptionViewItem = ...
    Type: QStyleOptionViewItem = ...
    HasDecoration: QStyleOptionViewItem = ...

    class Position(object):
        Left: QStyleOptionViewItem.Position = ...
        Right: QStyleOptionViewItem.Position = ...
        Top: QStyleOptionViewItem.Position = ...
        Bottom: QStyleOptionViewItem.Position = ...

    class StyleOptionType(object):
        Type: QStyleOptionViewItem.StyleOptionType = ...

    class StyleOptionVersion(object):
        Version: QStyleOptionViewItem.StyleOptionVersion = ...

    class ViewItemFeature(object):
        None_: QStyleOptionViewItem.ViewItemFeature = ...
        WrapText: QStyleOptionViewItem.ViewItemFeature = ...
        Alternate: QStyleOptionViewItem.ViewItemFeature = ...
        HasCheckIndicator: QStyleOptionViewItem.ViewItemFeature = ...
        HasDisplay: QStyleOptionViewItem.ViewItemFeature = ...
        HasDecoration: QStyleOptionViewItem.ViewItemFeature = ...

    class ViewItemFeatures(object):
        ...

    class ViewItemPosition(object):
        Invalid: QStyleOptionViewItem.ViewItemPosition = ...
        Beginning: QStyleOptionViewItem.ViewItemPosition = ...
        Middle: QStyleOptionViewItem.ViewItemPosition = ...
        End: QStyleOptionViewItem.ViewItemPosition = ...
        OnlyOne: QStyleOptionViewItem.ViewItemPosition = ...

    @typing.overload
    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-5/qstyleoptionviewitem.html#QStyleOptionViewItem

        **QStyleOptionViewItem::QStyleOptionViewItem()**

        Constructs a QStyleOptionViewItem, initializing the members variables to
        their default values.
        """
        ...

    @typing.overload
    def __init__(self, other: PySide2.QtWidgets.QStyleOptionViewItem) -> None:
        """
        https://doc.qt.io/qt-5/qstyleoptionviewitem.html#QStyleOptionViewItem-1

        **QStyleOptionViewItem::QStyleOptionViewItem(const QStyleOptionViewItem
        & other )**

        Constructs a copy of the **other** style option.
        """
        ...

    @typing.overload
    def __init__(self, version: int) -> None:
        """
        https://doc.qt.io/qt-5/qstyleoptionviewitem.html#QStyleOptionViewItem

        **QStyleOptionViewItem::QStyleOptionViewItem()**

        Constructs a QStyleOptionViewItem, initializing the members variables to
        their default values.
        """
        ...

    @staticmethod
    def __copy__() -> None:
        ...
