"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
"""
This file contains the exact signatures for all functions in module
PySide2.QtWinExtras, except for defaults which are replaced by "...".
"""
import PySide2
import typing
import PySide2.QtCore
import PySide2.QtGui
import PySide2.QtWidgets
import PySide2.QtWinExtras

bytes = str


class QWinJumpListItem(object):
    """
    https://doc.qt.io/qt-5/qwinjumplistitem.html

    **Detailed Description**
    """

    Destination: QWinJumpListItem = ...
    Link: QWinJumpListItem = ...
    Separator: QWinJumpListItem = ...

    class Type(object):
        Destination: QWinJumpListItem.Type = ...
        Link: QWinJumpListItem.Type = ...
        Separator: QWinJumpListItem.Type = ...

    def __init__(self, type: PySide2.QtWinExtras.QWinJumpListItem.Type) -> None:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#QWinJumpListItem

        **QWinJumpListItem::QWinJumpListItem(QWinJumpListItem::Type type )**

        Constructs a QWinJumpListItem with the specified **type**.
        """
        ...

    def arguments(self) -> typing.List:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#arguments

        **QStringList QWinJumpListItem::arguments() const**

        Returns the command-line arguments of this item.

        **See also** **setArguments** ().
        """
        ...

    def description(self) -> str:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#description

        **QString QWinJumpListItem::description() const**

        Returns the description of this item.

        **See also** **setDescription** ().
        """
        ...

    def filePath(self) -> str:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#filePath

        **QString QWinJumpListItem::filePath() const**

        Returns the file path set by **setFilePath** ().

        **See also** **setFilePath** ().
        """
        ...

    def icon(self) -> PySide2.QtGui.QIcon:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#icon

        **QIcon QWinJumpListItem::icon() const**

        Returns the icon set for this item.

        **See also** **setIcon** ().
        """
        ...

    def setArguments(self, arguments: typing.Sequence) -> None:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#setArguments

        **void QWinJumpListItem::setArguments(const QStringList & arguments )**

        Sets command-line **arguments** for this item.

        This value is used only if the type of this item is
        **QWinJumpListItem::Link** .

        **See also** **arguments** () and **setFilePath** ().
        """
        ...

    def setDescription(self, description: str) -> None:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#setDescription

        **void QWinJumpListItem::setDescription(const QString & description )**

        Sets a **description** for this item.

        This value is used only if the type of this item is
        **QWinJumpListItem::Link** .

        **See also** **description** ().
        """
        ...

    def setFilePath(self, filePath: str) -> None:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#setFilePath

        **void QWinJumpListItem::setFilePath(const QString & filePath )**

        Sets the item **filePath** , the meaning of which depends on the type of
        this item:

        * If the item type is **QWinJumpListItem::Destination** , **filePath**
        is the path to a file that can be opened by an application.
          * If the
        item type is **QWinJumpListItem::Link** , **filePath** is the path to an
        executable that is executed when this item is clicked by the user.

        **See also** **filePath** (), **setWorkingDirectory** (), and
        **setArguments** ().
        """
        ...

    def setIcon(self, icon: PySide2.QtGui.QIcon) -> None:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#setIcon

        **void QWinJumpListItem::setIcon(const QIcon & icon )**

        Sets the **icon** of this item.

        This value is used only if the type of this item is
        **QWinJumpListItem::Link** .

        **See also** **icon** ().
        """
        ...

    def setTitle(self, title: str) -> None:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#setTitle

        **void QWinJumpListItem::setTitle(const QString & title )**

        Sets the **title** of this item.

        This value is used only if the type of this item is
        **QWinJumpListItem::Link** .

        **See also** **title** ().
        """
        ...

    def setType(self, type: PySide2.QtWinExtras.QWinJumpListItem.Type) -> None:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#setType

        **void QWinJumpListItem::setType(QWinJumpListItem::Type type )**

        Sets the item **type**.

        **See also** **type** ().
        """
        ...

    def setWorkingDirectory(self, workingDirectory: str) -> None:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#setWorkingDirectory

        **void QWinJumpListItem::setWorkingDirectory(const QString &
        workingDirectory )**

        Sets the path to the working directory of this item to
        **workingDirectory**.

        This value is used only if the type of this item is
        **QWinJumpListItem::Link** .

        **See also** **workingDirectory** () and **setFilePath** ().
        """
        ...

    def title(self) -> str:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#title

        **QString QWinJumpListItem::title() const**

        Returns the title of this item.

        **See also** **setTitle** ().
        """
        ...

    def type(self) -> PySide2.QtWinExtras.QWinJumpListItem.Type:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#type

        **QWinJumpListItem::Type QWinJumpListItem::type() const**

        Returns the item type.

        **See also** **setType** ().
        """
        ...

    def workingDirectory(self) -> str:
        """
        https://doc.qt.io/qt-5/qwinjumplistitem.html#workingDirectory

        **QString QWinJumpListItem::workingDirectory() const**

        Returns the working directory path.

        **See also** **setWorkingDirectory** ().
        """
        ...
